% Display analysis linear spline function

% this is how rectangle looks in Fourier domain
%s=[ones(1,64) 0.5 zeros(1,127) 0.5 ones(1,63)] ;
%f=fft(s) ;
%subplot(211) ; plot(real(f)) ;
%subplot(212) ; plot(imag(f)) ;


%% Calculate spline of degree 3 in Fourier domain and show it
%
%subplot(511) ;
%[x,t]=fourtotime('(o>0)*sin(o/2)^4/(o/2+(o==0))^4+(o==0)*1',2) ;
%plot(t(300:700),x(300:700)) ; grid on ; zoom on; 
%title('B3') ;

% Calculate spline of degree 7 in Fourier domain and show it
figure(1) ;
subplot(511) ;
[x,t]=fourtotime('(o>0)*sin(o/2)^8/(o/2+(o==0))^8+(o==0)*1',4) ;
plot(t(300:700),x(300:700)) ; grid on ; zoom on; 
title('B7') ;

% to calculate values at integer points
h=interp1(t,x,[-4 -3 -2 -1 0 1 2 3 4]) ;


% orthogonalize B7 and show
subplot(512) ;
pr=50 ; % precision
denom=[ num2str(h(1),pr) '*exp(j*o*(-4))+'...
        num2str(h(2),pr) '*exp(j*o*(-3))+'...
        num2str(h(3),pr) '*exp(j*o*(-2))+'...
        num2str(h(4),pr) '*exp(-j*o)+'...
        num2str(h(5),pr) '+'...
        num2str(h(6),pr) '*exp(j*o)+'...
        num2str(h(7),pr) '*exp(j*o*2)+'...
        num2str(h(8),pr) '*exp(j*o*3)+'...
        num2str(h(9),pr) '*exp(j*o*4)' ] ;
fb7o=['(sin(o/2)+(o==0))^8/(o/2+(o==0))^8/(' denom ')'] ;
% The function is not exact. To increase precision, increase the support
% parameter and T in fourtotime.m
[x,t]=fourtotime(fb7o,8) ;
plot(t(400:600),x(400:600)) ; grid on ; zoom on; 
% plot(t,x) ; grid on ; zoom on; 
title('orto B7') ;

% to calculate values at integer points
intb7o=interp1(t,x,[-4 -3 -2 -1 0 1 2 3 4]) ;

% Calculate first derivative of the orthogonalized B7
subplot(513) ;
[x,t]=fourtotime(['(j*o)*' fb7o],4) ;
plot(t(300:700),x(300:700)) ; grid on ; zoom on; 
title('first derivative') ;

% to calculate values at integer points
intb7o1=interp1(t,x,[-4 -3 -2 -1 0 1 2 3 4])

% Calculate second derivative of the orthogonalized B7
subplot(514) ;
[x,t]=fourtotime(['-(o^2)*' fb7o],4) ;
plot(t(300:700),x(300:700)) ; grid on ; zoom on; 
title('second derivative') ;

% to calculate values at integer points
intb7o2=interp1(t,x,[-4 -3 -2 -1 0 1 2 3 4])

% Calculate third derivative of the orthogonalized B7
subplot(515) ;
[x,t]=fourtotime(['-j*o^3*' fb7o],4) ;
plot(t(300:700),x(300:700)) ; grid on ; zoom on; 
title('third derivative') ;
intb7o3=interp1(t,x,[-4 -3 -2 -1 0 1 2 3 4])

% Show the analysis function B3~
[x,t]=fourtotime(['sin(o/2)^4/(o/2+(o==0))^4/(' denom ')'],8,1024) ;
figure(2) ;
subplot(111) ;
plot(t,x) ; grid on ; zoom on
intb3a=interp1(t,x,-20:20)


