function s=epiforw(g,o1,o2,t1)
%
%
% Usage: s=epiforw(g,o1,o2,t1)

% The number of sweeps
N=floor((2*pi)/o2)+1 ;
ofs=-pi ;

% The last t
T=t1*N ;
s=zeros(1,T) ;

[ny,nx]=size(g) ;

for r=1:N, % run number
  for rr=0:t1-1,
    t=(r-1)*t1+rr+1  ;
    if mod(r,2)==1, % odd run 
      ox=2*pi/t1*rr ;
    else % even run
      ox=2*pi/t1*(t1-1-rr) ;
    end ;
    ox=ox+ofs ;
    oy=(r-1)*o2+o1*rr/t1+ofs ;
    for k=1:nx,
      for l=1:ny,
	s(t)=s(t)+g(l,k)*exp(-i*(ox*k+oy*l)) ;
      end ;
    end ;
    
  end ;
end ;

  