function img=freqtospace(w, ny,nx, hs, vs,ofs )
% Transform frequency domain signal to image, as in EPI, using horizontal and
% vertical shifts hs, vs, alternate scanning.
%
% Usage: img=freqtospace(w, ny,nx, hs, vs,ofs )


fr=abs(fft(w)) ;
nf=length(fr) ;

img=zeros(ny,nx) ;

for i=1:ny,
  for j=1:nx,
    img(i,j)=fr(ofs+(j-1)*hs+vs*(i-1)) ;
  end ;
end ;

for i=2:2:ny,
  img(i,:)=img(i,nx:-1:1) ;
end ;



