function c=imqbanal(z) ;
% Take each row of a 2D picture z and find proper interpolating quadratic
% B-spline coefficients.

[ny nx]=size(z) ;
c=zeros(ny,nx) ;

if nx>10,
  for i=1:ny,
    c(i,:)=fspline(z(i,:),2) ;
  end ;
else
  for i=1:ny,
    c(i,:)=qbanal(z(i,:)) ;
  end ;
end ;  


