% Test the scale invariance of landmark warping

x=[ 1 2 ; 2 1 ; 3 3 ; 2 2 ; 3 2 ] ;
z=[ 1 ; 2 ; 3; 2 ; 1 ] ;
c=lndunicoef(x,z)
t=1:0.1:3 ; N=length(t) ;
y1=t ;
for i=1:N,
    y1(i)=lndunieval([ t(i) 2],x,c) ;
end ;

alpha=10 ;
c2=lndunicoef(alpha*x,z) 
y2=t ;
for i=1:N,
    y2(i)=lndunieval(alpha*[ t(i) 2],alpha*x,c2) ;
end ;

alpha=0.5 ;
c3=lndunicoef(alpha*x,z) 
y3=t ;
for i=1:N,
    y3(i)=lndunieval(alpha*[ t(i) 2],alpha*x,c3) ;
end ;

plot(t,y1,t,y3,t,y2) ;



