function w=lnduniimgmex(img,x,z) ;
% Warp image using horizontal displacement z at points x,
% interpolating inbetween. Accelerated version of lnduniimg
%
% Usage: w=lnduniimgmex(img,x,z) ;

[ny,nx]=size(img) ;
% disp('Calculating coefficients') ;
c=lndunicoef(x,z-x(:,1)) ;
% disp('Bspline transform') ;
f=imcbanal(img) ;
% disp('Warping') ;
w=mexlnduniimgwarp(f,x,c) ;
% disp('Finished') ;
