static char mc_version[] = "MATLAB Compiler 1.2 Jan 17 1998 infun";
/*
 *  MATLAB Compiler: 1.2
 *  Date: Jan 17 1998
 *  Arguments: -e t 
 */

#ifdef __cplusplus
extern "C" {
#endif

#ifndef ARRAY_ACCESS_INLINING
#error You must use the -inline option when compiling MATLAB compiler generated code with MEX or MBUILD
#endif
#ifndef MATLAB_COMPILER_GENERATED_CODE
#define MATLAB_COMPILER_GENERATED_CODE
#endif

#include <math.h>
#include "matrix.h"
#include "mcc.h"
#include "matlab.h"

/***************** Compiler Assumptions ****************
 *
 *       I0_         	integer scalar temporary
 *       i           	integer scalar
 *       j           	real scalar
 *       mlfT        	<function being defined>
 *       x           	complex vector/matrix
 *******************************************************/

mxArray *
mlfT(mxArray *x_rhs_)
{
   int ci_;
   int i_;
   int nlhs_=1, nrhs_=0;
   mxArray *j_lhs_;
   mlfInitFcn();
   ci_ = 0;
   if (x_rhs_)
   {
      ++nrhs_;
      ci_ = ci_ || mccPI(x_rhs_);
   }
   if (ci_)
   {
      double j = 0.0;
      mxArray x;
      int i = 0;
      int I0_ = 0;
      
      mccComplexInit(x);
      mccImport(&x, x_rhs_, 0, 0);
      
      /* j=1; */
      j = 1;
      /* for i=2:x, */
      if(mccNOTSET(&x))
      {
         mexErrMsgTxt( "variable x undefined, line 3" );
      }
      for (I0_ = 2; I0_ <= *mccPR(&x); I0_ = I0_ + 1)
      {
         i = I0_;
         /* j=j*i ; */
         j = (j * (double) i);
         /* end ; */
      }
      
      mccReturnScalar(&j_lhs_, j, 0., mccREAL, 0);
      mlfCleanupOutputArray( j_lhs_ );
      mccFreeMatrix(&x);
      mlfCleanupFcn();
      return(j_lhs_);
   }
   else
   {
/***************** Compiler Assumptions ****************
 *
 *       I0_         	integer scalar temporary
 *       i           	integer scalar
 *       j           	real scalar
 *       mlfT        	<function being defined>
 *       x           	real vector/matrix
 *******************************************************/
      double j = 0.0;
      mxArray x;
      int i = 0;
      int I0_ = 0;
      
      mccRealInit(x);
      mccImport(&x, x_rhs_, 0, 0);
      
      /* j=1; */
      j = 1;
      /* for i=2:x, */
      if(mccNOTSET(&x))
      {
         mexErrMsgTxt( "variable x undefined, line 3" );
      }
      for (I0_ = 2; I0_ <= mccGetRealVectorElement(&x, 1); I0_ = I0_ + 1)
      {
         i = I0_;
         /* j=j*i ; */
         j = (j * (double) i);
         /* end ; */
      }
      
      mccReturnScalar(&j_lhs_, j, 0., mccREAL, 0);
      mlfCleanupOutputArray( j_lhs_ );
      mccFreeMatrix(&x);
      mlfCleanupFcn();
      return(j_lhs_);
   }
}

#ifdef __cplusplus
}
#endif

