% verify that degrees 1,2 of image interpolation work as well

i=16 ;
anat=getanatim(i) ;
anatp=pyramid2(anat,2) ; anat=anatp{3} ;
[ny,nx]=size(anat) ;
ww=genrandsptrans(5,5,ny,nx,0.01) ;
% ww=genrandafftrans(ny,nx,2) ;
wref=zeros(ny,nx) ;
for i=1:ny, wref(i,:)=(1:nx) ; end ;

wanat=imwarptable(anat,ww,'*linear') ;
mask=wanat>0.10 ;
mask=double(bwmorph(mask,'open',10)) ;
degree=2 ; order=3 ; nc=5 ; lambda=0 ;
s=spwstruct ; s(1)=order ; s(2)=nc ; s(3)=nc ; s(11)=1 ; 
s(19)=degree ; s(4)=0 ; s(7)=0 ; s(14)=1e-5 ; s(15)=1e-50 ;
if degree==3, s(18)=1 ; else s(18)=2 ; end ;
% s(18)=1 ; % ML
s(4)=1 ; s(8)=lambda ;
c=spwfind(wanat,anat,s) ;
xs=splnwarp21o(reshape(c,1,nc*nc),nc,nx,ny,order) ;
mdif=(xs-ww).*double(mask) ;
wi=sum(sum(abs(mdif)))/sum(sum(mask)) 
ranat=imwarptable(anat,xs,'*linear') ;
figure(1)
subplot(221) ; title('Warped') ; imagesc(ranat) ; pause(0.01) ;
subplot(222) ; title('Dif. after') ; imagesc(ranat-wanat) ; pause(0.01) ;
subplot(223) ; title('Def. dif.') ; imagesc(mdif) ; pause(0.01) ;
colorbar ;
Ea=sum(sum((ranat-wanat).^2.*mask)) 
figure(2)
subplot(221) ; dispimgwithedges(wanat,anat,2) ; title('orig')
subplot(222) ; dispimgwithedges(wanat,ranat,2) ; title('linear')
% subplot(223) ; dispimgwithedges(wanat,ranat3,2) ; title('cubic')
subplot(223) ; imagesc(anat) ; 
subplot(224) ; imagesc(wanat) ;
