% Evaluate optimal warping index for the manual registration

load ../acmpman/aimgs

N=10 ; 
wis=zeros(1,N) ;
fmri=normalize(fmri) ;

xr=zeros(128) ;
for i=1:128,
  xr(:,i)=ones(128,1)*i ;
end ;

[X,Y]=meshgrid(1:512,1:512) ;                                           
[X1,Y1]=meshgrid(1:4:512,1:4:512) ;

nc=13 ; nd=13 ;  

for i=1:N,
  wanat=normalize(wanats(:,:,i)) ;
  mask=wanat>0.2 ;
  mask=double(bwmorph(mask,'erode',1)) ;
  ww=wws(:,:,i) ;
  cid=cubicprojdd(ww,nc,nd) ;
  xws=splnwarp21(reshape(cid,1,nc*nd),nc,128,128) ;
  mdif=(xws-ww).*double(mask) ;
  wi=sum(sum(abs(mdif)))/sum(sum(mask)) 
  wis(i)=wi ;  
   ima=imwarptable(fmri,xws) ;
    Eopt=sum(sum((ima-fmri).^2)) 
end ;

mean(wis)