function ww=genrandafftrans(nx,ny,amp) ;
%
% Generate an arbitrary linear 2D->1D transformation 
%
% Usage: ww=genrandafftrans(nc,nd,nx,ny,amp) ;

% first the coordinates

shift=amp*randn(2)+ [ 1 nx ; 1 nx] ;

ww=zeros(ny,nx) ;

for i=1:ny,
  alpha=(i-1)/(ny-1) ;
  lrshift=shift(1,:)*alpha+shift(2,:)*(1-alpha) ;
  step=(lrshift(2)-lrshift(1))/(nx-1) ;
  ww(i,:)=lrshift(1):step:lrshift(2) ;
end ;




