function lndmrks=joinawwlnd ;
% Joins together results from the landmark warping of 
% artificial wavelet warped EPI images
% To be called from ~/matlab/medim99
% Returns an array - one row per submit ... i lng reshape(lnd,1,lng*2) 
%
% Usage: lndmrks=joinawwlnd


d=dir('awwimgs') ;
cd awwimgs
len=size(d,1) ;
maxlng=0 ; num=0 ;
for j=1:len,
  nam=d(j).name ;
  if strncmp(nam,'awwresult',9),
    num=num+1 ;
    s=load(nam) ; lnd=s.lnd ; 
    lng=size(lnd,1) ;
    maxlng=max(lng,maxlng) ;
  end ;
end ;

lndmrks=zeros(num,2+maxlng*2) ;

ind=1 ;
for j=1:len,
  nam=d(j).name ;
  if strncmp(nam,'awwresult',9),
    s=load(nam) ; lnd=s.lnd ; i=s.i ;
    lng=size(lnd,1) ;
    lndmrks(ind,1:(2+lng*2))=[ i lng reshape(lnd,1,2*lng) ] ;
    ind=ind+1 ;
  end ;
end ;

cd ..