% Automaticaly register image pairs in awwimgs
% maybe we should increase precision here?

for i=0:29,
  s=spwstruct ; s(11)=1 ; % 7 x 7 knots, some printing
  disp([ 'Warping set ' num2str(i+1) ]) ;
  anat=normalize(imread([ 'awwimgs/awwref' num2str(i+1,'%03d') '.tiff'])) ;
  epi=normalize(imread([ 'awwimgs/awwtest' num2str(i+1,'%03d') '.tiff'])) ;
  subplot(231) ; imagesc(anat) ; colormap(gray) ; title('Anatomical') ;
  subplot(232) ; imagesc(epi) ; colormap(gray) ; title('EPI') ;
  d=0.5+(anat-imhisteq(anat,epi))/2 ;
  subplot(233) ; imagesc(d) ; colormap(gray) ; title('Difference before') ;
  pause(0.001) ;
  [c,E]=spwfind(anat,epi,s) ;
  epib=imcbanal(epi) ;
  nr=size(epi,2) ;
  nc=s(2) ; nd=s(3) ;
  epiw=meximwarp(epib,reshape(c,1,nc*nd),nr,nc,s(1)) ;
  subplot(234) ; imagesc(epiw) ; colormap(gray) ; title('Warped') ;
  d=0.5+(anat-imhisteq(anat,epiw))/2 ;
  subplot(235) ; imagesc(d) ; colormap(gray) ; title('Difference after') ;
  name=[ 'awwimgs/awwautwarpc' num2str(i+1,'%03d')] ;
  save(name,'c') ;
  pause(0.001) ;
end ;