% Test the projection

N=128 ;
ctrue=[1 1 1 1 1 3 4 3 1 1 1 1 1] 
% ctrue=[0 0 1 0 0 0] 
nc=length(ctrue) ;
step=(N-1)/(nc-3) ;
t=1:128 ;
mt=(t-1)/step+2 ;
ytrue=mcbinterp(ctrue,mt) ;
ymeas=ytrue+randn(1,N)*0.3 ;
c=cubicproject(ymeas,nc) 
y=mcbinterp(c,mt) ;

plot(t,ytrue,'-',t,ymeas,'r*',t,y,'g-') ; grid on ; zoom on ;
legend('true','measured','interpolated') ;