% Demonstrates various interpolating methods

figure(1) ;
o=10 ;
N=80 ; N1=N/2 ;
x=zeros(N,N) ;
for i=1:N, x(N/4,i)=1 ; end ;
for i=1:N, x(N/4-2,i)=1 ; end ;
for i=1:N, x(N/4-4,i)=1 ; end ;
for i=1:N, x(N/4-6,i)=1 ; end ;
for i=1:N, x(N/4-8,i)=1 ; end ;
for i=1:N, x(N/4-10,i)=1 ; end ;

for i=0:0.05:2*pi, 
 x(round(N1+N1/2*sin(i)),round(N1+N1/2*cos(i)))=1 ; 
 x(round(N1+(N1/2-2)*sin(i)),round(N1+(N1/2-2)*cos(i)))=1 ; 
 x(round(N1+(N1/2-4)*sin(i)),round(N1+(N1/2-4)*cos(i)))=1 ; 
 x(round(N1+(N1/2-6)*sin(i)),round(N1+(N1/2-6)*cos(i)))=1 ; 
 x(round(N1+(N1/2-8)*sin(i)),round(N1+(N1/2-8)*cos(i)))=1 ; 
 x(round(N1+(N1/2-10)*sin(i)),round(N1+(N1/2-10)*cos(i)))=1 ; 
 x(round(N1+(N1/2-12)*sin(i)),round(N1+(N1/2-12)*cos(i)))=1 ; 
 x(round(N1+(N1/2-14)*sin(i)),round(N1+(N1/2-14)*cos(i)))=1 ; 
end ;

x=1-x ;
image(64*x(1+o:N-o,1+o:N-o)) ; colormap(gray) ;
axis off ; axis equal
print -deps /home/jkybic/tex/spregslds/interporig.eps

wx=x ; wy=x ;
ang=0.2 ;
A=[ cos(ang) sin(ang) ; -sin(ang)  cos(ang) ] ;
for i=1:N, for j=1:N,
    tr=A*([i ; j]-(1+N)/2)+(1+N)/2 ;
    wx(j,i)=tr(1) ; wy(j,i)=tr(2) ;
  end ;
end ;

figure(2) ;
y=imwarp2table(x,wx,wy,'nearest') ;
image(64*y(1+o:N-o,1+o:N-o)) ; colormap(gray) ;
axis off ; axis equal
print -deps /home/jkybic/tex/spregslds/interpnearest.eps

figure(3) ;
y=imwarp2table(x,wx,wy,'linear') ;
image(64*y(1+o:N-o,1+o:N-o)) ; colormap(gray) ;
axis off ; axis equal
print -deps /home/jkybic/tex/spregslds/interplin.eps

figure(4) ;
y=imwarp2table(x,wx,wy,'myspline') ;
image(64*y(1+o:N-o,1+o:N-o)) ; colormap(gray) ;
axis off ; axis equal
print -deps /home/jkybic/tex/spregslds/interpspln.eps

  