% Shows prefiltering

anatpref='/home/jkybic/nirkko/ev-KYBIC-Jan_N2-S_446-052/7651-4-' ;
anatofs=66 ;
epipref='/home/jkybic/nirkko/ev-KYBIC-J_MotLI/Ev7652-mean0-' ;
epiofs=1 ;
affix='.ima' ;
epsprefix='results/nir-ky-4-mean0-' ;

figure(1) ; 
cmsf=size(colormap,1) ;
i=15 ;

figure(1) ; colormap(gray) ;

  anatname=[ anatpref num2str(i+anatofs) affix ] ;
  epiname=[ epipref num2str(i+epiofs,'%03d') affix ] ;
  anat=loadima(anatname) ; 
  anatp=pyramid2(anat,1) ; anat=anatp{2} ; 
  epi=loadima(epiname) ; 

  image(cmsf*anat') ; colormap(gray.^0.5) ;
  axis image ; axis off
  print -depsc /home/jkybic/tex/thespres/demofiltanat.eps
  figure(2) ;
  image(cmsf*epi') ; axis image ; axis off ; colormap(gray.^0.5) ;
    print -depsc /home/jkybic/tex/thespres/demofiltepi.eps
  filtsize=20 ;
   frefim=imhpfilter(1/filtsize,anat) ;
  ftestim=imhpfilter(1/filtsize,epi) ;
  ftestim=imhisteq(frefim,ftestim) ;
  figure(3) ;
  image(cmsf*frefim') ; colormap(gray.^0.5) ;
  axis image ; axis off
  print -depsc /home/jkybic/tex/thespres/demofiltanatafter.eps

  figure(4) ;colormap(gray.^0.5) ;
  image(cmsf*ftestim') ; axis image ; axis off ;
  print -depsc /home/jkybic/tex/thespres/demofiltepiafter.eps
  
%    eval(['' num2str(i) ...
%	  '.eps']) ;

  