% Show some splines

figure(1) ;
c=[1 1 3 4 4 1 0 2] ;
t=2:0.1:5 ;
ti=2:5 ;
y=mcbinterp(c,t) ;
yi=mcbinterp(c,ti) ;
% set(gca,'Linewidth',5)
plot(t,y,'-',ti,yi,'o') ;
set(findobj('Type','line'),'LineWidth',5)
set(findobj('Type','line'),'MarkerSize',10)

axis off ;
print -depsc /home/jkybic/tex/spregslds/demospline.eps

figure(2) ;
t=-2:0.01:2 ;
y0=abs(t)<0.5 ;
for i=1:length(t),
  y1(i)=lbspln(t(i)) ;
  y2(i)=qbspln(t(i)) ;
  y3(i)=cbspln(t(i)) ;
end ;

plot(t,y0,t,y1,t,y2,t,y3) ;
set(findobj('Type','line'),'LineWidth',5)
grid on ;
print -depsc /home/jkybic/tex/spregslds/demobspline.eps


  