% Demonstrate warping

if 1,
figure(1) ;  
lena=imread('../images/lenahat.tiff') ;
lena=255*normalize(double(lena)) ;
imagesc(lena,[0 255]) ;
axis equal ; axis off ; whitebg('w') ;
print -depsc /home/jkybic/tex/imagesps/lenahat.eps
[ny,nx]=size(lena) ; colormap(pink) ;
end ;

%c=[0 0.1 0.8 0.9 0.95 1 ; 0 0.1 0.5 0.6 0.95 1 ; ...
%    0 0.1 0.4 0.5 0.6 0.7 ; 0 0.1 0.2 0.3 0.3 0.4 ] ;
%d=[0 0.1 0.8 0.9 0.95 1 ; 0 0.1 0.5 0.6 0.95 1 ; ...
%   0 0.1 0.4 0.5 0.6 0.7 ; 0 0.1 0.2 0.3 0.3 0.4 ] ;
  
c=[-1.6 -1.5 0.6 0.7 1 1.1;  -1 -0.5  0.6 0.8 1 1.1;  -1 0 0.5 0.8 1.2 2;  ...
   -1 0 0.5 0.8 1.2 2; -1 0 0.3 0.7 1 2 ; -1 0 0.3 0.7 1 2   ] ;
d=[-1 0 0.2 0.7 1 2;  -1 0 0.2 0.7 1 2;  -1 0 0.45 0.7 1.5 2.5;  ...
  -1 0 0.5 0.7 1.5 2 ;  -1 0 0.2 0.8 1 2 ; -1 0 0.7 0.8 1 2 ]' ;

%c=[-1 0 0.5 1 2;  -1 0 0.5 1 2;  -1 0 0.5 1 2;  ...
%  -1 0 0.5 1 2  ] ;
%d=[-1 0 1 2;  -1 0 1 2  ; -1 0 1 2 ; -1 0 1 2 ; -1 0 1 2 ]' ;

figure(2) ;
c=imcbanal(c) ; c=imcbanal(c')' ;
d=imcbanal(d) ; d=imcbanal(d')' ;
[nd,nc]=size(c) ;
c=reshape(c,1,nc*nd)*nx ;
d=reshape(d,1,nc*nd)*ny ;
l=imcbanal(lena) ;
l=imcbanal(l')' ;
ime=meximwarpdc(l,[c d],nc,nx,ny) ;
ime(find(abs(ime)==0))=255 ;
%ime=normalize(ime) ; 
imagesc(ime,[0 255]) ;axis equal ; axis off ; whitebg('w') ; colormap(pink) ;
print -depsc /home/jkybic/tex/imagesps/lenahatwarp.eps

% [wx,wy]=splnwarp22([c d],nc,nx,ny) ;
% disptablewf(wx,wy) ;

figure(3) ;
l=imcbanal(lena) ;
ime=meximwarp(l,c,nx,nc,3) ;
ime(find(abs(ime)==0))=255 ;
%ime=normalize(ime) ;

imagesc(ime,[0 255]) ;axis equal ; axis off ; whitebg('w') ;
print -depsc /home/jkybic/tex/imagesps/lenahatwarpu.eps

figure(4) ; clf ;
dispwf(c,nc,3) ;
print -depsc /home/jkybic/tex/imagesps/lenawf.eps
