% Demonstrate warping

if 1,
hilbert=imread('../images/hilbert.tiff') ;
hilbert=double(hilbert) ;
imagesc(hilbert) ;
axis equal ; axis off ; whitebg('w') ;
% print -depsc /home/jkybic/tex/images/hilberthat.eps
[ny,nx]=size(hilbert) ; colormap(gray) ;
end ;

%c=[0 0.1 0.8 0.9 0.95 1 ; 0 0.1 0.5 0.6 0.95 1 ; ...
%    0 0.1 0.4 0.5 0.6 0.7 ; 0 0.1 0.2 0.3 0.3 0.4 ] ;
%d=[0 0.1 0.8 0.9 0.95 1 ; 0 0.1 0.5 0.6 0.95 1 ; ...
%   0 0.1 0.4 0.5 0.6 0.7 ; 0 0.1 0.2 0.3 0.3 0.4 ] ;
  
c=[-1 0 0.5 1 2;...
   -1 -0.5 0.5 1 2;...
   -1 -0.5 0.5 1 2; ...
  -1 0 0.5 1.2 3;...
  -1 0 0.5 1 2;] ;
d=[-1 0 0.5 1 2;...
   -1 -0.2 0.5 1.5 2;...
   -1 -0.2 0.5 1 2; ...
  -1 -0.2 0.5 1.5 2;...
  -1 0 0.5 1 2;]' ;


%c=[-1 0 0.5 1 2;  -1 0 0.5 1 2;  -1 0 0.5 1 2;  ...
%  -1 0 0.5 1 2  ] ;
%d=[-1 0 1 2;  -1 0 1 2  ; -1 0 1 2 ; -1 0 1 2 ; -1 0 1 2 ]' ;

figure(1) ;
c=imcbanal(c) ; c=imcbanal(c')' ;
d=imcbanal(d) ; d=imcbanal(d')' ;
[nd,nc]=size(c) ;
c=reshape(c,1,nc*nd)*nx ;
d=reshape(d,1,nc*nd)*ny ;
l=imcbanal(hilbert) ;
l=imcbanal(l')' ;
ime=meximwarpdc(l,[c d],nc,nx,ny) ;
ime(find(abs(ime)==0))=255 ;
ime=normalize(ime) ; 
imagesc(ime) ;axis equal ; axis off ; whitebg('w') ; colormap(gray) ;
print -depsc /home/jkybic/tex/images/hilberthatwarp.eps
imwrite(ime,'hilbertwarp.tiff') ;

% [wx,wy]=splnwarp22([c d],nc,nx,ny) ;
% disptablewf(wx,wy) ;

% figure(2) ;
% l=imcbanal(hilbert) ;
% ime=meximwarp(l,c,nx,nc,3) ;
% ime(find(abs(ime)==0))=255 ;
% ime=normalize(ime) ;

% imagesc(ime) ;axis equal ; axis off ; whitebg('w') ; 
% print -depsc /home/jkybic/tex/images/hilberthatwarpu.eps

%figure(3) ; clf ;
%dispwf(c,nc,3) ;
%print -depsc /home/jkybic/tex/images/hilbertwf.eps
