static char mc_version[] = "MATLAB Compiler 1.2 Jan 17 1998 infun";
/*
 *  MATLAB Compiler: 1.2
 *  Date: Jan 17 1998
 *  Arguments: -ir imwarp2table 
 */
#ifndef ARRAY_ACCESS_INLINING
#error You must use the -inline option when compiling MATLAB compiler generated code with MEX or MBUILD
#endif
#ifndef MATLAB_COMPILER_GENERATED_CODE
#define MATLAB_COMPILER_GENERATED_CODE
#endif

#include <math.h>
#include "mex.h"
#include "mcc.h"

/* static array S0_ (1 x 8) text, line 11: 'myspline' */
static unsigned short S0__r_[] =
{
        109,  121,  115,  112,  108,  105,  110,  101,
};
static mxArray S0_ = mccCINIT( mccTEXT,  1, 8, S0__r_, 0);
/***************** Compiler Assumptions ****************
 *
 *       B0_         	boolean scalar temporary
 *       BM0_        	boolean vector/matrix temporary
 *       I0_         	integer scalar temporary
 *       I1_         	integer scalar temporary
 *       I2_         	integer scalar temporary
 *       I3_         	integer scalar temporary
 *       IM0_        	integer vector/matrix temporary
 *       IM1_        	integer vector/matrix temporary
 *       R0_         	real scalar temporary
 *       R1_         	real scalar temporary
 *       R2_         	real scalar temporary
 *       R3_         	real scalar temporary
 *       R4_         	real scalar temporary
 *       R5_         	real scalar temporary
 *       RM0_        	real vector/matrix temporary
 *       RM1_        	real vector/matrix temporary
 *       RM2_        	real vector/matrix temporary
 *       RM3_        	real vector/matrix temporary
 *       RM4_        	real vector/matrix temporary
 *       RM5_        	real vector/matrix temporary
 *       cbspln      	<function>
 *       find        	<function>
 *       floor       	<function>
 *       i           	integer scalar
 *       imcbanal    	<function>
 *       imwarp2table	<function being defined>
 *       ind         	integer vector/matrix
 *       interp2     	<function>
 *       isnan       	<function>
 *       j           	integer scalar
 *       k           	real scalar
 *       l           	real scalar
 *       max         	<function>
 *       method      	real vector/matrix
 *       min         	<function>
 *       nargin      	<function>
 *       nx          	integer scalar
 *       ny          	integer scalar
 *       rx          	real scalar
 *       ry          	real scalar
 *       size        	<function>
 *       strcmp      	<function>
 *       wx          	real vector/matrix
 *       wy          	real vector/matrix
 *       x           	real vector/matrix
 *       xs          	real scalar
 *       y           	real vector/matrix
 *       ys          	real scalar
 *       zeros       	<function>
 *******************************************************/

void
mexFunction(
    int nlhs_,
    mxArray *plhs_[],
    int nrhs_,
    const mxArray *prhs_[]
)
{
   mxArray *Mplhs_[2];
   mxArray *Mprhs_[6];
   

   if (nrhs_ > 4 )
   {
      mexErrMsgTxt( "Too many input arguments." );
   }

   if (nlhs_ > 1 )
   {
      mexErrMsgTxt( "Too many output arguments." );
   }

   {
      mxArray y;
      mxArray x;
      mxArray wx;
      mxArray wy;
      mxArray method;
      int ny = 0;
      int nx = 0;
      int i = 0;
      int j = 0;
      double xs = 0.0;
      double ys = 0.0;
      double rx = 0.0;
      double ry = 0.0;
      double k = 0.0;
      double l = 0.0;
      mxArray ind;
      int I0_ = 0;
      unsigned short B0_ = 0;
      mxArray RM0_;
      mxArray RM1_;
      mxArray RM2_;
      int I1_ = 0;
      int I2_ = 0;
      double R0_ = 0.0;
      double R1_ = 0.0;
      int I3_ = 0;
      mxArray RM3_;
      double R2_ = 0.0;
      mxArray RM4_;
      double R3_ = 0.0;
      mxArray RM5_;
      double R4_ = 0.0;
      double R5_ = 0.0;
      mxArray IM0_;
      mxArray IM1_;
      mxArray BM0_;
      
      mccRealInit(x);
      mccImportCopy(&x, ((nrhs_>0) ? prhs_[0] : 0), 0, 0);
      mccRealInit(wx);
      mccImport(&wx, ((nrhs_>1) ? prhs_[1] : 0), 0, 0);
      mccRealInit(wy);
      mccImport(&wy, ((nrhs_>2) ? prhs_[2] : 0), 0, 0);
      mccRealInit(method);
      mccImportCopy(&method, ((nrhs_>3) ? prhs_[3] : 0), 0, 0);
      mccRealInit(y);
      mccIntInit(ind);
      mccRealInit(RM0_);
      mccRealInit(RM1_);
      mccRealInit(RM2_);
      mccRealInit(RM3_);
      mccRealInit(RM4_);
      mccRealInit(RM5_);
      mccIntInit(IM0_);
      mccIntInit(IM1_);
      mccBoolInit(BM0_);
      
      /* % Takes an image x and a warping table wx in x, wy in y and */
      /* % computes destination image y */
      
      /* % Usage: y=imwarptable(x,wx,wy) */
      
      /* if nargin<4, method='spline' ; end ; */
      I0_ = mccNargin();
      B0_ = (I0_ < 4);
      if ((double)B0_)
      {
         mccCreateString(&method, "spline");
      }
      /* [ny,nx]=size(x) ; */
      if(mccNOTSET(&x))
      {
         mexErrMsgTxt( "variable x undefined, line 8" );
      }
      mccGetMatrixSize(&ny,&nx, &x);
      
      /* y=zeros(ny,nx) ; */
      mccZerosMN(&y, ny, nx);
      mccLOG(&y) = 0;
      mccSTRING(&y) = 0;
      /* if strcmp(method,'myspline'), */
      if(mccNOTSET(&method))
      {
         mexErrMsgTxt( "variable method undefined, line 11" );
      }
      if ((double)mccStrcmp(&method, &S0_))
      {
         /* x=imcbanal(imcbanal(x)' )' ; */
         Mprhs_[0] = &x;
         Mplhs_[0] = &RM0_;
         mccCallMATLAB(1, Mplhs_, 1, Mprhs_, "imcbanal", 12);
         mccConjTrans(&RM1_, &RM0_);
         Mprhs_[0] = &RM1_;
         Mplhs_[0] = &RM2_;
         mccCallMATLAB(1, Mplhs_, 1, Mprhs_, "imcbanal", 12);
         mccConjTrans(&x, &RM2_);
         /* for i=1:ny, */
         for (I0_ = 1; I0_ <= ny; I0_ = I0_ + 1)
         {
            i = I0_;
            /* for j=1:nx, */
            for (I1_ = 1; I1_ <= nx; I1_ = I1_ + 1)
            {
               j = I1_;
               /* xs=wx(i,j) ; ys=wy(i,j) ; */
               if(mccNOTSET(&wx))
               {
                  mexErrMsgTxt( "variable wx undefined, line 15" );
               }
               xs = (mccPR(&wx)[(j-1)*mccM(&wx) + (i-1)]);
               if(mccNOTSET(&wy))
               {
                  mexErrMsgTxt( "variable wy undefined, line 15" );
               }
               ys = (mccPR(&wy)[(j-1)*mccM(&wy) + (i-1)]);
               /* rx=floor(xs) ; ry=floor(ys) ; */
               rx = floor(xs);
               ry = floor(ys);
               /* y(i,j)=0 ; */
               mccPR(&y)[(i-1) + mccM(&y)*(j-1)] = 0;
               /* for k=max(rx-1,1):min(nx,rx+2), */
               Mprhs_[0] = mccTempMatrix((rx - 1), 0., mccREAL, 0 );
               Mprhs_[1] = mccTempMatrix(1, 0., mccINT, 0 );
               Mplhs_[0] = &RM2_;
               mccCallMATLAB(1, Mplhs_, 2, Mprhs_, "max", 18);
               R0_ = (mccPR(&RM2_)[(1-1)]);
               Mprhs_[0] = mccTempMatrix(nx, 0., mccINT, 0 );
               Mprhs_[1] = mccTempMatrix((rx + 2), 0., mccREAL, 0 );
               Mplhs_[0] = &RM1_;
               mccCallMATLAB(1, Mplhs_, 2, Mprhs_, "min", 18);
               R1_ = (mccPR(&RM1_)[(1-1)]);
               mccColon2(&RM0_, R0_, R1_);
               for (I2_ = 0; I2_ < mccN(&RM0_); ++I2_)
               {
                  k = mccPR(&RM0_)[I2_];
                  /* for l=max(ry-1,1):min(ry+2,ny), */
                  Mprhs_[0] = mccTempMatrix((ry - 1), 0., mccREAL, 0 );
                  Mprhs_[1] = mccTempMatrix(1, 0., mccINT, 0 );
                  Mplhs_[0] = &RM3_;
                  mccCallMATLAB(1, Mplhs_, 2, Mprhs_, "max", 19);
                  R2_ = (mccPR(&RM3_)[(1-1)]);
                  Mprhs_[0] = mccTempMatrix((ry + 2), 0., mccREAL, 0 );
                  Mprhs_[1] = mccTempMatrix(ny, 0., mccINT, 0 );
                  Mplhs_[0] = &RM4_;
                  mccCallMATLAB(1, Mplhs_, 2, Mprhs_, "min", 19);
                  R3_ = (mccPR(&RM4_)[(1-1)]);
                  mccColon2(&RM5_, R2_, R3_);
                  for (I3_ = 0; I3_ < mccN(&RM5_); ++I3_)
                  {
                     l = mccPR(&RM5_)[I3_];
                     /* y(i,j)=y(i,j)+x(l,k)*cbspln(xs-k)*cbspln(ys-l) ; */
                     Mprhs_[0] = mccTempMatrix((xs - k), 0., mccREAL, 0 );
                     Mplhs_[0] = 0;
                     mccCallMATLAB(1, Mplhs_, 1, Mprhs_, "cbspln", 20);
                     R4_ = mccImportReal(0, 0, Mplhs_[ 0 ], 1, " (imwarp2table, line 20): R4_");
                     Mprhs_[0] = mccTempMatrix((ys - l), 0., mccREAL, 0 );
                     Mplhs_[0] = 0;
                     mccCallMATLAB(1, Mplhs_, 1, Mprhs_, "cbspln", 20);
                     R5_ = mccImportReal(0, 0, Mplhs_[ 0 ], 1, " (imwarp2table, line 20): R5_");
                     mccPR(&y)[(i-1) + mccM(&y)*(j-1)] = ((mccPR(&y)[(j-1)*mccM(&y) + (i-1)]) + (((mccPR(&x)[((int)(k-.5))*mccM(&x) + ((int)(l-.5))]) * (double) R4_) * (double) R5_));
                     /* end ; */
                  }
                  /* end ; */
               }
               /* end ; */
            }
            /* end ; */
         }
      }
      else
      {
         /* else */
         
         
         /* y=interp2(1:nx,1:ny,x,wx,wy,method) ; */
         mccIntColon2(&IM0_, 1, nx);
         mccIntColon2(&IM1_, 1, ny);
         Mprhs_[0] = &IM0_;
         Mprhs_[1] = &IM1_;
         Mprhs_[2] = &x;
         Mprhs_[3] = &wx;
         Mprhs_[4] = &wy;
         Mprhs_[5] = &method;
         Mplhs_[0] = &y;
         mccCallMATLAB(1, Mplhs_, 6, Mprhs_, "interp2", 28);
         
         /* ind=find(isnan(y)) ; */
         Mprhs_[0] = &y;
         Mplhs_[0] = &BM0_;
         mccCallMATLAB(1, Mplhs_, 1, Mprhs_, "isnan", 30);
         mccFind(&ind, &BM0_);
         /* y(ind)=0 ; */
         mccFindIndex(&IM1_, &ind);
         {
            int i_, j_;
            int m_=1, n_=1, cx_ = 0;
            double *p_y;
            int *p_IM1_;
            int I_IM1_=1;
            m_ = mccCalcSubscriptDimensions(m_, &n_, mccM(&IM1_), mccN(&IM1_), &y);
            I_IM1_ = (mccM(&IM1_) != 1 || mccN(&IM1_) != 1);
            p_IM1_ = mccIPR(&IM1_);
            if (m_ != 0)
            {
               for (j_=0; j_<n_; ++j_)
               {
                  for (i_=0; i_<m_; ++i_, p_IM1_+=I_IM1_)
                  {
                     mccPR(&y)[((int)(((int)*p_IM1_)-.5))] = 0;
                  }
               }
            }
         }
         /* end ; */
      }
      mccReturnFirstValue(&plhs_[0], &y);
   }
   return;
}
