function out=pyramid2(orig,level)
%PYRAMID  produces a pyramid of the image 'orig' at 'level' level.
% IN: orig must be double.
% OUT: cell array of pyramid. 
%      Adress with: out{level}
%
%  sub_2 = subsampled
%  card_2 = prefiltered with bspline of order 3
%  dual_2 = none meaningful result
%
%  Author: Stefan Horbelt, 23.4.98

% sinsin
% tyre, tartan, facets, wifs, madrill, geometry, detail, detfinger

% modified by JK not to plot anything 

out=cell(level+1,1);
sub=orig;
down=orig;

% Original:
%%%%%%%%%%%%%%%%%%%%%%%%%

out{1}=orig;

% Going down
%%%%%%%%%%%%%%%%%%%%%%%%%%

for l=1:level
  sub=dyaddown(sub,'m',1);
  down=L2spyramid_down(down,3);
  card=spspace(down,3,'dual','card');
  out{l+1}=card;
end;
