
img=imread('../images/lenahat.tiff') ;
img=normalize(double(img)) ;
figure(1) ; subplot(221) ; imagesc(img) ; colormap(gray) ; axis image ; 

img=zeros(512,512) ;
ra=rand(1,300) ;
for k=1:512,
  for l=1:512,
%    img(k,l)=ra(1+floor(k/8)+8*floor(l/8)) ;
    img(k,l)=ra(1+floor(k/32)+16*floor(l/32)) ;
  end ;
end ;

[ny,nx]=size(img) ;

img1=img+0.1*randn(ny,nx) ;
img2=img+0.1*randn(ny,nx) ;

figure(1) ; subplot(231) ; imagesc(img) ; colormap(gray) ; axis image ; 
subplot(232) ;imagesc(img1) ; colormap(gray) ; axis image ; 
subplot(233) ;imagesc(img2) ; colormap(gray) ; axis image ; 

f1=fft2(img1) ; f2=fft2(img2) ;
subplot(234) ; imagesc(log(abs(fftshift(f1)))) ; colormap(gray) ; colorbar ;
subplot(234) ; imagesc(log(abs(fftshift(f2)))) ; colormap(gray) ; colorbar ;


hh=2*real(f1.*conj(f2))./(abs(f1).^2+abs(f2).^2) ;
subplot(234) ; imagesc(log(abs(fftshift(hh)))) ; colormap(gray) ; colorbar ;

h=abs(ifft2(hh)) ;
subplot(235) ; imagesc(fftshift(log(h))) ; colormap(gray) ; axis image ; colorbar ;

r1=abs(ifft2(hh.*f1)) ; 
subplot(236) ; imagesc(r1) ; axis image ;