function y=waveden(x) ;
% Perform 2D wavelet denoising of x
%
% Usage: function y=waveden(x) ;


[ny,nx]=size(x) ;

tmp=zeros(ny,nx) ;
y=zeros(ny,nx) ;
lev=5 ;

for i=1:ny,
  tmp(i,:)=wden(x(i,:),'heursure','s','mln',lev,'sym8');       
end ;

for i=1:nx,
  y(:,i)=wden(tmp(:,i),'heursure','s','mln',lev,'sym8');       
end ;

