static char mc_version[] = "MATLAB Compiler 1.2 Jan 17 1998 infun";
/*
 *  MATLAB Compiler: 1.2
 *  Date: Jan 17 1998
 *  Arguments: -v filfirs 
 */
#ifndef ARRAY_ACCESS_INLINING
#error You must use the -inline option when compiling MATLAB compiler generated code with MEX or MBUILD
#endif
#ifndef MATLAB_COMPILER_GENERATED_CODE
#define MATLAB_COMPILER_GENERATED_CODE
#endif

#include <math.h>
#include "mex.h"
#include "mcc.h"

/* static array S0_ (1 x 40) text, line 16: 'Signal length is zero in ...' */
static unsigned short S0__r_[] =
{
         83,  105,  103,  110,   97,  108,   32,  108,
        101,  110,  103,  116,  104,   32,  105,  115,
         32,  122,  101,  114,  111,   32,  105,  110,
         32,  114,  111,  117,  116,  105,  110,  101,
         32,  102,  105,  108,  102,  105,  114,  115,
};
static mxArray S0_ = mccCINIT( mccTEXT,  1, 40, S0__r_, 0);
/* static array S1_ (1 x 40) text, line 21: 'Filter length is zero in ...' */
static unsigned short S1__r_[] =
{
         70,  105,  108,  116,  101,  114,   32,  108,
        101,  110,  103,  116,  104,   32,  105,  115,
         32,  122,  101,  114,  111,   32,  105,  110,
         32,  114,  111,  117,  116,  105,  110,  101,
         32,  102,  105,  108,  102,  105,  114,  115,
};
static mxArray S1_ = mccCINIT( mccTEXT,  1, 40, S1__r_, 0);
/* static array S2_ (1 x 40) text, line 16: 'Signal length is zero in ...' */
static unsigned short S2__r_[] =
{
         83,  105,  103,  110,   97,  108,   32,  108,
        101,  110,  103,  116,  104,   32,  105,  115,
         32,  122,  101,  114,  111,   32,  105,  110,
         32,  114,  111,  117,  116,  105,  110,  101,
         32,  102,  105,  108,  102,  105,  114,  115,
};
static mxArray S2_ = mccCINIT( mccTEXT,  1, 40, S2__r_, 0);
/* static array S3_ (1 x 40) text, line 21: 'Filter length is zero in ...' */
static unsigned short S3__r_[] =
{
         70,  105,  108,  116,  101,  114,   32,  108,
        101,  110,  103,  116,  104,   32,  105,  115,
         32,  122,  101,  114,  111,   32,  105,  110,
         32,  114,  111,  117,  116,  105,  110,  101,
         32,  102,  105,  108,  102,  105,  114,  115,
};
static mxArray S3_ = mccCINIT( mccTEXT,  1, 40, S3__r_, 0);
/***************** Compiler Assumptions ****************
 *
 *       C0_         	complex scalar temporary
 *       I0_         	integer scalar temporary
 *       I1_         	integer scalar temporary
 *       R0_         	real scalar temporary
 *       error       	<function>
 *       filfirs     	<function being defined>
 *       i           	integer scalar
 *       k           	integer scalar
 *       k1          	real scalar
 *       k2          	real scalar
 *       length      	<function>
 *       np          	real scalar
 *       nw          	integer scalar
 *       nx          	integer scalar
 *       nx2         	real scalar
 *       rem         	<function>
 *       w           	complex vector/matrix
 *       x           	complex vector/matrix
 *       y           	complex vector/matrix
 *******************************************************/

void
mexFunction(
    int nlhs_,
    mxArray *plhs_[],
    int nrhs_,
    const mxArray *prhs_[]
)
{
   int ci_;
   int i_;
   

   if (nrhs_ > 2 )
   {
      mexErrMsgTxt( "Too many input arguments." );
   }

   if (nlhs_ > 1 )
   {
      mexErrMsgTxt( "Too many output arguments." );
   }

   for (ci_=i_=0; i_<nrhs_; ++i_)
   {
      if ( mccPI(prhs_[i_]) )
      {
         ci_ = 1;
         break;
      }
   }
   if (ci_)
   {
      mxArray y;
      mxArray x;
      mxArray w;
      int nx = 0;
      double np = 0.0;
      double nx2 = 0.0;
      int nw = 0;
      int k = 0;
      int i = 0;
      double k1 = 0.0;
      double k2 = 0.0;
      double C0__r=0.0, C0__i=0.0;
      int I0_ = 0;
      int I1_ = 0;
      double R0_ = 0.0;
      
      mccComplexInit(x);
      mccImport(&x, ((nrhs_>0) ? prhs_[0] : 0), 0, 0);
      mccComplexInit(w);
      mccImport(&w, ((nrhs_>1) ? prhs_[1] : 0), 0, 0);
      mccComplexInit(y);
      
      
      /* % M. Unser / BEIP		Jan-93 */
      
      /* % For symmetric filter only! */
      /* % First coeff = center; */
      
      /* % JK: The signal may not be too short. */
      
      /* % Usage: y=filfirs(x,w) */
      
      /* nx=length(x);            %length of signal */
      if(mccNOTSET(&x))
      {
         mexErrMsgTxt( "variable x undefined, line 12" );
      }
      nx = mccGetLength(&x);
      /* np=2*nx-1; */
      np = ((2 * (double) nx) - 1);
      /* nx2=2*nx; */
      nx2 = (2 * (double) nx);
      /* if nx==0 */
      if ((nx == 0))
      {
         /* error('Signal length is zero in routine filfirs') */
         mccError(&S0_);
         /* return */
         goto MretC;
         /* end */
      }
      /* nw=length(w);             %length of filter */
      if(mccNOTSET(&w))
      {
         mexErrMsgTxt( "variable w undefined, line 19" );
      }
      nw = mccGetLength(&w);
      /* if nw==0 */
      if ((nw == 0))
      {
         /* error('Filter length is zero in routine filfirs') */
         mccError(&S1_);
         /* return */
         goto MretC;
         /* end */
      }
      
      /* y=w(1)*x; */
      C0__r = (mccGetRealVectorElement(&w, mccRint(1)));
      C0__i = mccGetImagVectorElement(&w, mccRint(1));
      {
         int i_, j_;
         int m_=1, n_=1, cx_ = 0;
         double *p_y;
         int I_y=1;
         double *q_y;
         double *p_x;
         int I_x=1;
         double *q_x;
         m_ = mcmCalcResultSize(m_, &n_, mccM(&x), mccN(&x));
         mccAllocateMatrix(&y, m_, n_);
         I_y = (mccM(&y) != 1 || mccN(&y) != 1);
         p_y = mccPR(&y);
         q_y = mccPI(&y);
         I_x = (mccM(&x) != 1 || mccN(&x) != 1);
         p_x = mccPR(&x);
         q_x = mccPI(&x);
         if (m_ != 0)
         {
            for (j_=0; j_<n_; ++j_)
            {
               for (i_=0; i_<m_; ++i_, p_y+=I_y, q_y+=I_y, p_x+=I_x, q_x+=I_x)
               {
                  *p_y = (C0__r * *p_x - C0__i * *q_x);
                  *q_y = (C0__r * *q_x + C0__i * *p_x);
               }
            }
         }
      }
      mccLOG(&y) = 0;
      mccSTRING(&y) = 0;
      /* for k=1:nx */
      for (I0_ = 1; I0_ <= nx; I0_ = I0_ + 1)
      {
         k = I0_;
         /* % y(k)=w(1)*x(k);																			 */
         /* for i=1:nw-1 */
         for (I1_ = 1; I1_ <= (nw - 1); I1_ = I1_ + 1)
         {
            i = I1_;
            /* k1=k-i; */
            k1 = (k - i);
            /* k2=k+i;          */
            k2 = (k + i);
            /* if (k1<1) */
            if ((k1 < 1))
            {
               /* k1=rem((1-k1),np)+1; */
               R0_ = mcmRealRem((double)(1 - k1), np);
               k1 = (R0_ + 1);
               /* if (k1>nx) k1=nx2-k1; end */
               if (( (k1 > nx) && !mccREL_NAN(k1) ))
               {
                  k1 = (nx2 - k1);
               }
               /* end   */
            }
            /* if (k2>nx) */
            if ((k2 > nx))
            {
               /* k2=rem((k2-1),np)+1; */
               R0_ = mcmRealRem((double)(k2 - 1), np);
               k2 = (R0_ + 1);
               /* if (k2>nx) k2=nx2-k2; end */
               if (( (k2 > nx) && !mccREL_NAN(k2) ))
               {
                  k2 = (nx2 - k2);
               }
               /* end */
            }
            /* y(k)=y(k)+(x(k1)+x(k2))*w(i+1); */
            mccSetVectorElement(&y, mccRint(k), ((mccGetRealVectorElement(&y, mccRint(k))) + (((mccGetRealVectorElement(&x, mccRint(k1))) + (mccGetRealVectorElement(&x, mccRint(k2)))) * (mccGetRealVectorElement(&w, mccRint((i + 1)))) - (mccGetImagVectorElement(&x, mccRint(k1)) + mccGetImagVectorElement(&x, mccRint(k2))) * mccGetImagVectorElement(&w, mccRint((i + 1))))), (mccGetImagVectorElement(&y, mccRint(k)) + (((mccGetRealVectorElement(&x, mccRint(k1))) + (mccGetRealVectorElement(&x, mccRint(k2)))) * mccGetImagVectorElement(&w, mccRint((i + 1))) + (mccGetImagVectorElement(&x, mccRint(k1)) + mccGetImagVectorElement(&x, mccRint(k2))) * (mccGetRealVectorElement(&w, mccRint((i + 1)))))));
            /* end */
         }
         /* end */
      }
      MretC: ;
      mccReturnFirstValue(&plhs_[0], &y);
   }
   else
   {
/***************** Compiler Assumptions ****************
 *
 *       I0_         	integer scalar temporary
 *       I1_         	integer scalar temporary
 *       R0_         	real scalar temporary
 *       error       	<function>
 *       filfirs     	<function being defined>
 *       i           	integer scalar
 *       k           	integer scalar
 *       k1          	real scalar
 *       k2          	real scalar
 *       length      	<function>
 *       np          	real scalar
 *       nw          	integer scalar
 *       nx          	integer scalar
 *       nx2         	real scalar
 *       rem         	<function>
 *       w           	real vector/matrix
 *       x           	real vector/matrix
 *       y           	real vector/matrix
 *******************************************************/
      mxArray y;
      mxArray x;
      mxArray w;
      int nx = 0;
      double np = 0.0;
      double nx2 = 0.0;
      int nw = 0;
      int k = 0;
      int i = 0;
      double k1 = 0.0;
      double k2 = 0.0;
      double R0_ = 0.0;
      int I0_ = 0;
      int I1_ = 0;
      
      mccRealInit(x);
      mccImport(&x, ((nrhs_>0) ? prhs_[0] : 0), 0, 0);
      mccRealInit(w);
      mccImport(&w, ((nrhs_>1) ? prhs_[1] : 0), 0, 0);
      mccRealInit(y);
      
      
      /* % M. Unser / BEIP		Jan-93 */
      
      /* % For symmetric filter only! */
      /* % First coeff = center; */
      
      /* % JK: The signal may not be too short. */
      
      /* % Usage: y=filfirs(x,w) */
      
      /* nx=length(x);            %length of signal */
      if(mccNOTSET(&x))
      {
         mexErrMsgTxt( "variable x undefined, line 12" );
      }
      nx = mccGetLength(&x);
      /* np=2*nx-1; */
      np = ((2 * (double) nx) - 1);
      /* nx2=2*nx; */
      nx2 = (2 * (double) nx);
      /* if nx==0 */
      if ((nx == 0))
      {
         /* error('Signal length is zero in routine filfirs') */
         mccError(&S2_);
         /* return */
         goto MretR;
         /* end */
      }
      /* nw=length(w);             %length of filter */
      if(mccNOTSET(&w))
      {
         mexErrMsgTxt( "variable w undefined, line 19" );
      }
      nw = mccGetLength(&w);
      /* if nw==0 */
      if ((nw == 0))
      {
         /* error('Filter length is zero in routine filfirs') */
         mccError(&S3_);
         /* return */
         goto MretR;
         /* end */
      }
      
      /* y=w(1)*x; */
      R0_ = (mccGetRealVectorElement(&w, mccRint(1)));
      {
         int i_, j_;
         int m_=1, n_=1, cx_ = 0;
         double *p_y;
         int I_y=1;
         double *p_x;
         int I_x=1;
         m_ = mcmCalcResultSize(m_, &n_, mccM(&x), mccN(&x));
         mccAllocateMatrix(&y, m_, n_);
         I_y = (mccM(&y) != 1 || mccN(&y) != 1);
         p_y = mccPR(&y);
         I_x = (mccM(&x) != 1 || mccN(&x) != 1);
         p_x = mccPR(&x);
         if (m_ != 0)
         {
            for (j_=0; j_<n_; ++j_)
            {
               for (i_=0; i_<m_; ++i_, p_y+=I_y, p_x+=I_x)
               {
                  *p_y = (R0_ * (double) *p_x);
               }
            }
         }
      }
      mccLOG(&y) = 0;
      mccSTRING(&y) = 0;
      /* for k=1:nx */
      for (I0_ = 1; I0_ <= nx; I0_ = I0_ + 1)
      {
         k = I0_;
         /* % y(k)=w(1)*x(k);																			 */
         /* for i=1:nw-1 */
         for (I1_ = 1; I1_ <= (nw - 1); I1_ = I1_ + 1)
         {
            i = I1_;
            /* k1=k-i; */
            k1 = (k - i);
            /* k2=k+i;          */
            k2 = (k + i);
            /* if (k1<1) */
            if ((k1 < 1))
            {
               /* k1=rem((1-k1),np)+1; */
               R0_ = mcmRealRem((double)(1 - k1), np);
               k1 = (R0_ + 1);
               /* if (k1>nx) k1=nx2-k1; end */
               if (( (k1 > nx) && !mccREL_NAN(k1) ))
               {
                  k1 = (nx2 - k1);
               }
               /* end   */
            }
            /* if (k2>nx) */
            if ((k2 > nx))
            {
               /* k2=rem((k2-1),np)+1; */
               R0_ = mcmRealRem((double)(k2 - 1), np);
               k2 = (R0_ + 1);
               /* if (k2>nx) k2=nx2-k2; end */
               if (( (k2 > nx) && !mccREL_NAN(k2) ))
               {
                  k2 = (nx2 - k2);
               }
               /* end */
            }
            /* y(k)=y(k)+(x(k1)+x(k2))*w(i+1); */
            mccSetRealVectorElement(&y, mccRint(k), ((mccGetRealVectorElement(&y, mccRint(k))) + (((mccGetRealVectorElement(&x, mccRint(k1))) + (mccGetRealVectorElement(&x, mccRint(k2)))) * (double) (mccGetRealVectorElement(&w, mccRint((i + 1)))))));
            /* end */
         }
         /* end */
      }
      MretR: ;
      mccReturnFirstValue(&plhs_[0], &y);
   }
   return;
}
