function s=spwstruct
% This function generates the default values of a structure s,
% driving the spline warping programs

s(1)=3 ;     % degree of the warping function representation             
s(2)=7 ;     % vertical number of nodes                                         
s(3)=7 ;     % horizontal number of nodes                                       
s(4)=1 ;     % preprocessing: 0 none, 1 highpass + histeq, 2 local normalization
s(5)=20 ;    % main filter size for preprocessing                               
s(6)=20 ;    % secondary filter size for preprocessing (not used so far)        
s(7)=1 ;     % regularization 1=yes, 0=no                                       
s(8)=1e-5 ;  % regularization factor (lambda)                                   
s(9)=10 ;    % ML step multiplier                                               
s(10)=32 ;   % Maximum size of the smallest image in the pyramid                
s(11)=1 ;    % Verbosity of prints (0..rare,1..some,2..all)                     
s(12)=0 ;    % Displaying graphically the intermediate images                   
s(13)=0 ;    % show the warping function                                        
s(14)=1e-4 ; % relative precision for ML                                        
s(15)=1e-10 ;% absolute precision for ML
s(16)=1e-10 ;% minimum condition reciprocal for ML
s(17)=0.1 ;  % initial lambda for ML
s(18)=1 ;    % optimisation method to use 1- ML, 2- conjugate gradients
s(19)=3 ;    % the degree of the image interpolation function