% Demonstrate 2D->2D image registration

fr=zeros(32,32) ;
for i=10:20, 
  fr(i,10:20)=ones(1,11) ;
end ;  

ft=zeros(32,32) ;
for i=1:32,
  for j=1:32,
    if ((abs(i-16))^2.5+(abs(j-16))^2.5)<35, ft(i,j)=1.1 ;
    end ;
  end ;
end ;

if 0,
  ft=zeros(32,32) ;
  for i=10:21, 
    ft(i,10:21)=ones(1,12) ;
  end ;  
end ;

subplot(221) ; imagesc(fr) ;
subplot(222) ; imagesc(ft) ;

nx=32 ; ny=32 ;


if 0, % one scale warping
  % Prepare identity mapping 
  cr=clincf(1,nx) ;
  c=zeros(4,4) ;
  c(:,1)=clincf(cr(1),cr(1)) ;
  c(:,2)=clincf(cr(2),cr(2)) ;
  c(:,3)=clincf(cr(3),cr(3)) ;
  c(:,4)=clincf(cr(4),cr(4)) ;
  
  dr=clincf(1,ny) ;
  d=zeros(4,4) ;
  d(1,:)=clincf(dr(1),dr(1))' ;
  d(2,:)=clincf(dr(2),dr(2))' ;
  d(3,:)=clincf(dr(3),dr(3))' ;
  d(4,:)=clincf(dr(4),dr(4))' ;
  c=reshape(c,1,16) ;
  d=reshape(d,1,16) ;
  c=[c d] ;
  nca=4 ;
  
  cc=cputime ;
  c=imwarpoptdi(fr,ft,nca,4,c,3) ;
  cputime-cc 
else
  

  nl=3 ;
  refp=pyramid2(fr,nl) ;
  testp=pyramid2(ft,nl) ;
  cc=cputime ;
  [c,E,nca]=pimwarpoptd(refp,testp,5,5,3) ;
  cputime-cc
end  
  ftb=imcbanal(imcbanal(ft)')' ;
  ime=meximwarpdc(ftb,c,nca,nx,ny) ;

subplot(223) ; imagesc(ime) ;
subplot(224) ; imagesc(ime-fr) ;