static char mc_version[] = "MATLAB Compiler 1.2 Jan 17 1998 infun";
/*
 *  MATLAB Compiler: 1.2
 *  Date: Jan 17 1998
 *  Arguments: -ir szbas 
 */
#ifndef ARRAY_ACCESS_INLINING
#error You must use the -inline option when compiling MATLAB compiler generated code with MEX or MBUILD
#endif
#ifndef MATLAB_COMPILER_GENERATED_CODE
#define MATLAB_COMPILER_GENERATED_CODE
#endif

#include <math.h>
#include "mex.h"
#include "mcc.h"

/* static array S0_ (1 x 5) int, line 9 */
static int S0r_[] =
{
	0, -1, -1, -1, -1, 
};
static mxArray S0_ = mccCINIT( mccINT, 1, 5, S0r_, 0 );
/* static array S1_ (1 x 5) int, line 10 */
static int S1r_[] =
{
	1, 1, 1, 
	1, 2, 
};
static mxArray S1_ = mccCINIT( mccINT, 1, 5, S1r_, 0 );
/***************** Compiler Assumptions ****************
 *
 *       B0_         	boolean scalar temporary
 *       B1_         	boolean scalar temporary
 *       B2_         	boolean scalar temporary
 *       BM0_        	boolean vector/matrix temporary
 *       BM1_        	boolean vector/matrix temporary
 *       BM2_        	boolean vector/matrix temporary
 *       BM3_        	boolean vector/matrix temporary
 *       IM0_        	integer vector/matrix temporary
 *       RM0_        	real vector/matrix temporary
 *       RM1_        	real vector/matrix temporary
 *       RM2_        	real vector/matrix temporary
 *       RM3_        	real vector/matrix temporary
 *       RM4_        	real vector/matrix temporary
 *       RM5_        	real vector/matrix temporary
 *       RM6_        	real vector/matrix temporary
 *       RM7_        	real vector/matrix temporary
 *       RM8_        	real vector/matrix temporary
 *       S0_         	<constant>
 *       S1_         	<constant>
 *       abs         	<function>
 *       h           	integer vector/matrix
 *       ha          	integer vector/matrix
 *       l           	integer vector/matrix
 *       la          	integer vector/matrix
 *       max         	<function>
 *       qbspln      	<function>
 *       szbas       	<function being defined>
 *       t           	real vector/matrix
 *       w           	real vector/matrix
 *       x           	real vector/matrix
 *       y           	real vector/matrix
 *******************************************************/

void
mexFunction(
    int nlhs_,
    mxArray *plhs_[],
    int nrhs_,
    const mxArray *prhs_[]
)
{
   mxArray *Mplhs_[1];
   mxArray *Mprhs_[1];
   

   if (nrhs_ > 3 )
   {
      mexErrMsgTxt( "Too many input arguments." );
   }

   if (nlhs_ > 3 )
   {
      mexErrMsgTxt( "Too many output arguments." );
   }

   {
      mxArray w;
      mxArray l;
      mxArray h;
      mxArray x;
      mxArray y;
      mxArray t;
      mxArray la;
      mxArray ha;
      mxArray IM0_;
      mxArray BM0_;
      mxArray BM1_;
      unsigned short B0_ = 0;
      mxArray BM2_;
      unsigned short B1_ = 0;
      mxArray BM3_;
      unsigned short B2_ = 0;
      mxArray RM0_;
      mxArray RM1_;
      mxArray RM2_;
      mxArray RM3_;
      mxArray RM4_;
      mxArray RM5_;
      mxArray RM6_;
      mxArray RM7_;
      mxArray RM8_;
      
      mccRealInit(x);
      mccImport(&x, ((nrhs_>0) ? prhs_[0] : 0), 0, 0);
      mccRealInit(y);
      mccImport(&y, ((nrhs_>1) ? prhs_[1] : 0), 0, 0);
      mccRealInit(t);
      mccImport(&t, ((nrhs_>2) ? prhs_[2] : 0), 0, 0);
      mccRealInit(w);
      mccIntInit(l);
      mccIntInit(h);
      mccIntInit(la);
      mccIntInit(ha);
      mccIntInit(IM0_);
      mccBoolInit(BM0_);
      mccBoolInit(BM1_);
      mccBoolInit(BM2_);
      mccBoolInit(BM3_);
      mccRealInit(RM0_);
      mccRealInit(RM1_);
      mccRealInit(RM2_);
      mccRealInit(RM3_);
      mccRealInit(RM4_);
      mccRealInit(RM5_);
      mccRealInit(RM6_);
      mccRealInit(RM7_);
      mccRealInit(RM8_);
      
      /* % Basis functions from Szelinski & Coughlan paper */
      /* % Calculates the value of the basis function number t at point (x,y) */
      /* % Returns its value w and the support boundaries - basis function number t */
      /* % has support [l,h]x[l,h] */
      
      /* % Usage: [w,l,h]=szbas(x,y,t) ; */
      
      /* la=[0,-1,-1,-1,-1] ; */
      mccCopy(&la, &S0_);
      /* ha=[1,1,1,1,2] ; */
      mccCopy(&ha, &S1_);
      
      /* l=la(t) ; h=ha(t) ; */
      if(mccNOTSET(&t))
      {
         mexErrMsgTxt( "variable t undefined, line 12" );
      }
      mccFindIndex(&IM0_, &t);
      {
         int i_, j_;
         int m_=1, n_=1, cx_ = 0;
         int *p_l;
         int I_l=1;
         int *p_la;
         int *p_IM0_;
         int I_IM0_=1;
         m_ = mccCalcSubscriptDimensions(m_, &n_, mccM(&IM0_), mccN(&IM0_), &la);
         mccAllocateMatrix(&l, m_, n_);
         I_l = (mccM(&l) != 1 || mccN(&l) != 1);
         p_l = mccIPR(&l);
         I_IM0_ = (mccM(&IM0_) != 1 || mccN(&IM0_) != 1);
         p_IM0_ = mccIPR(&IM0_);
         if (m_ != 0)
         {
            for (j_=0; j_<n_; ++j_)
            {
               for (i_=0; i_<m_; ++i_, p_l+=I_l, p_IM0_+=I_IM0_)
               {
                  *p_l = ((int)mccIPR(&la)[((int)(*p_IM0_ - .5))]);
               }
            }
         }
      }
      mccFindIndex(&IM0_, &t);
      {
         int i_, j_;
         int m_=1, n_=1, cx_ = 0;
         int *p_h;
         int I_h=1;
         int *p_ha;
         int *p_IM0_;
         int I_IM0_=1;
         m_ = mccCalcSubscriptDimensions(m_, &n_, mccM(&IM0_), mccN(&IM0_), &ha);
         mccAllocateMatrix(&h, m_, n_);
         I_h = (mccM(&h) != 1 || mccN(&h) != 1);
         p_h = mccIPR(&h);
         I_IM0_ = (mccM(&IM0_) != 1 || mccN(&IM0_) != 1);
         p_IM0_ = mccIPR(&IM0_);
         if (m_ != 0)
         {
            for (j_=0; j_<n_; ++j_)
            {
               for (i_=0; i_<m_; ++i_, p_h+=I_h, p_IM0_+=I_IM0_)
               {
                  *p_h = ((int)mccIPR(&ha)[((int)(*p_IM0_ - .5))]);
               }
            }
         }
      }
      /* w=0; */
      {
         double tr_ = 0;
         mccAllocateMatrix(&w, 1, 1);
         *mccPR(&w) = tr_;
      }
      /* if x>=h | x<=l | y>=h |  y<=l, return ; end ; */
      if(mccNOTSET(&x))
      {
         mexErrMsgTxt( "variable x undefined, line 14" );
      }
      {
         int i_, j_;
         int m_=1, n_=1, cx_ = 0;
         unsigned short *p_BM0_;
         int I_BM0_=1;
         double *p_x;
         int I_x=1;
         int *p_h;
         int I_h=1;
         m_ = mcmCalcResultSize(m_, &n_, mccM(&x), mccN(&x));
         m_ = mcmCalcResultSize(m_, &n_, mccM(&h), mccN(&h));
         mccAllocateMatrix(&BM0_, m_, n_);
         I_BM0_ = (mccM(&BM0_) != 1 || mccN(&BM0_) != 1);
         p_BM0_ = mccSPR(&BM0_);
         I_x = (mccM(&x) != 1 || mccN(&x) != 1);
         p_x = mccPR(&x);
         I_h = (mccM(&h) != 1 || mccN(&h) != 1);
         p_h = mccIPR(&h);
         if (m_ != 0)
         {
            for (j_=0; j_<n_; ++j_)
            {
               for (i_=0; i_<m_; ++i_, p_BM0_+=I_BM0_, p_x+=I_x, p_h+=I_h)
               {
                  *p_BM0_ = ( (*p_x >= ((int)*p_h)) && !mccREL_NAN(*p_x) );
               }
            }
         }
      }
      B0_ = mccIfCondition(&BM0_);
      if (!(double)B0_)
      {
         if(mccNOTSET(&x))
         {
            mexErrMsgTxt( "variable x undefined, line 14" );
         }
         {
            int i_, j_;
            int m_=1, n_=1, cx_ = 0;
            unsigned short *p_BM1_;
            int I_BM1_=1;
            double *p_x;
            int I_x=1;
            int *p_l;
            int I_l=1;
            m_ = mcmCalcResultSize(m_, &n_, mccM(&x), mccN(&x));
            m_ = mcmCalcResultSize(m_, &n_, mccM(&l), mccN(&l));
            mccAllocateMatrix(&BM1_, m_, n_);
            I_BM1_ = (mccM(&BM1_) != 1 || mccN(&BM1_) != 1);
            p_BM1_ = mccSPR(&BM1_);
            I_x = (mccM(&x) != 1 || mccN(&x) != 1);
            p_x = mccPR(&x);
            I_l = (mccM(&l) != 1 || mccN(&l) != 1);
            p_l = mccIPR(&l);
            if (m_ != 0)
            {
               for (j_=0; j_<n_; ++j_)
               {
                  for (i_=0; i_<m_; ++i_, p_BM1_+=I_BM1_, p_x+=I_x, p_l+=I_l)
                  {
                     *p_BM1_ = ( (*p_x <= ((int)*p_l)) && !mccREL_NAN(*p_x) );
                  }
               }
            }
         }
         B0_ = mccIfCondition(&BM1_);
      }
      B1_ = (double)B0_;
      if (!(double)B1_)
      {
         if(mccNOTSET(&y))
         {
            mexErrMsgTxt( "variable y undefined, line 14" );
         }
         {
            int i_, j_;
            int m_=1, n_=1, cx_ = 0;
            unsigned short *p_BM2_;
            int I_BM2_=1;
            double *p_y;
            int I_y=1;
            int *p_h;
            int I_h=1;
            m_ = mcmCalcResultSize(m_, &n_, mccM(&y), mccN(&y));
            m_ = mcmCalcResultSize(m_, &n_, mccM(&h), mccN(&h));
            mccAllocateMatrix(&BM2_, m_, n_);
            I_BM2_ = (mccM(&BM2_) != 1 || mccN(&BM2_) != 1);
            p_BM2_ = mccSPR(&BM2_);
            I_y = (mccM(&y) != 1 || mccN(&y) != 1);
            p_y = mccPR(&y);
            I_h = (mccM(&h) != 1 || mccN(&h) != 1);
            p_h = mccIPR(&h);
            if (m_ != 0)
            {
               for (j_=0; j_<n_; ++j_)
               {
                  for (i_=0; i_<m_; ++i_, p_BM2_+=I_BM2_, p_y+=I_y, p_h+=I_h)
                  {
                     *p_BM2_ = ( (*p_y >= ((int)*p_h)) && !mccREL_NAN(*p_y) );
                  }
               }
            }
         }
         B1_ = mccIfCondition(&BM2_);
      }
      B2_ = (double)B1_;
      if (!(double)B2_)
      {
         if(mccNOTSET(&y))
         {
            mexErrMsgTxt( "variable y undefined, line 14" );
         }
         {
            int i_, j_;
            int m_=1, n_=1, cx_ = 0;
            unsigned short *p_BM3_;
            int I_BM3_=1;
            double *p_y;
            int I_y=1;
            int *p_l;
            int I_l=1;
            m_ = mcmCalcResultSize(m_, &n_, mccM(&y), mccN(&y));
            m_ = mcmCalcResultSize(m_, &n_, mccM(&l), mccN(&l));
            mccAllocateMatrix(&BM3_, m_, n_);
            I_BM3_ = (mccM(&BM3_) != 1 || mccN(&BM3_) != 1);
            p_BM3_ = mccSPR(&BM3_);
            I_y = (mccM(&y) != 1 || mccN(&y) != 1);
            p_y = mccPR(&y);
            I_l = (mccM(&l) != 1 || mccN(&l) != 1);
            p_l = mccIPR(&l);
            if (m_ != 0)
            {
               for (j_=0; j_<n_; ++j_)
               {
                  for (i_=0; i_<m_; ++i_, p_BM3_+=I_BM3_, p_y+=I_y, p_l+=I_l)
                  {
                     *p_BM3_ = ( (*p_y <= ((int)*p_l)) && !mccREL_NAN(*p_y) );
                  }
               }
            }
         }
         B2_ = mccIfCondition(&BM3_);
      }
      if ((double)B2_)
      {
         goto MretR;
      }
      
      /* if t==1, w=1 ;  */
      {
         int i_, j_;
         int m_=1, n_=1, cx_ = 0;
         unsigned short *p_BM3_;
         int I_BM3_=1;
         double *p_t;
         int I_t=1;
         m_ = mcmCalcResultSize(m_, &n_, mccM(&t), mccN(&t));
         mccAllocateMatrix(&BM3_, m_, n_);
         I_BM3_ = (mccM(&BM3_) != 1 || mccN(&BM3_) != 1);
         p_BM3_ = mccSPR(&BM3_);
         I_t = (mccM(&t) != 1 || mccN(&t) != 1);
         p_t = mccPR(&t);
         if (m_ != 0)
         {
            for (j_=0; j_<n_; ++j_)
            {
               for (i_=0; i_<m_; ++i_, p_BM3_+=I_BM3_, p_t+=I_t)
               {
                  *p_BM3_ = ( (*p_t == 1) && !mccREL_NAN(*p_t) );
               }
            }
         }
      }
      if (mccIfCondition(&BM3_))
      {
         {
            double tr_ = 1;
            mccAllocateMatrix(&w, 1, 1);
            *mccPR(&w) = tr_;
         }
         
      }
      else
      {
         /* elseif t==2,  */
         {
            int i_, j_;
            int m_=1, n_=1, cx_ = 0;
            unsigned short *p_BM3_;
            int I_BM3_=1;
            double *p_t;
            int I_t=1;
            m_ = mcmCalcResultSize(m_, &n_, mccM(&t), mccN(&t));
            mccAllocateMatrix(&BM3_, m_, n_);
            I_BM3_ = (mccM(&BM3_) != 1 || mccN(&BM3_) != 1);
            p_BM3_ = mccSPR(&BM3_);
            I_t = (mccM(&t) != 1 || mccN(&t) != 1);
            p_t = mccPR(&t);
            if (m_ != 0)
            {
               for (j_=0; j_<n_; ++j_)
               {
                  for (i_=0; i_<m_; ++i_, p_BM3_+=I_BM3_, p_t+=I_t)
                  {
                     *p_BM3_ = ( (*p_t == 2) && !mccREL_NAN(*p_t) );
                  }
               }
            }
         }
         if (mccIfCondition(&BM3_))
         {
            /* if x<0, */
            {
               int i_, j_;
               int m_=1, n_=1, cx_ = 0;
               unsigned short *p_BM3_;
               int I_BM3_=1;
               double *p_x;
               int I_x=1;
               m_ = mcmCalcResultSize(m_, &n_, mccM(&x), mccN(&x));
               mccAllocateMatrix(&BM3_, m_, n_);
               I_BM3_ = (mccM(&BM3_) != 1 || mccN(&BM3_) != 1);
               p_BM3_ = mccSPR(&BM3_);
               I_x = (mccM(&x) != 1 || mccN(&x) != 1);
               p_x = mccPR(&x);
               if (m_ != 0)
               {
                  for (j_=0; j_<n_; ++j_)
                  {
                     for (i_=0; i_<m_; ++i_, p_BM3_+=I_BM3_, p_x+=I_x)
                     {
                        *p_BM3_ = ( (*p_x < 0) && !mccREL_NAN(*p_x) );
                     }
                  }
               }
            }
            if (mccIfCondition(&BM3_))
            {
               /* if y>0, w=x+1 ; end ; */
               {
                  int i_, j_;
                  int m_=1, n_=1, cx_ = 0;
                  unsigned short *p_BM3_;
                  int I_BM3_=1;
                  double *p_y;
                  int I_y=1;
                  m_ = mcmCalcResultSize(m_, &n_, mccM(&y), mccN(&y));
                  mccAllocateMatrix(&BM3_, m_, n_);
                  I_BM3_ = (mccM(&BM3_) != 1 || mccN(&BM3_) != 1);
                  p_BM3_ = mccSPR(&BM3_);
                  I_y = (mccM(&y) != 1 || mccN(&y) != 1);
                  p_y = mccPR(&y);
                  if (m_ != 0)
                  {
                     for (j_=0; j_<n_; ++j_)
                     {
                        for (i_=0; i_<m_; ++i_, p_BM3_+=I_BM3_, p_y+=I_y)
                        {
                           *p_BM3_ = ( (*p_y > 0) && !mccREL_NAN(*p_y) );
                        }
                     }
                  }
               }
               if (mccIfCondition(&BM3_))
               {
                  {
                     int i_, j_;
                     int m_=1, n_=1, cx_ = 0;
                     double *p_w;
                     int I_w=1;
                     double *p_x;
                     int I_x=1;
                     m_ = mcmCalcResultSize(m_, &n_, mccM(&x), mccN(&x));
                     mccAllocateMatrix(&w, m_, n_);
                     I_w = (mccM(&w) != 1 || mccN(&w) != 1);
                     p_w = mccPR(&w);
                     I_x = (mccM(&x) != 1 || mccN(&x) != 1);
                     p_x = mccPR(&x);
                     if (m_ != 0)
                     {
                        for (j_=0; j_<n_; ++j_)
                        {
                           for (i_=0; i_<m_; ++i_, p_w+=I_w, p_x+=I_x)
                           {
                              *p_w = (*p_x + 1);
                           }
                        }
                     }
                  }
               }
            }
            else
            {
               /* elseif y<0, w=y+1 ;  */
               {
                  int i_, j_;
                  int m_=1, n_=1, cx_ = 0;
                  unsigned short *p_BM3_;
                  int I_BM3_=1;
                  double *p_y;
                  int I_y=1;
                  m_ = mcmCalcResultSize(m_, &n_, mccM(&y), mccN(&y));
                  mccAllocateMatrix(&BM3_, m_, n_);
                  I_BM3_ = (mccM(&BM3_) != 1 || mccN(&BM3_) != 1);
                  p_BM3_ = mccSPR(&BM3_);
                  I_y = (mccM(&y) != 1 || mccN(&y) != 1);
                  p_y = mccPR(&y);
                  if (m_ != 0)
                  {
                     for (j_=0; j_<n_; ++j_)
                     {
                        for (i_=0; i_<m_; ++i_, p_BM3_+=I_BM3_, p_y+=I_y)
                        {
                           *p_BM3_ = ( (*p_y < 0) && !mccREL_NAN(*p_y) );
                        }
                     }
                  }
               }
               if (mccIfCondition(&BM3_))
               {
                  {
                     int i_, j_;
                     int m_=1, n_=1, cx_ = 0;
                     double *p_w;
                     int I_w=1;
                     double *p_y;
                     int I_y=1;
                     m_ = mcmCalcResultSize(m_, &n_, mccM(&y), mccN(&y));
                     mccAllocateMatrix(&w, m_, n_);
                     I_w = (mccM(&w) != 1 || mccN(&w) != 1);
                     p_w = mccPR(&w);
                     I_y = (mccM(&y) != 1 || mccN(&y) != 1);
                     p_y = mccPR(&y);
                     if (m_ != 0)
                     {
                        for (j_=0; j_<n_; ++j_)
                        {
                           for (i_=0; i_<m_; ++i_, p_w+=I_w, p_y+=I_y)
                           {
                              *p_w = (*p_y + 1);
                           }
                        }
                     }
                  }
               }
               else
               {
                  /* else w=1-x-y ; end ; */
                  {
                     int i_, j_;
                     int m_=1, n_=1, cx_ = 0;
                     double *p_w;
                     int I_w=1;
                     double *p_x;
                     int I_x=1;
                     double *p_y;
                     int I_y=1;
                     m_ = mcmCalcResultSize(m_, &n_, mccM(&x), mccN(&x));
                     m_ = mcmCalcResultSize(m_, &n_, mccM(&y), mccN(&y));
                     mccAllocateMatrix(&w, m_, n_);
                     I_w = (mccM(&w) != 1 || mccN(&w) != 1);
                     p_w = mccPR(&w);
                     I_x = (mccM(&x) != 1 || mccN(&x) != 1);
                     p_x = mccPR(&x);
                     I_y = (mccM(&y) != 1 || mccN(&y) != 1);
                     p_y = mccPR(&y);
                     if (m_ != 0)
                     {
                        for (j_=0; j_<n_; ++j_)
                        {
                           for (i_=0; i_<m_; ++i_, p_w+=I_w, p_x+=I_x, p_y+=I_y)
                           {
                              *p_w = ((1 - *p_x) - *p_y);
                           }
                        }
                     }
                  }
               }
            }
            
         }
         else
         {
            /* elseif t==3,         */
            {
               int i_, j_;
               int m_=1, n_=1, cx_ = 0;
               unsigned short *p_BM3_;
               int I_BM3_=1;
               double *p_t;
               int I_t=1;
               m_ = mcmCalcResultSize(m_, &n_, mccM(&t), mccN(&t));
               mccAllocateMatrix(&BM3_, m_, n_);
               I_BM3_ = (mccM(&BM3_) != 1 || mccN(&BM3_) != 1);
               p_BM3_ = mccSPR(&BM3_);
               I_t = (mccM(&t) != 1 || mccN(&t) != 1);
               p_t = mccPR(&t);
               if (m_ != 0)
               {
                  for (j_=0; j_<n_; ++j_)
                  {
                     for (i_=0; i_<m_; ++i_, p_BM3_+=I_BM3_, p_t+=I_t)
                     {
                        *p_BM3_ = ( (*p_t == 3) && !mccREL_NAN(*p_t) );
                     }
                  }
               }
            }
            if (mccIfCondition(&BM3_))
            {
               /* w=max([ 0 1-max([ abs(x) abs(y) abs(x+y)]) ]) ; */
               mccAbs(&RM0_, &x);
               mccAbs(&RM1_, &y);
               mccCatenateColumns(&RM2_, &RM0_, &RM1_);
               {
                  int i_, j_;
                  int m_=1, n_=1, cx_ = 0;
                  double *p_RM3_;
                  int I_RM3_=1;
                  double *p_x;
                  int I_x=1;
                  double *p_y;
                  int I_y=1;
                  m_ = mcmCalcResultSize(m_, &n_, mccM(&x), mccN(&x));
                  m_ = mcmCalcResultSize(m_, &n_, mccM(&y), mccN(&y));
                  mccAllocateMatrix(&RM3_, m_, n_);
                  I_RM3_ = (mccM(&RM3_) != 1 || mccN(&RM3_) != 1);
                  p_RM3_ = mccPR(&RM3_);
                  I_x = (mccM(&x) != 1 || mccN(&x) != 1);
                  p_x = mccPR(&x);
                  I_y = (mccM(&y) != 1 || mccN(&y) != 1);
                  p_y = mccPR(&y);
                  if (m_ != 0)
                  {
                     for (j_=0; j_<n_; ++j_)
                     {
                        for (i_=0; i_<m_; ++i_, p_RM3_+=I_RM3_, p_x+=I_x, p_y+=I_y)
                        {
                           *p_RM3_ = (*p_x + *p_y);
                        }
                     }
                  }
               }
               mccAbs(&RM4_, &RM3_);
               mccCatenateColumns(&RM5_, &RM2_, &RM4_);
               mccMax(&RM6_, &RM5_);
               {
                  int i_, j_;
                  int m_=1, n_=1, cx_ = 0;
                  double *p_RM7_;
                  int I_RM7_=1;
                  double *p_RM6_;
                  int I_RM6_=1;
                  m_ = mcmCalcResultSize(m_, &n_, mccM(&RM6_), mccN(&RM6_));
                  mccAllocateMatrix(&RM7_, m_, n_);
                  I_RM7_ = (mccM(&RM7_) != 1 || mccN(&RM7_) != 1);
                  p_RM7_ = mccPR(&RM7_);
                  I_RM6_ = (mccM(&RM6_) != 1 || mccN(&RM6_) != 1);
                  p_RM6_ = mccPR(&RM6_);
                  if (m_ != 0)
                  {
                     for (j_=0; j_<n_; ++j_)
                     {
                        for (i_=0; i_<m_; ++i_, p_RM7_+=I_RM7_, p_RM6_+=I_RM6_)
                        {
                           *p_RM7_ = (1 - *p_RM6_);
                        }
                     }
                  }
               }
               mccCatenateColumns(&RM8_, mccTempMatrix(0, 0., mccINT, 0 ), &RM7_);
               mccMax(&w, &RM8_);
               
            }
            else
            {
               /* elseif t==4,   */
               {
                  int i_, j_;
                  int m_=1, n_=1, cx_ = 0;
                  unsigned short *p_BM3_;
                  int I_BM3_=1;
                  double *p_t;
                  int I_t=1;
                  m_ = mcmCalcResultSize(m_, &n_, mccM(&t), mccN(&t));
                  mccAllocateMatrix(&BM3_, m_, n_);
                  I_BM3_ = (mccM(&BM3_) != 1 || mccN(&BM3_) != 1);
                  p_BM3_ = mccSPR(&BM3_);
                  I_t = (mccM(&t) != 1 || mccN(&t) != 1);
                  p_t = mccPR(&t);
                  if (m_ != 0)
                  {
                     for (j_=0; j_<n_; ++j_)
                     {
                        for (i_=0; i_<m_; ++i_, p_BM3_+=I_BM3_, p_t+=I_t)
                        {
                           *p_BM3_ = ( (*p_t == 4) && !mccREL_NAN(*p_t) );
                        }
                     }
                  }
               }
               if (mccIfCondition(&BM3_))
               {
                  /* w=(1-abs(x))*(1-abs(y)) ; */
                  mccAbs(&RM8_, &x);
                  {
                     int i_, j_;
                     int m_=1, n_=1, cx_ = 0;
                     double *p_RM7_;
                     int I_RM7_=1;
                     double *p_RM8_;
                     int I_RM8_=1;
                     m_ = mcmCalcResultSize(m_, &n_, mccM(&RM8_), mccN(&RM8_));
                     mccAllocateMatrix(&RM7_, m_, n_);
                     I_RM7_ = (mccM(&RM7_) != 1 || mccN(&RM7_) != 1);
                     p_RM7_ = mccPR(&RM7_);
                     I_RM8_ = (mccM(&RM8_) != 1 || mccN(&RM8_) != 1);
                     p_RM8_ = mccPR(&RM8_);
                     if (m_ != 0)
                     {
                        for (j_=0; j_<n_; ++j_)
                        {
                           for (i_=0; i_<m_; ++i_, p_RM7_+=I_RM7_, p_RM8_+=I_RM8_)
                           {
                              *p_RM7_ = (1 - *p_RM8_);
                           }
                        }
                     }
                  }
                  mccAbs(&RM6_, &y);
                  {
                     int i_, j_;
                     int m_=1, n_=1, cx_ = 0;
                     double *p_RM5_;
                     int I_RM5_=1;
                     double *p_RM6_;
                     int I_RM6_=1;
                     m_ = mcmCalcResultSize(m_, &n_, mccM(&RM6_), mccN(&RM6_));
                     mccAllocateMatrix(&RM5_, m_, n_);
                     I_RM5_ = (mccM(&RM5_) != 1 || mccN(&RM5_) != 1);
                     p_RM5_ = mccPR(&RM5_);
                     I_RM6_ = (mccM(&RM6_) != 1 || mccN(&RM6_) != 1);
                     p_RM6_ = mccPR(&RM6_);
                     if (m_ != 0)
                     {
                        for (j_=0; j_<n_; ++j_)
                        {
                           for (i_=0; i_<m_; ++i_, p_RM5_+=I_RM5_, p_RM6_+=I_RM6_)
                           {
                              *p_RM5_ = (1 - *p_RM6_);
                           }
                        }
                     }
                  }
                  mccRealMatrixMultiply(&w, &RM7_, &RM5_);
               }
               else
               {
                  /* elseif t==5, */
                  {
                     int i_, j_;
                     int m_=1, n_=1, cx_ = 0;
                     unsigned short *p_BM3_;
                     int I_BM3_=1;
                     double *p_t;
                     int I_t=1;
                     m_ = mcmCalcResultSize(m_, &n_, mccM(&t), mccN(&t));
                     mccAllocateMatrix(&BM3_, m_, n_);
                     I_BM3_ = (mccM(&BM3_) != 1 || mccN(&BM3_) != 1);
                     p_BM3_ = mccSPR(&BM3_);
                     I_t = (mccM(&t) != 1 || mccN(&t) != 1);
                     p_t = mccPR(&t);
                     if (m_ != 0)
                     {
                        for (j_=0; j_<n_; ++j_)
                        {
                           for (i_=0; i_<m_; ++i_, p_BM3_+=I_BM3_, p_t+=I_t)
                           {
                              *p_BM3_ = ( (*p_t == 5) && !mccREL_NAN(*p_t) );
                           }
                        }
                     }
                  }
                  if (mccIfCondition(&BM3_))
                  {
                     /* w=qbspln(x)*qbspln(y) ; */
                     Mprhs_[0] = &x;
                     Mplhs_[0] = &RM5_;
                     mccCallMATLAB(1, Mplhs_, 1, Mprhs_, "qbspln", 30);
                     Mprhs_[0] = &y;
                     Mplhs_[0] = &RM6_;
                     mccCallMATLAB(1, Mplhs_, 1, Mprhs_, "qbspln", 30);
                     mccRealMatrixMultiply(&w, &RM5_, &RM6_);
                     /* end ; */
                  }
               }
            }
         }
      }
      
      
      MretR: ;
      mccReturnFirstValue(&plhs_[0], &w);
      mccReturnValue(&plhs_[1], &l);
      mccReturnValue(&plhs_[2], &h);
   }
   return;
}
