static char mc_version[] = "MATLAB Compiler 1.2 Jan 17 1998 infun";
/*
 *  MATLAB Compiler: 1.2
 *  Date: Jan 17 1998
 *  Arguments: -ir szcalcdad 
 */
#ifndef ARRAY_ACCESS_INLINING
#error You must use the -inline option when compiling MATLAB compiler generated code with MEX or MBUILD
#endif
#ifndef MATLAB_COMPILER_GENERATED_CODE
#define MATLAB_COMPILER_GENERATED_CODE
#endif

#include <math.h>
#include "mex.h"
#include "mcc.h"

/***************** Compiler Assumptions ****************
 *
 *       B0_         	boolean scalar temporary
 *       B1_         	boolean scalar temporary
 *       B2_         	boolean scalar temporary
 *       BM0_        	boolean vector/matrix temporary
 *       BM1_        	boolean vector/matrix temporary
 *       BM2_        	boolean vector/matrix temporary
 *       BM3_        	boolean vector/matrix temporary
 *       I0_         	integer scalar temporary
 *       I1_         	integer scalar temporary
 *       I2_         	integer scalar temporary
 *       I3_         	integer scalar temporary
 *       IM0_        	integer vector/matrix temporary
 *       R0_         	real scalar temporary
 *       RM0_        	real vector/matrix temporary
 *       RM1_        	real vector/matrix temporary
 *       RM2_        	real vector/matrix temporary
 *       RM3_        	real vector/matrix temporary
 *       RM4_        	real vector/matrix temporary
 *       ceil        	<function>
 *       d           	real vector/matrix
 *       dAd         	real vector/matrix
 *       du          	real vector/matrix
 *       dv          	real vector/matrix
 *       floor       	<function>
 *       grx         	real vector/matrix
 *       gry         	real vector/matrix
 *       gx          	real scalar
 *       gy          	real scalar
 *       hbas        	integer vector/matrix
 *       hrx         	real vector/matrix
 *       hry         	real vector/matrix
 *       ind         	real vector/matrix
 *       k           	integer scalar
 *       kk          	real scalar
 *       l           	integer scalar
 *       lbas        	integer vector/matrix
 *       ll          	real scalar
 *       lrx         	real vector/matrix
 *       lry         	real vector/matrix
 *       m           	real vector/matrix
 *       max         	<function>
 *       min         	<function>
 *       nsx         	real vector/matrix
 *       nsy         	real vector/matrix
 *       nx          	integer scalar
 *       ny          	integer scalar
 *       rx          	real vector/matrix
 *       ry          	real vector/matrix
 *       size        	<function>
 *       szbas       	<function>
 *       szcalcdad   	<function being defined>
 *       t           	real vector/matrix
 *       ux          	real vector/matrix
 *       uxc         	real scalar
 *       uy          	real vector/matrix
 *       uyc         	real scalar
 *       w           	real vector/matrix
 *       wij         	real vector/matrix
 *******************************************************/

void
mexFunction(
    int nlhs_,
    mxArray *plhs_[],
    int nrhs_,
    const mxArray *prhs_[]
)
{
   mxArray *Mplhs_[3];
   mxArray *Mprhs_[3];
   

   if (nrhs_ > 7 )
   {
      mexErrMsgTxt( "Too many input arguments." );
   }

   if (nlhs_ > 1 )
   {
      mexErrMsgTxt( "Too many output arguments." );
   }

   {
      mxArray dAd;
      mxArray d;
      mxArray grx;
      mxArray gry;
      mxArray ux;
      mxArray uy;
      mxArray m;
      mxArray t;
      int ny = 0;
      int nx = 0;
      mxArray nsy;
      mxArray nsx;
      mxArray w;
      mxArray lbas;
      mxArray hbas;
      int k = 0;
      int l = 0;
      double uxc = 0.0;
      double uyc = 0.0;
      mxArray rx;
      mxArray ry;
      mxArray lrx;
      mxArray hrx;
      mxArray lry;
      mxArray hry;
      double gx = 0.0;
      double gy = 0.0;
      mxArray du;
      mxArray dv;
      double ll = 0.0;
      double kk = 0.0;
      mxArray ind;
      mxArray wij;
      int I0_ = 0;
      mxArray RM0_;
      mxArray RM1_;
      int I1_ = 0;
      unsigned short B0_ = 0;
      unsigned short B1_ = 0;
      unsigned short B2_ = 0;
      double R0_ = 0.0;
      mxArray BM0_;
      mxArray BM1_;
      mxArray BM2_;
      mxArray BM3_;
      int I2_ = 0;
      int I3_ = 0;
      mxArray RM2_;
      mxArray RM3_;
      mxArray IM0_;
      mxArray RM4_;
      
      mccRealInit(d);
      mccImport(&d, ((nrhs_>0) ? prhs_[0] : 0), 0, 0);
      mccRealInit(grx);
      mccImport(&grx, ((nrhs_>1) ? prhs_[1] : 0), 0, 0);
      mccRealInit(gry);
      mccImport(&gry, ((nrhs_>2) ? prhs_[2] : 0), 0, 0);
      mccRealInit(ux);
      mccImport(&ux, ((nrhs_>3) ? prhs_[3] : 0), 0, 0);
      mccRealInit(uy);
      mccImport(&uy, ((nrhs_>4) ? prhs_[4] : 0), 0, 0);
      mccRealInit(m);
      mccImport(&m, ((nrhs_>5) ? prhs_[5] : 0), 0, 0);
      mccRealInit(t);
      mccImport(&t, ((nrhs_>6) ? prhs_[6] : 0), 0, 0);
      mccRealInit(dAd);
      mccRealInit(nsy);
      mccRealInit(nsx);
      mccRealInit(w);
      mccIntInit(lbas);
      mccIntInit(hbas);
      mccRealInit(rx);
      mccRealInit(ry);
      mccRealInit(lrx);
      mccRealInit(hrx);
      mccRealInit(lry);
      mccRealInit(hry);
      mccRealInit(du);
      mccRealInit(dv);
      mccRealInit(ind);
      mccRealInit(wij);
      mccRealInit(RM0_);
      mccRealInit(RM1_);
      mccBoolInit(BM0_);
      mccBoolInit(BM1_);
      mccBoolInit(BM2_);
      mccBoolInit(BM3_);
      mccRealInit(RM2_);
      mccRealInit(RM3_);
      mccIntInit(IM0_);
      mccRealInit(RM4_);
      
      /* % Part of the implementation of the Szelinski-Coughlan registration algorithm */
      
      /* % Jan Kybic, February 1999 */
      
      /* % Usage: dAd=szcalcdad(d,grx,gry,ux,uy,m,t) ; */
      
      /* [ny,nx]=size(grx) ; */
      if(mccNOTSET(&grx))
      {
         mexErrMsgTxt( "variable grx undefined, line 8" );
      }
      mccGetMatrixSize(&ny,&nx, &grx);
      /* nsy=floor((ny-2)/m)+1 ; */
      I0_ = (ny - 2);
      if(mccNOTSET(&m))
      {
         mexErrMsgTxt( "variable m undefined, line 9" );
      }
      {
         int i_, j_;
         int m_=1, n_=1, cx_ = 0;
         double *p_RM0_;
         int I_RM0_=1;
         double *p_m;
         int I_m=1;
         m_ = mcmCalcResultSize(m_, &n_, mccM(&m), mccN(&m));
         mccAllocateMatrix(&RM0_, m_, n_);
         I_RM0_ = (mccM(&RM0_) != 1 || mccN(&RM0_) != 1);
         p_RM0_ = mccPR(&RM0_);
         I_m = (mccM(&m) != 1 || mccN(&m) != 1);
         p_m = mccPR(&m);
         if (m_ != 0)
         {
            for (j_=0; j_<n_; ++j_)
            {
               for (i_=0; i_<m_; ++i_, p_RM0_+=I_RM0_, p_m+=I_m)
               {
                  *p_RM0_ = (I0_ / (double) *p_m);
               }
            }
         }
      }
      mccFloor(&RM1_, &RM0_);
      {
         int i_, j_;
         int m_=1, n_=1, cx_ = 0;
         double *p_nsy;
         int I_nsy=1;
         double *p_RM1_;
         int I_RM1_=1;
         m_ = mcmCalcResultSize(m_, &n_, mccM(&RM1_), mccN(&RM1_));
         mccAllocateMatrix(&nsy, m_, n_);
         I_nsy = (mccM(&nsy) != 1 || mccN(&nsy) != 1);
         p_nsy = mccPR(&nsy);
         I_RM1_ = (mccM(&RM1_) != 1 || mccN(&RM1_) != 1);
         p_RM1_ = mccPR(&RM1_);
         if (m_ != 0)
         {
            for (j_=0; j_<n_; ++j_)
            {
               for (i_=0; i_<m_; ++i_, p_nsy+=I_nsy, p_RM1_+=I_RM1_)
               {
                  *p_nsy = (*p_RM1_ + 1);
               }
            }
         }
      }
      /* nsx=floor((nx-2)/m)+1 ; */
      I0_ = (nx - 2);
      {
         int i_, j_;
         int m_=1, n_=1, cx_ = 0;
         double *p_RM1_;
         int I_RM1_=1;
         double *p_m;
         int I_m=1;
         m_ = mcmCalcResultSize(m_, &n_, mccM(&m), mccN(&m));
         mccAllocateMatrix(&RM1_, m_, n_);
         I_RM1_ = (mccM(&RM1_) != 1 || mccN(&RM1_) != 1);
         p_RM1_ = mccPR(&RM1_);
         I_m = (mccM(&m) != 1 || mccN(&m) != 1);
         p_m = mccPR(&m);
         if (m_ != 0)
         {
            for (j_=0; j_<n_; ++j_)
            {
               for (i_=0; i_<m_; ++i_, p_RM1_+=I_RM1_, p_m+=I_m)
               {
                  *p_RM1_ = (I0_ / (double) *p_m);
               }
            }
         }
      }
      mccFloor(&RM0_, &RM1_);
      {
         int i_, j_;
         int m_=1, n_=1, cx_ = 0;
         double *p_nsx;
         int I_nsx=1;
         double *p_RM0_;
         int I_RM0_=1;
         m_ = mcmCalcResultSize(m_, &n_, mccM(&RM0_), mccN(&RM0_));
         mccAllocateMatrix(&nsx, m_, n_);
         I_nsx = (mccM(&nsx) != 1 || mccN(&nsx) != 1);
         p_nsx = mccPR(&nsx);
         I_RM0_ = (mccM(&RM0_) != 1 || mccN(&RM0_) != 1);
         p_RM0_ = mccPR(&RM0_);
         if (m_ != 0)
         {
            for (j_=0; j_<n_; ++j_)
            {
               for (i_=0; i_<m_; ++i_, p_nsx+=I_nsx, p_RM0_+=I_RM0_)
               {
                  *p_nsx = (*p_RM0_ + 1);
               }
            }
         }
      }
      /* [w,lbas,hbas]=szbas(0,0,t) ; % get the support size */
      if(mccNOTSET(&t))
      {
         mexErrMsgTxt( "variable t undefined, line 11" );
      }
      Mprhs_[0] = mccTempMatrix(0, 0., mccINT, 0 );
      Mprhs_[1] = mccTempMatrix(0, 0., mccINT, 0 );
      Mprhs_[2] = &t;
      Mplhs_[0] = &w;
      Mplhs_[1] = &lbas;
      Mplhs_[2] = &hbas;
      mccCallMATLAB(3, Mplhs_, 3, Mprhs_, "szbas", 11);
      
      /* dAd=0 ; */
      {
         double tr_ = 0;
         mccAllocateMatrix(&dAd, 1, 1);
         *mccPR(&dAd) = tr_;
      }
      /* % k,l is the row, resp. column of the reference image */
      /* for k=1:ny, */
      for (I0_ = 1; I0_ <= ny; I0_ = I0_ + 1)
      {
         k = I0_;
         /* for l=1:nx, */
         for (I1_ = 1; I1_ <= nx; I1_ = I1_ + 1)
         {
            l = I1_;
            /* % fetch the coordinates in the test image */
            /* uxc=ux(k,l) ; uyc=uy(k,l) ; */
            if(mccNOTSET(&ux))
            {
               mexErrMsgTxt( "variable ux undefined, line 18" );
            }
            uxc = (mccPR(&ux)[(l-1)*mccM(&ux) + (k-1)]);
            if(mccNOTSET(&uy))
            {
               mexErrMsgTxt( "variable uy undefined, line 18" );
            }
            uyc = (mccPR(&uy)[(l-1)*mccM(&uy) + (k-1)]);
            /* if uxc>=2 & uxc<=nx-1 & uyc>=2 & uyc<=ny-1, */
            B0_ = ( (uxc >= 2) && !mccREL_NAN(uxc) );
            if ((double)B0_)
            {
               B0_ = ( (uxc <= (nx - 1)) && !mccREL_NAN(uxc) );
            }
            B1_ = (double)B0_;
            if ((double)B1_)
            {
               B1_ = ( (uyc >= 2) && !mccREL_NAN(uyc) );
            }
            B2_ = (double)B1_;
            if ((double)B2_)
            {
               B2_ = ( (uyc <= (ny - 1)) && !mccREL_NAN(uyc) );
            }
            if ((double)B2_)
            {
               /* % ignore points outside  the image */
               /* % leave margin of 1 to allow for (bilinear interpolation) */
               /* rx=(l-1.5)/m+1 ; % coordinates in the control grid space */
               R0_ = (l - 1.5);
               {
                  int i_, j_;
                  int m_=1, n_=1, cx_ = 0;
                  double *p_rx;
                  int I_rx=1;
                  double *p_m;
                  int I_m=1;
                  m_ = mcmCalcResultSize(m_, &n_, mccM(&m), mccN(&m));
                  mccAllocateMatrix(&rx, m_, n_);
                  I_rx = (mccM(&rx) != 1 || mccN(&rx) != 1);
                  p_rx = mccPR(&rx);
                  I_m = (mccM(&m) != 1 || mccN(&m) != 1);
                  p_m = mccPR(&m);
                  if (m_ != 0)
                  {
                     for (j_=0; j_<n_; ++j_)
                     {
                        for (i_=0; i_<m_; ++i_, p_rx+=I_rx, p_m+=I_m)
                        {
                           *p_rx = ((R0_ / (double) *p_m) + 1);
                        }
                     }
                  }
               }
               /* ry=(k-1.5)/m+1 ; */
               R0_ = (k - 1.5);
               {
                  int i_, j_;
                  int m_=1, n_=1, cx_ = 0;
                  double *p_ry;
                  int I_ry=1;
                  double *p_m;
                  int I_m=1;
                  m_ = mcmCalcResultSize(m_, &n_, mccM(&m), mccN(&m));
                  mccAllocateMatrix(&ry, m_, n_);
                  I_ry = (mccM(&ry) != 1 || mccN(&ry) != 1);
                  p_ry = mccPR(&ry);
                  I_m = (mccM(&m) != 1 || mccN(&m) != 1);
                  p_m = mccPR(&m);
                  if (m_ != 0)
                  {
                     for (j_=0; j_<n_; ++j_)
                     {
                        for (i_=0; i_<m_; ++i_, p_ry+=I_ry, p_m+=I_m)
                        {
                           *p_ry = ((R0_ / (double) *p_m) + 1);
                        }
                     }
                  }
               }
               /* if rx>=1 & rx<=nsx & ry>=1 & ry<=nsy, % ignore points outside  the grid */
               {
                  int i_, j_;
                  int m_=1, n_=1, cx_ = 0;
                  unsigned short *p_BM0_;
                  int I_BM0_=1;
                  double *p_rx;
                  int I_rx=1;
                  m_ = mcmCalcResultSize(m_, &n_, mccM(&rx), mccN(&rx));
                  mccAllocateMatrix(&BM0_, m_, n_);
                  I_BM0_ = (mccM(&BM0_) != 1 || mccN(&BM0_) != 1);
                  p_BM0_ = mccSPR(&BM0_);
                  I_rx = (mccM(&rx) != 1 || mccN(&rx) != 1);
                  p_rx = mccPR(&rx);
                  if (m_ != 0)
                  {
                     for (j_=0; j_<n_; ++j_)
                     {
                        for (i_=0; i_<m_; ++i_, p_BM0_+=I_BM0_, p_rx+=I_rx)
                        {
                           *p_BM0_ = ( (*p_rx >= 1) && !mccREL_NAN(*p_rx) );
                        }
                     }
                  }
               }
               B2_ = mccIfCondition(&BM0_);
               if ((double)B2_)
               {
                  {
                     int i_, j_;
                     int m_=1, n_=1, cx_ = 0;
                     unsigned short *p_BM1_;
                     int I_BM1_=1;
                     double *p_rx;
                     int I_rx=1;
                     double *p_nsx;
                     int I_nsx=1;
                     m_ = mcmCalcResultSize(m_, &n_, mccM(&rx), mccN(&rx));
                     m_ = mcmCalcResultSize(m_, &n_, mccM(&nsx), mccN(&nsx));
                     mccAllocateMatrix(&BM1_, m_, n_);
                     I_BM1_ = (mccM(&BM1_) != 1 || mccN(&BM1_) != 1);
                     p_BM1_ = mccSPR(&BM1_);
                     I_rx = (mccM(&rx) != 1 || mccN(&rx) != 1);
                     p_rx = mccPR(&rx);
                     I_nsx = (mccM(&nsx) != 1 || mccN(&nsx) != 1);
                     p_nsx = mccPR(&nsx);
                     if (m_ != 0)
                     {
                        for (j_=0; j_<n_; ++j_)
                        {
                           for (i_=0; i_<m_; ++i_, p_BM1_+=I_BM1_, p_rx+=I_rx, p_nsx+=I_nsx)
                           {
                              *p_BM1_ = ( (*p_rx <= *p_nsx) && !mccREL_NAN(*p_rx) && !mccREL_NAN(*p_nsx) );
                           }
                        }
                     }
                  }
                  B2_ = mccIfCondition(&BM1_);
               }
               B1_ = (double)B2_;
               if ((double)B1_)
               {
                  {
                     int i_, j_;
                     int m_=1, n_=1, cx_ = 0;
                     unsigned short *p_BM2_;
                     int I_BM2_=1;
                     double *p_ry;
                     int I_ry=1;
                     m_ = mcmCalcResultSize(m_, &n_, mccM(&ry), mccN(&ry));
                     mccAllocateMatrix(&BM2_, m_, n_);
                     I_BM2_ = (mccM(&BM2_) != 1 || mccN(&BM2_) != 1);
                     p_BM2_ = mccSPR(&BM2_);
                     I_ry = (mccM(&ry) != 1 || mccN(&ry) != 1);
                     p_ry = mccPR(&ry);
                     if (m_ != 0)
                     {
                        for (j_=0; j_<n_; ++j_)
                        {
                           for (i_=0; i_<m_; ++i_, p_BM2_+=I_BM2_, p_ry+=I_ry)
                           {
                              *p_BM2_ = ( (*p_ry >= 1) && !mccREL_NAN(*p_ry) );
                           }
                        }
                     }
                  }
                  B1_ = mccIfCondition(&BM2_);
               }
               B0_ = (double)B1_;
               if ((double)B0_)
               {
                  {
                     int i_, j_;
                     int m_=1, n_=1, cx_ = 0;
                     unsigned short *p_BM3_;
                     int I_BM3_=1;
                     double *p_ry;
                     int I_ry=1;
                     double *p_nsy;
                     int I_nsy=1;
                     m_ = mcmCalcResultSize(m_, &n_, mccM(&ry), mccN(&ry));
                     m_ = mcmCalcResultSize(m_, &n_, mccM(&nsy), mccN(&nsy));
                     mccAllocateMatrix(&BM3_, m_, n_);
                     I_BM3_ = (mccM(&BM3_) != 1 || mccN(&BM3_) != 1);
                     p_BM3_ = mccSPR(&BM3_);
                     I_ry = (mccM(&ry) != 1 || mccN(&ry) != 1);
                     p_ry = mccPR(&ry);
                     I_nsy = (mccM(&nsy) != 1 || mccN(&nsy) != 1);
                     p_nsy = mccPR(&nsy);
                     if (m_ != 0)
                     {
                        for (j_=0; j_<n_; ++j_)
                        {
                           for (i_=0; i_<m_; ++i_, p_BM3_+=I_BM3_, p_ry+=I_ry, p_nsy+=I_nsy)
                           {
                              *p_BM3_ = ( (*p_ry <= *p_nsy) && !mccREL_NAN(*p_ry) && !mccREL_NAN(*p_nsy) );
                           }
                        }
                     }
                  }
                  B0_ = mccIfCondition(&BM3_);
               }
               if ((double)B0_)
               {
                  /* % Boundaries of influential control points */
                  /* lrx=max(1,ceil(rx-hbas)) ; */
                  {
                     int i_, j_;
                     int m_=1, n_=1, cx_ = 0;
                     double *p_RM0_;
                     int I_RM0_=1;
                     double *p_rx;
                     int I_rx=1;
                     int *p_hbas;
                     int I_hbas=1;
                     m_ = mcmCalcResultSize(m_, &n_, mccM(&rx), mccN(&rx));
                     m_ = mcmCalcResultSize(m_, &n_, mccM(&hbas), mccN(&hbas));
                     mccAllocateMatrix(&RM0_, m_, n_);
                     I_RM0_ = (mccM(&RM0_) != 1 || mccN(&RM0_) != 1);
                     p_RM0_ = mccPR(&RM0_);
                     I_rx = (mccM(&rx) != 1 || mccN(&rx) != 1);
                     p_rx = mccPR(&rx);
                     I_hbas = (mccM(&hbas) != 1 || mccN(&hbas) != 1);
                     p_hbas = mccIPR(&hbas);
                     if (m_ != 0)
                     {
                        for (j_=0; j_<n_; ++j_)
                        {
                           for (i_=0; i_<m_; ++i_, p_RM0_+=I_RM0_, p_rx+=I_rx, p_hbas+=I_hbas)
                           {
                              *p_RM0_ = (*p_rx - ((int)*p_hbas));
                           }
                        }
                     }
                  }
                  mccCeil(&RM1_, &RM0_);
                  Mprhs_[0] = mccTempMatrix(1, 0., mccINT, 0 );
                  Mprhs_[1] = &RM1_;
                  Mplhs_[0] = &lrx;
                  mccCallMATLAB(1, Mplhs_, 2, Mprhs_, "max", 26);
                  /* hrx=min(nsx,floor(rx-lbas)) ; */
                  {
                     int i_, j_;
                     int m_=1, n_=1, cx_ = 0;
                     double *p_RM1_;
                     int I_RM1_=1;
                     double *p_rx;
                     int I_rx=1;
                     int *p_lbas;
                     int I_lbas=1;
                     m_ = mcmCalcResultSize(m_, &n_, mccM(&rx), mccN(&rx));
                     m_ = mcmCalcResultSize(m_, &n_, mccM(&lbas), mccN(&lbas));
                     mccAllocateMatrix(&RM1_, m_, n_);
                     I_RM1_ = (mccM(&RM1_) != 1 || mccN(&RM1_) != 1);
                     p_RM1_ = mccPR(&RM1_);
                     I_rx = (mccM(&rx) != 1 || mccN(&rx) != 1);
                     p_rx = mccPR(&rx);
                     I_lbas = (mccM(&lbas) != 1 || mccN(&lbas) != 1);
                     p_lbas = mccIPR(&lbas);
                     if (m_ != 0)
                     {
                        for (j_=0; j_<n_; ++j_)
                        {
                           for (i_=0; i_<m_; ++i_, p_RM1_+=I_RM1_, p_rx+=I_rx, p_lbas+=I_lbas)
                           {
                              *p_RM1_ = (*p_rx - ((int)*p_lbas));
                           }
                        }
                     }
                  }
                  mccFloor(&RM0_, &RM1_);
                  Mprhs_[0] = &nsx;
                  Mprhs_[1] = &RM0_;
                  Mplhs_[0] = &hrx;
                  mccCallMATLAB(1, Mplhs_, 2, Mprhs_, "min", 27);
                  /* lry=max(1,ceil(ry-hbas)) ; */
                  {
                     int i_, j_;
                     int m_=1, n_=1, cx_ = 0;
                     double *p_RM0_;
                     int I_RM0_=1;
                     double *p_ry;
                     int I_ry=1;
                     int *p_hbas;
                     int I_hbas=1;
                     m_ = mcmCalcResultSize(m_, &n_, mccM(&ry), mccN(&ry));
                     m_ = mcmCalcResultSize(m_, &n_, mccM(&hbas), mccN(&hbas));
                     mccAllocateMatrix(&RM0_, m_, n_);
                     I_RM0_ = (mccM(&RM0_) != 1 || mccN(&RM0_) != 1);
                     p_RM0_ = mccPR(&RM0_);
                     I_ry = (mccM(&ry) != 1 || mccN(&ry) != 1);
                     p_ry = mccPR(&ry);
                     I_hbas = (mccM(&hbas) != 1 || mccN(&hbas) != 1);
                     p_hbas = mccIPR(&hbas);
                     if (m_ != 0)
                     {
                        for (j_=0; j_<n_; ++j_)
                        {
                           for (i_=0; i_<m_; ++i_, p_RM0_+=I_RM0_, p_ry+=I_ry, p_hbas+=I_hbas)
                           {
                              *p_RM0_ = (*p_ry - ((int)*p_hbas));
                           }
                        }
                     }
                  }
                  mccCeil(&RM1_, &RM0_);
                  Mprhs_[0] = mccTempMatrix(1, 0., mccINT, 0 );
                  Mprhs_[1] = &RM1_;
                  Mplhs_[0] = &lry;
                  mccCallMATLAB(1, Mplhs_, 2, Mprhs_, "max", 28);
                  /* hry=min(nsy,floor(ry-lbas)) ; */
                  {
                     int i_, j_;
                     int m_=1, n_=1, cx_ = 0;
                     double *p_RM1_;
                     int I_RM1_=1;
                     double *p_ry;
                     int I_ry=1;
                     int *p_lbas;
                     int I_lbas=1;
                     m_ = mcmCalcResultSize(m_, &n_, mccM(&ry), mccN(&ry));
                     m_ = mcmCalcResultSize(m_, &n_, mccM(&lbas), mccN(&lbas));
                     mccAllocateMatrix(&RM1_, m_, n_);
                     I_RM1_ = (mccM(&RM1_) != 1 || mccN(&RM1_) != 1);
                     p_RM1_ = mccPR(&RM1_);
                     I_ry = (mccM(&ry) != 1 || mccN(&ry) != 1);
                     p_ry = mccPR(&ry);
                     I_lbas = (mccM(&lbas) != 1 || mccN(&lbas) != 1);
                     p_lbas = mccIPR(&lbas);
                     if (m_ != 0)
                     {
                        for (j_=0; j_<n_; ++j_)
                        {
                           for (i_=0; i_<m_; ++i_, p_RM1_+=I_RM1_, p_ry+=I_ry, p_lbas+=I_lbas)
                           {
                              *p_RM1_ = (*p_ry - ((int)*p_lbas));
                           }
                        }
                     }
                  }
                  mccFloor(&RM0_, &RM1_);
                  Mprhs_[0] = &nsy;
                  Mprhs_[1] = &RM0_;
                  Mplhs_[0] = &hry;
                  mccCallMATLAB(1, Mplhs_, 2, Mprhs_, "min", 29);
                  /* gx=grx(k,l) ; */
                  gx = (mccPR(&grx)[(l-1)*mccM(&grx) + (k-1)]);
                  /* gy=gry(k,l) ; */
                  if(mccNOTSET(&gry))
                  {
                     mexErrMsgTxt( "variable gry undefined, line 31" );
                  }
                  gy = (mccPR(&gry)[(l-1)*mccM(&gry) + (k-1)]);
                  
                  /* % For all influential parameters */
                  /* du=0 ; dv=0 ; */
                  {
                     double tr_ = 0;
                     mccAllocateMatrix(&du, 1, 1);
                     *mccPR(&du) = tr_;
                  }
                  {
                     double tr_ = 0;
                     mccAllocateMatrix(&dv, 1, 1);
                     *mccPR(&dv) = tr_;
                  }
                  /* for ll=lrx:hrx, */
                  mccColon2(&RM0_, (*mccPR(&lrx)), (*mccPR(&hrx)));
                  for (I2_ = 0; I2_ < mccN(&RM0_); ++I2_)
                  {
                     ll = mccPR(&RM0_)[I2_];
                     /* for kk=lry:hry, */
                     mccColon2(&RM1_, (*mccPR(&lry)), (*mccPR(&hry)));
                     for (I3_ = 0; I3_ < mccN(&RM1_); ++I3_)
                     {
                        kk = mccPR(&RM1_)[I3_];
                        /* ind=2*((ll-1)*nsy+kk)-1 ; */
                        R0_ = (ll - 1);
                        {
                           int i_, j_;
                           int m_=1, n_=1, cx_ = 0;
                           double *p_ind;
                           int I_ind=1;
                           double *p_nsy;
                           int I_nsy=1;
                           m_ = mcmCalcResultSize(m_, &n_, mccM(&nsy), mccN(&nsy));
                           mccAllocateMatrix(&ind, m_, n_);
                           I_ind = (mccM(&ind) != 1 || mccN(&ind) != 1);
                           p_ind = mccPR(&ind);
                           I_nsy = (mccM(&nsy) != 1 || mccN(&nsy) != 1);
                           p_nsy = mccPR(&nsy);
                           if (m_ != 0)
                           {
                              for (j_=0; j_<n_; ++j_)
                              {
                                 for (i_=0; i_<m_; ++i_, p_ind+=I_ind, p_nsy+=I_nsy)
                                 {
                                    *p_ind = ((2 * (double) ((R0_ * (double) *p_nsy) + kk)) - 1);
                                 }
                              }
                           }
                        }
                        /* wij=szbas(rx-ll,ry-kk,t) ; */
                        {
                           int i_, j_;
                           int m_=1, n_=1, cx_ = 0;
                           double *p_RM2_;
                           int I_RM2_=1;
                           double *p_rx;
                           int I_rx=1;
                           m_ = mcmCalcResultSize(m_, &n_, mccM(&rx), mccN(&rx));
                           mccAllocateMatrix(&RM2_, m_, n_);
                           I_RM2_ = (mccM(&RM2_) != 1 || mccN(&RM2_) != 1);
                           p_RM2_ = mccPR(&RM2_);
                           I_rx = (mccM(&rx) != 1 || mccN(&rx) != 1);
                           p_rx = mccPR(&rx);
                           if (m_ != 0)
                           {
                              for (j_=0; j_<n_; ++j_)
                              {
                                 for (i_=0; i_<m_; ++i_, p_RM2_+=I_RM2_, p_rx+=I_rx)
                                 {
                                    *p_RM2_ = (*p_rx - ll);
                                 }
                              }
                           }
                        }
                        {
                           int i_, j_;
                           int m_=1, n_=1, cx_ = 0;
                           double *p_RM3_;
                           int I_RM3_=1;
                           double *p_ry;
                           int I_ry=1;
                           m_ = mcmCalcResultSize(m_, &n_, mccM(&ry), mccN(&ry));
                           mccAllocateMatrix(&RM3_, m_, n_);
                           I_RM3_ = (mccM(&RM3_) != 1 || mccN(&RM3_) != 1);
                           p_RM3_ = mccPR(&RM3_);
                           I_ry = (mccM(&ry) != 1 || mccN(&ry) != 1);
                           p_ry = mccPR(&ry);
                           if (m_ != 0)
                           {
                              for (j_=0; j_<n_; ++j_)
                              {
                                 for (i_=0; i_<m_; ++i_, p_RM3_+=I_RM3_, p_ry+=I_ry)
                                 {
                                    *p_RM3_ = (*p_ry - kk);
                                 }
                              }
                           }
                        }
                        Mprhs_[0] = &RM2_;
                        Mprhs_[1] = &RM3_;
                        Mprhs_[2] = &t;
                        Mplhs_[0] = &wij;
                        mccCallMATLAB(1, Mplhs_, 3, Mprhs_, "szbas", 38);
                        /* du=du+wij*d(ind) ; */
                        if(mccNOTSET(&d))
                        {
                           mexErrMsgTxt( "variable d undefined, line 39" );
                        }
                        mccFindIndex(&IM0_, &ind);
                        {
                           int i_, j_;
                           int m_=1, n_=1, cx_ = 0;
                           double *p_RM3_;
                           int I_RM3_=1;
                           double *p_d;
                           int *p_IM0_;
                           int I_IM0_=1;
                           m_ = mccCalcSubscriptDimensions(m_, &n_, mccM(&IM0_), mccN(&IM0_), &d);
                           mccAllocateMatrix(&RM3_, m_, n_);
                           I_RM3_ = (mccM(&RM3_) != 1 || mccN(&RM3_) != 1);
                           p_RM3_ = mccPR(&RM3_);
                           I_IM0_ = (mccM(&IM0_) != 1 || mccN(&IM0_) != 1);
                           p_IM0_ = mccIPR(&IM0_);
                           if (m_ != 0)
                           {
                              for (j_=0; j_<n_; ++j_)
                              {
                                 for (i_=0; i_<m_; ++i_, p_RM3_+=I_RM3_, p_IM0_+=I_IM0_)
                                 {
                                    *p_RM3_ = mccPR(&d)[((int)(*p_IM0_ - .5))];
                                 }
                              }
                           }
                        }
                        mccRealMatrixMultiply(&RM2_, &wij, &RM3_);
                        {
                           int i_, j_;
                           int m_=1, n_=1, cx_ = 0;
                           double *p_du;
                           int I_du=1;
                           double *p_1du;
                           int I_1du=1;
                           double *p_RM2_;
                           int I_RM2_=1;
                           m_ = mcmCalcResultSize(m_, &n_, mccM(&du), mccN(&du));
                           m_ = mcmCalcResultSize(m_, &n_, mccM(&RM2_), mccN(&RM2_));
                           mccAllocateMatrix(&du, m_, n_);
                           I_du = (mccM(&du) != 1 || mccN(&du) != 1);
                           p_du = mccPR(&du);
                           I_1du = (mccM(&du) != 1 || mccN(&du) != 1);
                           p_1du = mccPR(&du);
                           I_RM2_ = (mccM(&RM2_) != 1 || mccN(&RM2_) != 1);
                           p_RM2_ = mccPR(&RM2_);
                           if (m_ != 0)
                           {
                              for (j_=0; j_<n_; ++j_)
                              {
                                 for (i_=0; i_<m_; ++i_, p_du+=I_du, p_1du+=I_1du, p_RM2_+=I_RM2_)
                                 {
                                    *p_du = (*p_1du + *p_RM2_);
                                 }
                              }
                           }
                        }
                        /* dv=dv+wij*d(ind+1) ; */
                        {
                           int i_, j_;
                           int m_=1, n_=1, cx_ = 0;
                           double *p_RM2_;
                           int I_RM2_=1;
                           double *p_ind;
                           int I_ind=1;
                           m_ = mcmCalcResultSize(m_, &n_, mccM(&ind), mccN(&ind));
                           mccAllocateMatrix(&RM2_, m_, n_);
                           I_RM2_ = (mccM(&RM2_) != 1 || mccN(&RM2_) != 1);
                           p_RM2_ = mccPR(&RM2_);
                           I_ind = (mccM(&ind) != 1 || mccN(&ind) != 1);
                           p_ind = mccPR(&ind);
                           if (m_ != 0)
                           {
                              for (j_=0; j_<n_; ++j_)
                              {
                                 for (i_=0; i_<m_; ++i_, p_RM2_+=I_RM2_, p_ind+=I_ind)
                                 {
                                    *p_RM2_ = (*p_ind + 1);
                                 }
                              }
                           }
                        }
                        mccLOG(&RM2_) = 0;
                        mccFindIndex(&IM0_, &RM2_);
                        {
                           int i_, j_;
                           int m_=1, n_=1, cx_ = 0;
                           double *p_RM3_;
                           int I_RM3_=1;
                           double *p_d;
                           int *p_IM0_;
                           int I_IM0_=1;
                           m_ = mccCalcSubscriptDimensions(m_, &n_, mccM(&IM0_), mccN(&IM0_), &d);
                           mccAllocateMatrix(&RM3_, m_, n_);
                           I_RM3_ = (mccM(&RM3_) != 1 || mccN(&RM3_) != 1);
                           p_RM3_ = mccPR(&RM3_);
                           I_IM0_ = (mccM(&IM0_) != 1 || mccN(&IM0_) != 1);
                           p_IM0_ = mccIPR(&IM0_);
                           if (m_ != 0)
                           {
                              for (j_=0; j_<n_; ++j_)
                              {
                                 for (i_=0; i_<m_; ++i_, p_RM3_+=I_RM3_, p_IM0_+=I_IM0_)
                                 {
                                    *p_RM3_ = mccPR(&d)[((int)(*p_IM0_ - .5))];
                                 }
                              }
                           }
                        }
                        mccRealMatrixMultiply(&RM4_, &wij, &RM3_);
                        {
                           int i_, j_;
                           int m_=1, n_=1, cx_ = 0;
                           double *p_dv;
                           int I_dv=1;
                           double *p_1dv;
                           int I_1dv=1;
                           double *p_RM4_;
                           int I_RM4_=1;
                           m_ = mcmCalcResultSize(m_, &n_, mccM(&dv), mccN(&dv));
                           m_ = mcmCalcResultSize(m_, &n_, mccM(&RM4_), mccN(&RM4_));
                           mccAllocateMatrix(&dv, m_, n_);
                           I_dv = (mccM(&dv) != 1 || mccN(&dv) != 1);
                           p_dv = mccPR(&dv);
                           I_1dv = (mccM(&dv) != 1 || mccN(&dv) != 1);
                           p_1dv = mccPR(&dv);
                           I_RM4_ = (mccM(&RM4_) != 1 || mccN(&RM4_) != 1);
                           p_RM4_ = mccPR(&RM4_);
                           if (m_ != 0)
                           {
                              for (j_=0; j_<n_; ++j_)
                              {
                                 for (i_=0; i_<m_; ++i_, p_dv+=I_dv, p_1dv+=I_1dv, p_RM4_+=I_RM4_)
                                 {
                                    *p_dv = (*p_1dv + *p_RM4_);
                                 }
                              }
                           }
                        }
                        /* end ; % for ll */
                     }
                     /* end ;  % for kk */
                  }
                  /* dAd=dAd+(gx*du+gy*dv)^2 ; */
                  {
                     int i_, j_;
                     int m_=1, n_=1, cx_ = 0;
                     double *p_RM0_;
                     int I_RM0_=1;
                     double *p_du;
                     int I_du=1;
                     double *p_dv;
                     int I_dv=1;
                     m_ = mcmCalcResultSize(m_, &n_, mccM(&du), mccN(&du));
                     m_ = mcmCalcResultSize(m_, &n_, mccM(&dv), mccN(&dv));
                     mccAllocateMatrix(&RM0_, m_, n_);
                     I_RM0_ = (mccM(&RM0_) != 1 || mccN(&RM0_) != 1);
                     p_RM0_ = mccPR(&RM0_);
                     I_du = (mccM(&du) != 1 || mccN(&du) != 1);
                     p_du = mccPR(&du);
                     I_dv = (mccM(&dv) != 1 || mccN(&dv) != 1);
                     p_dv = mccPR(&dv);
                     if (m_ != 0)
                     {
                        for (j_=0; j_<n_; ++j_)
                        {
                           for (i_=0; i_<m_; ++i_, p_RM0_+=I_RM0_, p_du+=I_du, p_dv+=I_dv)
                           {
                              *p_RM0_ = ((gx * (double) *p_du) + (gy * (double) *p_dv));
                           }
                        }
                     }
                  }
                  mccPower(&RM1_, &RM0_, mccTempMatrix(2, 0., mccINT, 0 ));
                  {
                     int i_, j_;
                     int m_=1, n_=1, cx_ = 0;
                     double *p_dAd;
                     int I_dAd=1;
                     double *p_1dAd;
                     int I_1dAd=1;
                     double *p_RM1_;
                     int I_RM1_=1;
                     m_ = mcmCalcResultSize(m_, &n_, mccM(&dAd), mccN(&dAd));
                     m_ = mcmCalcResultSize(m_, &n_, mccM(&RM1_), mccN(&RM1_));
                     mccAllocateMatrix(&dAd, m_, n_);
                     I_dAd = (mccM(&dAd) != 1 || mccN(&dAd) != 1);
                     p_dAd = mccPR(&dAd);
                     I_1dAd = (mccM(&dAd) != 1 || mccN(&dAd) != 1);
                     p_1dAd = mccPR(&dAd);
                     I_RM1_ = (mccM(&RM1_) != 1 || mccN(&RM1_) != 1);
                     p_RM1_ = mccPR(&RM1_);
                     if (m_ != 0)
                     {
                        for (j_=0; j_<n_; ++j_)
                        {
                           for (i_=0; i_<m_; ++i_, p_dAd+=I_dAd, p_1dAd+=I_1dAd, p_RM1_+=I_RM1_)
                           {
                              *p_dAd = (*p_1dAd + *p_RM1_);
                           }
                        }
                     }
                  }
                  
                  /* end ; % if rx>=1 ... */
               }
               /* end ; % if uxc<1 ...    */
            }
            /* end ;	% for l  */
         }
         /* end ; % for k */
      }
      mccReturnFirstValue(&plhs_[0], &dAd);
   }
   return;
}
