static char mc_version[] = "MATLAB Compiler 1.2 Jan 17 1998 infun";
/*
 *  MATLAB Compiler: 1.2
 *  Date: Jan 17 1998
 *  Arguments: -irh szdispd 
 */
#ifndef ARRAY_ACCESS_INLINING
#error You must use the -inline option when compiling MATLAB compiler generated code with MEX or MBUILD
#endif
#ifndef MATLAB_COMPILER_GENERATED_CODE
#define MATLAB_COMPILER_GENERATED_CODE
#endif

#include <math.h>
#include "mex.h"
#include "mcc.h"

static void szdisp_(mxArray *, mxArray *, int, int, mxArray *, mxArray *);
static void szbas_(mxArray *,mxArray *,mxArray *, int, int, mxArray *);
static void szbas__1(mxArray *, mxArray *, mxArray *, mxArray *);
/* static array S0_ (1 x 5) int, line 9 */
static int S0r_[] =
{
	0, -1, -1, -1, -1, 
};
static mxArray S0_ = mccCINIT( mccINT, 1, 5, S0r_, 0 );
/* static array S1_ (1 x 5) int, line 10 */
static int S1r_[] =
{
	1, 1, 1, 
	1, 2, 
};
static mxArray S1_ = mccCINIT( mccINT, 1, 5, S1r_, 0 );
static void qbspln_(mxArray *, mxArray *);
/* static array S2_ (1 x 5) int, line 9 */
static int S2r_[] =
{
	0, -1, -1, -1, -1, 
};
static mxArray S2_ = mccCINIT( mccINT, 1, 5, S2r_, 0 );
/* static array S3_ (1 x 5) int, line 10 */
static int S3r_[] =
{
	1, 
	1, 1, 1, 2, 
};
static mxArray S3_ = mccCINIT( mccINT, 1, 5, S3r_, 0 );
static void qbspln__1(double *, double);
/***************** Compiler Assumptions ****************
 *
 *       I0_         	integer scalar temporary
 *       i           	integer scalar
 *       m           	real vector/matrix
 *       nx          	integer scalar
 *       ny          	integer scalar
 *       sx          	real vector/matrix
 *       sy          	real vector/matrix
 *       szdisp      	<function>
 *       szdispd     	<function being defined>
 *       t           	real vector/matrix
 *       ux          	real vector/matrix
 *       uy          	real vector/matrix
 *******************************************************/

void
mexFunction(
    int nlhs_,
    mxArray *plhs_[],
    int nrhs_,
    const mxArray *prhs_[]
)
{
   

   if (nrhs_ > 6 )
   {
      mexErrMsgTxt( "Too many input arguments." );
   }

   if (nlhs_ > 2 )
   {
      mexErrMsgTxt( "Too many output arguments." );
   }

   {
      mxArray ux;
      mxArray uy;
      mxArray sx;
      mxArray sy;
      int nx = 0;
      int nx_set_ = 0;
      int ny = 0;
      int ny_set_ = 0;
      mxArray m;
      mxArray t;
      int i = 0;
      int I0_ = 0;
      
      mccRealInit(sx);
      mccImport(&sx, ((nrhs_>0) ? prhs_[0] : 0), 0, 0);
      mccRealInit(sy);
      mccImport(&sy, ((nrhs_>1) ? prhs_[1] : 0), 0, 0);
      nx = mccImportReal(&nx_set_, 0, (mxArray *) ((nrhs_>2) ? prhs_[2] : 0), 0, "nx");
      ny = mccImportReal(&ny_set_, 0, (mxArray *) ((nrhs_>3) ? prhs_[3] : 0), 0, "ny");
      mccRealInit(m);
      mccImport(&m, ((nrhs_>4) ? prhs_[4] : 0), 0, 0);
      mccRealInit(t);
      mccImport(&t, ((nrhs_>5) ? prhs_[5] : 0), 0, 0);
      mccRealInit(ux);
      mccRealInit(uy);
      
      /* % Given control point positions sx,sy calculate the displacement fields for  */
      /* % a nx times ny size image, subsampling factor m and basis function type t. */
      /* % For the Szelinski, Coughlan algorithm. */
      
      /* % Jan Kybic, February 1999 */
      
      /* % Usage: [ux,uy]=szdispd(sx,sy,nx,ny,m,t) ; */
      
      /* ux=szdisp(sx,nx,ny,m,t) ; */
      if(mccNOTSET(&sx))
      {
         mexErrMsgTxt( "variable sx undefined, line 10" );
      }
      if( !nx_set_ )
      {
         mexErrMsgTxt( "variable nx undefined, line 10" );
      }
      if( !ny_set_ )
      {
         mexErrMsgTxt( "variable ny undefined, line 10" );
      }
      if(mccNOTSET(&m))
      {
         mexErrMsgTxt( "variable m undefined, line 10" );
      }
      if(mccNOTSET(&t))
      {
         mexErrMsgTxt( "variable t undefined, line 10" );
      }
      szdisp_(&ux, &sx, nx, ny, &m, &t);
      /* uy=szdisp(sy,nx,ny,m,t) ; */
      if(mccNOTSET(&sy))
      {
         mexErrMsgTxt( "variable sy undefined, line 11" );
      }
      szdisp_(&uy, &sy, nx, ny, &m, &t);
      
      /* % now ux,uy contain the offset; add the unit transform */
      
      /* for i=1:ny, */
      for (I0_ = 1; I0_ <= ny; I0_ = I0_ + 1)
      {
         i = I0_;
         /* uy(i,:)=uy(i,:)+i ; */
         {
            int i_, j_;
            int m_=1, n_=1, cx_ = 0;
            double *p_uy;
            int I_uy=1, J_uy;
            double *p_1uy;
            int I_1uy=1, J_1uy;
            m_ = mcmCalcResultSize(m_, &n_, 1, mccN(&uy));
            if (mccN(&uy) == 1) { I_uy = J_uy = 0;}
            else { I_uy = 1; J_uy=mccM(&uy)-m_; }
            p_uy = mccPR(&uy) + (i-1) + mccM(&uy) * 0;
            if (mccN(&uy) == 1) { I_1uy = J_1uy = 0;}
            else { I_1uy = 1; J_1uy=mccM(&uy)-m_; }
            p_1uy = mccPR(&uy) + (i-1) + mccM(&uy) * 0;
            if (m_ != 0)
            {
               for (j_=0; j_<n_; ++j_, p_uy += J_uy, p_1uy += J_1uy)
               {
                  for (i_=0; i_<m_; ++i_, p_uy+=I_uy, p_1uy+=I_1uy)
                  {
                     *p_uy = (*p_1uy + i);
                  }
               }
            }
         }
         /* end ; */
      }
      
      /* for i=1:nx, */
      for (I0_ = 1; I0_ <= nx; I0_ = I0_ + 1)
      {
         i = I0_;
         /* ux(:,i)=ux(:,i)+i ; */
         {
            int i_, j_;
            int m_=1, n_=1, cx_ = 0;
            double *p_ux;
            int I_ux=1, J_ux;
            double *p_1ux;
            int I_1ux=1, J_1ux;
            m_ = mcmCalcResultSize(m_, &n_, mccM(&ux), 1);
            if (mccM(&ux) == 1) { I_ux = J_ux = 0;}
            else { I_ux = 1; J_ux=mccM(&ux)-m_; }
            p_ux = mccPR(&ux) + 0 + mccM(&ux) * (i-1);
            if (mccM(&ux) == 1) { I_1ux = J_1ux = 0;}
            else { I_1ux = 1; J_1ux=mccM(&ux)-m_; }
            p_1ux = mccPR(&ux) + 0 + mccM(&ux) * (i-1);
            if (m_ != 0)
            {
               for (j_=0; j_<n_; ++j_, p_ux += J_ux, p_1ux += J_1ux)
               {
                  for (i_=0; i_<m_; ++i_, p_ux+=I_ux, p_1ux+=I_1ux)
                  {
                     *p_ux = (*p_1ux + i);
                  }
               }
            }
         }
         /* end ; */
      }
      mccReturnFirstValue(&plhs_[0], &ux);
      mccReturnValue(&plhs_[1], &uy);
   }
   return;
}
/*
R = szdisp(RiiRR)
*/
/***************** Compiler Assumptions ****************
 *
 *       I0_         	integer scalar temporary
 *       I1_         	integer scalar temporary
 *       I2_         	integer scalar temporary
 *       I3_         	integer scalar temporary
 *       R0_         	real scalar temporary
 *       RM0_        	real vector/matrix temporary
 *       RM1_        	real vector/matrix temporary
 *       RM2_        	real vector/matrix temporary
 *       RM3_        	real vector/matrix temporary
 *       RM4_        	real vector/matrix temporary
 *       ceil        	<function>
 *       floor       	<function>
 *       h           	integer vector/matrix
 *       hrx         	real vector/matrix
 *       hry         	real vector/matrix
 *       i           	integer scalar
 *       j           	integer scalar
 *       k           	real scalar
 *       kk          	real scalar
 *       l           	integer vector/matrix
 *       lrx         	real vector/matrix
 *       lry         	real vector/matrix
 *       m           	real vector/matrix
 *       max         	<function>
 *       min         	<function>
 *       nrx         	integer scalar
 *       nry         	integer scalar
 *       nx          	integer scalar
 *       ny          	integer scalar
 *       rx          	real vector/matrix
 *       ry          	real vector/matrix
 *       s           	real vector/matrix
 *       size        	<function>
 *       szbas       	<function>
 *       szdisp      	<function being defined>
 *       t           	real vector/matrix
 *       u           	real vector/matrix
 *       w           	real vector/matrix
 *       zeros       	<function>
 *******************************************************/
static void szdisp_(mxArray *u_PP_, mxArray *s_P_, int nx, int ny, mxArray *m_P_, mxArray *t_P_ )
{
   mxArray *Mplhs_[2];
   mxArray *Mprhs_[2];
   mxArray u;
   mxArray w;
   mxArray l;
   mxArray h;
   int nry = 0;
   int nrx = 0;
   int i = 0;
   int j = 0;
   mxArray rx;
   mxArray ry;
   mxArray lrx;
   mxArray hrx;
   mxArray lry;
   mxArray hry;
   double k = 0.0;
   double kk = 0.0;
   int I0_ = 0;
   int I1_ = 0;
   double R0_ = 0.0;
   mxArray RM0_;
   mxArray RM1_;
   int I2_ = 0;
   int I3_ = 0;
   mxArray RM2_;
   mxArray RM3_;
   mxArray RM4_;
   
   mccRealInit(u);
   mccRealInit(w);
   mccIntInit(l);
   mccIntInit(h);
   mccRealInit(rx);
   mccRealInit(ry);
   mccRealInit(lrx);
   mccRealInit(hrx);
   mccRealInit(lry);
   mccRealInit(hry);
   mccRealInit(RM0_);
   mccRealInit(RM1_);
   mccRealInit(RM2_);
   mccRealInit(RM3_);
   mccRealInit(RM4_);
   
   /* % Given control point positions s, calculate the displacement field for  */
   /* % a nx times ny size image, subsampling factor m and basis function type t. */
   /* % For the Szelinski, Coughlan algorithm. */
   
   /* % Jan Kybic, February 1999 */
   
   /* % Usage: u=szdisp(s,nx,ny,m,t) ; */
   
   /* [w,l,h]=szbas(0,0,t) ; % get the support size */
   szbas_(&w,&l,&h, 0, 0, t_P_);
   
   /* [nry nrx]=size(s) ; */
   mccGetMatrixSize(&nry,&nrx, s_P_);
   
   /* u=zeros(ny,nx) ; */
   mccZerosMN(&u, ny, nx);
   mccLOG(&u) = 0;
   mccSTRING(&u) = 0;
   
   /* for i=1:nx,    % columns */
   for (I0_ = 1; I0_ <= nx; I0_ = I0_ + 1)
   {
      i = I0_;
      /* for j=1:ny,  % rows */
      for (I1_ = 1; I1_ <= ny; I1_ = I1_ + 1)
      {
         j = I1_;
         /* rx=(i-1.5)/m+1 ; */
         R0_ = (i - 1.5);
         {
            int i_, j_;
            int m_=1, n_=1, cx_ = 0;
            double *p_rx;
            int I_rx=1;
            double *p_m;
            int I_m=1;
            m_ = mcmCalcResultSize(m_, &n_, mccM(m_P_), mccN(m_P_));
            mccAllocateMatrix(&rx, m_, n_);
            I_rx = (mccM(&rx) != 1 || mccN(&rx) != 1);
            p_rx = mccPR(&rx);
            I_m = (mccM(m_P_) != 1 || mccN(m_P_) != 1);
            p_m = mccPR(m_P_);
            if (m_ != 0)
            {
               for (j_=0; j_<n_; ++j_)
               {
                  for (i_=0; i_<m_; ++i_, p_rx+=I_rx, p_m+=I_m)
                  {
                     *p_rx = ((R0_ / (double) *p_m) + 1);
                  }
               }
            }
         }
         /* ry=(j-1.5)/m+1 ; */
         R0_ = (j - 1.5);
         {
            int i_, j_;
            int m_=1, n_=1, cx_ = 0;
            double *p_ry;
            int I_ry=1;
            double *p_m;
            int I_m=1;
            m_ = mcmCalcResultSize(m_, &n_, mccM(m_P_), mccN(m_P_));
            mccAllocateMatrix(&ry, m_, n_);
            I_ry = (mccM(&ry) != 1 || mccN(&ry) != 1);
            p_ry = mccPR(&ry);
            I_m = (mccM(m_P_) != 1 || mccN(m_P_) != 1);
            p_m = mccPR(m_P_);
            if (m_ != 0)
            {
               for (j_=0; j_<n_; ++j_)
               {
                  for (i_=0; i_<m_; ++i_, p_ry+=I_ry, p_m+=I_m)
                  {
                     *p_ry = ((R0_ / (double) *p_m) + 1);
                  }
               }
            }
         }
         /* lrx=max(1,ceil(rx-h)) ; */
         {
            int i_, j_;
            int m_=1, n_=1, cx_ = 0;
            double *p_RM0_;
            int I_RM0_=1;
            double *p_rx;
            int I_rx=1;
            int *p_h;
            int I_h=1;
            m_ = mcmCalcResultSize(m_, &n_, mccM(&rx), mccN(&rx));
            m_ = mcmCalcResultSize(m_, &n_, mccM(&h), mccN(&h));
            mccAllocateMatrix(&RM0_, m_, n_);
            I_RM0_ = (mccM(&RM0_) != 1 || mccN(&RM0_) != 1);
            p_RM0_ = mccPR(&RM0_);
            I_rx = (mccM(&rx) != 1 || mccN(&rx) != 1);
            p_rx = mccPR(&rx);
            I_h = (mccM(&h) != 1 || mccN(&h) != 1);
            p_h = mccIPR(&h);
            if (m_ != 0)
            {
               for (j_=0; j_<n_; ++j_)
               {
                  for (i_=0; i_<m_; ++i_, p_RM0_+=I_RM0_, p_rx+=I_rx, p_h+=I_h)
                  {
                     *p_RM0_ = (*p_rx - ((int)*p_h));
                  }
               }
            }
         }
         mccCeil(&RM1_, &RM0_);
         Mprhs_[0] = mccTempMatrix(1, 0., mccINT, 0 );
         Mprhs_[1] = &RM1_;
         Mplhs_[0] = &lrx;
         mccCallMATLAB(1, Mplhs_, 2, Mprhs_, "max", 20);
         /* hrx=min(nrx,floor(rx-l)) ; */
         {
            int i_, j_;
            int m_=1, n_=1, cx_ = 0;
            double *p_RM1_;
            int I_RM1_=1;
            double *p_rx;
            int I_rx=1;
            int *p_l;
            int I_l=1;
            m_ = mcmCalcResultSize(m_, &n_, mccM(&rx), mccN(&rx));
            m_ = mcmCalcResultSize(m_, &n_, mccM(&l), mccN(&l));
            mccAllocateMatrix(&RM1_, m_, n_);
            I_RM1_ = (mccM(&RM1_) != 1 || mccN(&RM1_) != 1);
            p_RM1_ = mccPR(&RM1_);
            I_rx = (mccM(&rx) != 1 || mccN(&rx) != 1);
            p_rx = mccPR(&rx);
            I_l = (mccM(&l) != 1 || mccN(&l) != 1);
            p_l = mccIPR(&l);
            if (m_ != 0)
            {
               for (j_=0; j_<n_; ++j_)
               {
                  for (i_=0; i_<m_; ++i_, p_RM1_+=I_RM1_, p_rx+=I_rx, p_l+=I_l)
                  {
                     *p_RM1_ = (*p_rx - ((int)*p_l));
                  }
               }
            }
         }
         mccFloor(&RM0_, &RM1_);
         Mprhs_[0] = mccTempMatrix(nrx, 0., mccINT, 0 );
         Mprhs_[1] = &RM0_;
         Mplhs_[0] = &hrx;
         mccCallMATLAB(1, Mplhs_, 2, Mprhs_, "min", 21);
         /* lry=max(1,ceil(ry-h)) ; */
         {
            int i_, j_;
            int m_=1, n_=1, cx_ = 0;
            double *p_RM0_;
            int I_RM0_=1;
            double *p_ry;
            int I_ry=1;
            int *p_h;
            int I_h=1;
            m_ = mcmCalcResultSize(m_, &n_, mccM(&ry), mccN(&ry));
            m_ = mcmCalcResultSize(m_, &n_, mccM(&h), mccN(&h));
            mccAllocateMatrix(&RM0_, m_, n_);
            I_RM0_ = (mccM(&RM0_) != 1 || mccN(&RM0_) != 1);
            p_RM0_ = mccPR(&RM0_);
            I_ry = (mccM(&ry) != 1 || mccN(&ry) != 1);
            p_ry = mccPR(&ry);
            I_h = (mccM(&h) != 1 || mccN(&h) != 1);
            p_h = mccIPR(&h);
            if (m_ != 0)
            {
               for (j_=0; j_<n_; ++j_)
               {
                  for (i_=0; i_<m_; ++i_, p_RM0_+=I_RM0_, p_ry+=I_ry, p_h+=I_h)
                  {
                     *p_RM0_ = (*p_ry - ((int)*p_h));
                  }
               }
            }
         }
         mccCeil(&RM1_, &RM0_);
         Mprhs_[0] = mccTempMatrix(1, 0., mccINT, 0 );
         Mprhs_[1] = &RM1_;
         Mplhs_[0] = &lry;
         mccCallMATLAB(1, Mplhs_, 2, Mprhs_, "max", 22);
         /* hry=min(nry,floor(ry-l)) ; */
         {
            int i_, j_;
            int m_=1, n_=1, cx_ = 0;
            double *p_RM1_;
            int I_RM1_=1;
            double *p_ry;
            int I_ry=1;
            int *p_l;
            int I_l=1;
            m_ = mcmCalcResultSize(m_, &n_, mccM(&ry), mccN(&ry));
            m_ = mcmCalcResultSize(m_, &n_, mccM(&l), mccN(&l));
            mccAllocateMatrix(&RM1_, m_, n_);
            I_RM1_ = (mccM(&RM1_) != 1 || mccN(&RM1_) != 1);
            p_RM1_ = mccPR(&RM1_);
            I_ry = (mccM(&ry) != 1 || mccN(&ry) != 1);
            p_ry = mccPR(&ry);
            I_l = (mccM(&l) != 1 || mccN(&l) != 1);
            p_l = mccIPR(&l);
            if (m_ != 0)
            {
               for (j_=0; j_<n_; ++j_)
               {
                  for (i_=0; i_<m_; ++i_, p_RM1_+=I_RM1_, p_ry+=I_ry, p_l+=I_l)
                  {
                     *p_RM1_ = (*p_ry - ((int)*p_l));
                  }
               }
            }
         }
         mccFloor(&RM0_, &RM1_);
         Mprhs_[0] = mccTempMatrix(nry, 0., mccINT, 0 );
         Mprhs_[1] = &RM0_;
         Mplhs_[0] = &hry;
         mccCallMATLAB(1, Mplhs_, 2, Mprhs_, "min", 23);
         /* for k=lrx:hrx, */
         mccColon2(&RM0_, (*mccPR(&lrx)), (*mccPR(&hrx)));
         for (I2_ = 0; I2_ < mccN(&RM0_); ++I2_)
         {
            k = mccPR(&RM0_)[I2_];
            /* for kk=lry:hry, */
            mccColon2(&RM1_, (*mccPR(&lry)), (*mccPR(&hry)));
            for (I3_ = 0; I3_ < mccN(&RM1_); ++I3_)
            {
               kk = mccPR(&RM1_)[I3_];
               /* u(j,i)=u(j,i)+s(kk,k)*szbas(rx-k,ry-kk,t) ; */
               {
                  int i_, j_;
                  int m_=1, n_=1, cx_ = 0;
                  double *p_RM2_;
                  int I_RM2_=1;
                  double *p_rx;
                  int I_rx=1;
                  m_ = mcmCalcResultSize(m_, &n_, mccM(&rx), mccN(&rx));
                  mccAllocateMatrix(&RM2_, m_, n_);
                  I_RM2_ = (mccM(&RM2_) != 1 || mccN(&RM2_) != 1);
                  p_RM2_ = mccPR(&RM2_);
                  I_rx = (mccM(&rx) != 1 || mccN(&rx) != 1);
                  p_rx = mccPR(&rx);
                  if (m_ != 0)
                  {
                     for (j_=0; j_<n_; ++j_)
                     {
                        for (i_=0; i_<m_; ++i_, p_RM2_+=I_RM2_, p_rx+=I_rx)
                        {
                           *p_RM2_ = (*p_rx - k);
                        }
                     }
                  }
               }
               {
                  int i_, j_;
                  int m_=1, n_=1, cx_ = 0;
                  double *p_RM3_;
                  int I_RM3_=1;
                  double *p_ry;
                  int I_ry=1;
                  m_ = mcmCalcResultSize(m_, &n_, mccM(&ry), mccN(&ry));
                  mccAllocateMatrix(&RM3_, m_, n_);
                  I_RM3_ = (mccM(&RM3_) != 1 || mccN(&RM3_) != 1);
                  p_RM3_ = mccPR(&RM3_);
                  I_ry = (mccM(&ry) != 1 || mccN(&ry) != 1);
                  p_ry = mccPR(&ry);
                  if (m_ != 0)
                  {
                     for (j_=0; j_<n_; ++j_)
                     {
                        for (i_=0; i_<m_; ++i_, p_RM3_+=I_RM3_, p_ry+=I_ry)
                        {
                           *p_RM3_ = (*p_ry - kk);
                        }
                     }
                  }
               }
               szbas__1(&RM4_, &RM2_, &RM3_, t_P_);
               R0_ = (mccPR(&RM4_)[(1-1)]);
               mccPR(&u)[(j-1) + mccM(&u)*(i-1)] = ((mccPR(&u)[(i-1)*mccM(&u) + (j-1)]) + ((mccPR(s_P_)[((int)(k-.5))*mccM(s_P_) + ((int)(kk-.5))]) * (double) R0_));
               /* end ; */
            }
            /* end ; */
         }
         /* end ; */
      }
      /* end ; */
   }
   
   
   
   mccCopy(u_PP_, &u );
   mccFreeMatrix(&u);
   mccFreeMatrix(&w);
   mccFreeMatrix(&l);
   mccFreeMatrix(&h);
   mccFreeMatrix(&rx);
   mccFreeMatrix(&ry);
   mccFreeMatrix(&lrx);
   mccFreeMatrix(&hrx);
   mccFreeMatrix(&lry);
   mccFreeMatrix(&hry);
   mccFreeMatrix(&RM0_);
   mccFreeMatrix(&RM1_);
   mccFreeMatrix(&RM2_);
   mccFreeMatrix(&RM3_);
   mccFreeMatrix(&RM4_);
   return;
}
/*
RII = szbas(RRR)
*/
/***************** Compiler Assumptions ****************
 *
 *       B0_         	boolean scalar temporary
 *       B1_         	boolean scalar temporary
 *       B2_         	boolean scalar temporary
 *       BM0_        	boolean vector/matrix temporary
 *       BM1_        	boolean vector/matrix temporary
 *       BM2_        	boolean vector/matrix temporary
 *       BM3_        	boolean vector/matrix temporary
 *       IM0_        	integer vector/matrix temporary
 *       RM0_        	real vector/matrix temporary
 *       RM1_        	real vector/matrix temporary
 *       RM2_        	real vector/matrix temporary
 *       RM3_        	real vector/matrix temporary
 *       RM4_        	real vector/matrix temporary
 *       RM5_        	real vector/matrix temporary
 *       RM6_        	real vector/matrix temporary
 *       RM7_        	real vector/matrix temporary
 *       RM8_        	real vector/matrix temporary
 *       S0_         	<constant>
 *       S1_         	<constant>
 *       abs         	<function>
 *       h           	integer vector/matrix
 *       ha          	integer vector/matrix
 *       l           	integer vector/matrix
 *       la          	integer vector/matrix
 *       max         	<function>
 *       qbspln      	<function>
 *       szbas       	<function being defined>
 *       t           	real vector/matrix
 *       w           	real vector/matrix
 *       x           	real vector/matrix
 *       y           	real vector/matrix
 *******************************************************/
static void szbas__1(mxArray *w_PP_, mxArray *x_P_, mxArray *y_P_, mxArray *t_P_ )
{
   mxArray w;
   mxArray l;
   mxArray h;
   mxArray la;
   mxArray ha;
   mxArray IM0_;
   mxArray BM0_;
   mxArray BM1_;
   unsigned short B0_ = 0;
   mxArray BM2_;
   unsigned short B1_ = 0;
   mxArray BM3_;
   unsigned short B2_ = 0;
   mxArray RM0_;
   mxArray RM1_;
   mxArray RM2_;
   mxArray RM3_;
   mxArray RM4_;
   mxArray RM5_;
   mxArray RM6_;
   mxArray RM7_;
   mxArray RM8_;
   
   mccRealInit(w);
   mccIntInit(l);
   mccIntInit(h);
   mccIntInit(la);
   mccIntInit(ha);
   mccIntInit(IM0_);
   mccBoolInit(BM0_);
   mccBoolInit(BM1_);
   mccBoolInit(BM2_);
   mccBoolInit(BM3_);
   mccRealInit(RM0_);
   mccRealInit(RM1_);
   mccRealInit(RM2_);
   mccRealInit(RM3_);
   mccRealInit(RM4_);
   mccRealInit(RM5_);
   mccRealInit(RM6_);
   mccRealInit(RM7_);
   mccRealInit(RM8_);
   
   /* % Basis functions from Szelinski & Coughlan paper */
   /* % Calculates the value of the basis function number t at point (x,y) */
   /* % Returns its value w and the support boundaries - basis function number t */
   /* % has support [l,h]x[l,h] */
   
   /* % Usage: [w,l,h]=szbas(x,y,t) ; */
   
   /* la=[0,-1,-1,-1,-1] ; */
   mccCopy(&la, &S0_);
   /* ha=[1,1,1,1,2] ; */
   mccCopy(&ha, &S1_);
   
   /* l=la(t) ; h=ha(t) ; */
   mccFindIndex(&IM0_, t_P_);
   {
      int i_, j_;
      int m_=1, n_=1, cx_ = 0;
      int *p_l;
      int I_l=1;
      int *p_la;
      int *p_IM0_;
      int I_IM0_=1;
      m_ = mccCalcSubscriptDimensions(m_, &n_, mccM(&IM0_), mccN(&IM0_), &la);
      mccAllocateMatrix(&l, m_, n_);
      I_l = (mccM(&l) != 1 || mccN(&l) != 1);
      p_l = mccIPR(&l);
      I_IM0_ = (mccM(&IM0_) != 1 || mccN(&IM0_) != 1);
      p_IM0_ = mccIPR(&IM0_);
      if (m_ != 0)
      {
         for (j_=0; j_<n_; ++j_)
         {
            for (i_=0; i_<m_; ++i_, p_l+=I_l, p_IM0_+=I_IM0_)
            {
               *p_l = ((int)mccIPR(&la)[((int)(*p_IM0_ - .5))]);
            }
         }
      }
   }
   mccFindIndex(&IM0_, t_P_);
   {
      int i_, j_;
      int m_=1, n_=1, cx_ = 0;
      int *p_h;
      int I_h=1;
      int *p_ha;
      int *p_IM0_;
      int I_IM0_=1;
      m_ = mccCalcSubscriptDimensions(m_, &n_, mccM(&IM0_), mccN(&IM0_), &ha);
      mccAllocateMatrix(&h, m_, n_);
      I_h = (mccM(&h) != 1 || mccN(&h) != 1);
      p_h = mccIPR(&h);
      I_IM0_ = (mccM(&IM0_) != 1 || mccN(&IM0_) != 1);
      p_IM0_ = mccIPR(&IM0_);
      if (m_ != 0)
      {
         for (j_=0; j_<n_; ++j_)
         {
            for (i_=0; i_<m_; ++i_, p_h+=I_h, p_IM0_+=I_IM0_)
            {
               *p_h = ((int)mccIPR(&ha)[((int)(*p_IM0_ - .5))]);
            }
         }
      }
   }
   /* w=0; */
   {
      double tr_ = 0;
      mccAllocateMatrix(&w, 1, 1);
      *mccPR(&w) = tr_;
   }
   /* if x>=h | x<=l | y>=h |  y<=l, return ; end ; */
   {
      int i_, j_;
      int m_=1, n_=1, cx_ = 0;
      unsigned short *p_BM0_;
      int I_BM0_=1;
      double *p_x;
      int I_x=1;
      int *p_h;
      int I_h=1;
      m_ = mcmCalcResultSize(m_, &n_, mccM(x_P_), mccN(x_P_));
      m_ = mcmCalcResultSize(m_, &n_, mccM(&h), mccN(&h));
      mccAllocateMatrix(&BM0_, m_, n_);
      I_BM0_ = (mccM(&BM0_) != 1 || mccN(&BM0_) != 1);
      p_BM0_ = mccSPR(&BM0_);
      I_x = (mccM(x_P_) != 1 || mccN(x_P_) != 1);
      p_x = mccPR(x_P_);
      I_h = (mccM(&h) != 1 || mccN(&h) != 1);
      p_h = mccIPR(&h);
      if (m_ != 0)
      {
         for (j_=0; j_<n_; ++j_)
         {
            for (i_=0; i_<m_; ++i_, p_BM0_+=I_BM0_, p_x+=I_x, p_h+=I_h)
            {
               *p_BM0_ = ( (*p_x >= ((int)*p_h)) && !mccREL_NAN(*p_x) );
            }
         }
      }
   }
   B0_ = mccIfCondition(&BM0_);
   if (!(double)B0_)
   {
      {
         int i_, j_;
         int m_=1, n_=1, cx_ = 0;
         unsigned short *p_BM1_;
         int I_BM1_=1;
         double *p_x;
         int I_x=1;
         int *p_l;
         int I_l=1;
         m_ = mcmCalcResultSize(m_, &n_, mccM(x_P_), mccN(x_P_));
         m_ = mcmCalcResultSize(m_, &n_, mccM(&l), mccN(&l));
         mccAllocateMatrix(&BM1_, m_, n_);
         I_BM1_ = (mccM(&BM1_) != 1 || mccN(&BM1_) != 1);
         p_BM1_ = mccSPR(&BM1_);
         I_x = (mccM(x_P_) != 1 || mccN(x_P_) != 1);
         p_x = mccPR(x_P_);
         I_l = (mccM(&l) != 1 || mccN(&l) != 1);
         p_l = mccIPR(&l);
         if (m_ != 0)
         {
            for (j_=0; j_<n_; ++j_)
            {
               for (i_=0; i_<m_; ++i_, p_BM1_+=I_BM1_, p_x+=I_x, p_l+=I_l)
               {
                  *p_BM1_ = ( (*p_x <= ((int)*p_l)) && !mccREL_NAN(*p_x) );
               }
            }
         }
      }
      B0_ = mccIfCondition(&BM1_);
   }
   B1_ = (double)B0_;
   if (!(double)B1_)
   {
      {
         int i_, j_;
         int m_=1, n_=1, cx_ = 0;
         unsigned short *p_BM2_;
         int I_BM2_=1;
         double *p_y;
         int I_y=1;
         int *p_h;
         int I_h=1;
         m_ = mcmCalcResultSize(m_, &n_, mccM(y_P_), mccN(y_P_));
         m_ = mcmCalcResultSize(m_, &n_, mccM(&h), mccN(&h));
         mccAllocateMatrix(&BM2_, m_, n_);
         I_BM2_ = (mccM(&BM2_) != 1 || mccN(&BM2_) != 1);
         p_BM2_ = mccSPR(&BM2_);
         I_y = (mccM(y_P_) != 1 || mccN(y_P_) != 1);
         p_y = mccPR(y_P_);
         I_h = (mccM(&h) != 1 || mccN(&h) != 1);
         p_h = mccIPR(&h);
         if (m_ != 0)
         {
            for (j_=0; j_<n_; ++j_)
            {
               for (i_=0; i_<m_; ++i_, p_BM2_+=I_BM2_, p_y+=I_y, p_h+=I_h)
               {
                  *p_BM2_ = ( (*p_y >= ((int)*p_h)) && !mccREL_NAN(*p_y) );
               }
            }
         }
      }
      B1_ = mccIfCondition(&BM2_);
   }
   B2_ = (double)B1_;
   if (!(double)B2_)
   {
      {
         int i_, j_;
         int m_=1, n_=1, cx_ = 0;
         unsigned short *p_BM3_;
         int I_BM3_=1;
         double *p_y;
         int I_y=1;
         int *p_l;
         int I_l=1;
         m_ = mcmCalcResultSize(m_, &n_, mccM(y_P_), mccN(y_P_));
         m_ = mcmCalcResultSize(m_, &n_, mccM(&l), mccN(&l));
         mccAllocateMatrix(&BM3_, m_, n_);
         I_BM3_ = (mccM(&BM3_) != 1 || mccN(&BM3_) != 1);
         p_BM3_ = mccSPR(&BM3_);
         I_y = (mccM(y_P_) != 1 || mccN(y_P_) != 1);
         p_y = mccPR(y_P_);
         I_l = (mccM(&l) != 1 || mccN(&l) != 1);
         p_l = mccIPR(&l);
         if (m_ != 0)
         {
            for (j_=0; j_<n_; ++j_)
            {
               for (i_=0; i_<m_; ++i_, p_BM3_+=I_BM3_, p_y+=I_y, p_l+=I_l)
               {
                  *p_BM3_ = ( (*p_y <= ((int)*p_l)) && !mccREL_NAN(*p_y) );
               }
            }
         }
      }
      B2_ = mccIfCondition(&BM3_);
   }
   if ((double)B2_)
   {
      goto MretH;
   }
   
   /* if t==1, w=1 ;  */
   {
      int i_, j_;
      int m_=1, n_=1, cx_ = 0;
      unsigned short *p_BM3_;
      int I_BM3_=1;
      double *p_t;
      int I_t=1;
      m_ = mcmCalcResultSize(m_, &n_, mccM(t_P_), mccN(t_P_));
      mccAllocateMatrix(&BM3_, m_, n_);
      I_BM3_ = (mccM(&BM3_) != 1 || mccN(&BM3_) != 1);
      p_BM3_ = mccSPR(&BM3_);
      I_t = (mccM(t_P_) != 1 || mccN(t_P_) != 1);
      p_t = mccPR(t_P_);
      if (m_ != 0)
      {
         for (j_=0; j_<n_; ++j_)
         {
            for (i_=0; i_<m_; ++i_, p_BM3_+=I_BM3_, p_t+=I_t)
            {
               *p_BM3_ = ( (*p_t == 1) && !mccREL_NAN(*p_t) );
            }
         }
      }
   }
   if (mccIfCondition(&BM3_))
   {
      {
         double tr_ = 1;
         mccAllocateMatrix(&w, 1, 1);
         *mccPR(&w) = tr_;
      }
      
   }
   else
   {
      /* elseif t==2,  */
      {
         int i_, j_;
         int m_=1, n_=1, cx_ = 0;
         unsigned short *p_BM3_;
         int I_BM3_=1;
         double *p_t;
         int I_t=1;
         m_ = mcmCalcResultSize(m_, &n_, mccM(t_P_), mccN(t_P_));
         mccAllocateMatrix(&BM3_, m_, n_);
         I_BM3_ = (mccM(&BM3_) != 1 || mccN(&BM3_) != 1);
         p_BM3_ = mccSPR(&BM3_);
         I_t = (mccM(t_P_) != 1 || mccN(t_P_) != 1);
         p_t = mccPR(t_P_);
         if (m_ != 0)
         {
            for (j_=0; j_<n_; ++j_)
            {
               for (i_=0; i_<m_; ++i_, p_BM3_+=I_BM3_, p_t+=I_t)
               {
                  *p_BM3_ = ( (*p_t == 2) && !mccREL_NAN(*p_t) );
               }
            }
         }
      }
      if (mccIfCondition(&BM3_))
      {
         /* if x<0, */
         {
            int i_, j_;
            int m_=1, n_=1, cx_ = 0;
            unsigned short *p_BM3_;
            int I_BM3_=1;
            double *p_x;
            int I_x=1;
            m_ = mcmCalcResultSize(m_, &n_, mccM(x_P_), mccN(x_P_));
            mccAllocateMatrix(&BM3_, m_, n_);
            I_BM3_ = (mccM(&BM3_) != 1 || mccN(&BM3_) != 1);
            p_BM3_ = mccSPR(&BM3_);
            I_x = (mccM(x_P_) != 1 || mccN(x_P_) != 1);
            p_x = mccPR(x_P_);
            if (m_ != 0)
            {
               for (j_=0; j_<n_; ++j_)
               {
                  for (i_=0; i_<m_; ++i_, p_BM3_+=I_BM3_, p_x+=I_x)
                  {
                     *p_BM3_ = ( (*p_x < 0) && !mccREL_NAN(*p_x) );
                  }
               }
            }
         }
         if (mccIfCondition(&BM3_))
         {
            /* if y>0, w=x+1 ; end ; */
            {
               int i_, j_;
               int m_=1, n_=1, cx_ = 0;
               unsigned short *p_BM3_;
               int I_BM3_=1;
               double *p_y;
               int I_y=1;
               m_ = mcmCalcResultSize(m_, &n_, mccM(y_P_), mccN(y_P_));
               mccAllocateMatrix(&BM3_, m_, n_);
               I_BM3_ = (mccM(&BM3_) != 1 || mccN(&BM3_) != 1);
               p_BM3_ = mccSPR(&BM3_);
               I_y = (mccM(y_P_) != 1 || mccN(y_P_) != 1);
               p_y = mccPR(y_P_);
               if (m_ != 0)
               {
                  for (j_=0; j_<n_; ++j_)
                  {
                     for (i_=0; i_<m_; ++i_, p_BM3_+=I_BM3_, p_y+=I_y)
                     {
                        *p_BM3_ = ( (*p_y > 0) && !mccREL_NAN(*p_y) );
                     }
                  }
               }
            }
            if (mccIfCondition(&BM3_))
            {
               {
                  int i_, j_;
                  int m_=1, n_=1, cx_ = 0;
                  double *p_w;
                  int I_w=1;
                  double *p_x;
                  int I_x=1;
                  m_ = mcmCalcResultSize(m_, &n_, mccM(x_P_), mccN(x_P_));
                  mccAllocateMatrix(&w, m_, n_);
                  I_w = (mccM(&w) != 1 || mccN(&w) != 1);
                  p_w = mccPR(&w);
                  I_x = (mccM(x_P_) != 1 || mccN(x_P_) != 1);
                  p_x = mccPR(x_P_);
                  if (m_ != 0)
                  {
                     for (j_=0; j_<n_; ++j_)
                     {
                        for (i_=0; i_<m_; ++i_, p_w+=I_w, p_x+=I_x)
                        {
                           *p_w = (*p_x + 1);
                        }
                     }
                  }
               }
            }
         }
         else
         {
            /* elseif y<0, w=y+1 ;  */
            {
               int i_, j_;
               int m_=1, n_=1, cx_ = 0;
               unsigned short *p_BM3_;
               int I_BM3_=1;
               double *p_y;
               int I_y=1;
               m_ = mcmCalcResultSize(m_, &n_, mccM(y_P_), mccN(y_P_));
               mccAllocateMatrix(&BM3_, m_, n_);
               I_BM3_ = (mccM(&BM3_) != 1 || mccN(&BM3_) != 1);
               p_BM3_ = mccSPR(&BM3_);
               I_y = (mccM(y_P_) != 1 || mccN(y_P_) != 1);
               p_y = mccPR(y_P_);
               if (m_ != 0)
               {
                  for (j_=0; j_<n_; ++j_)
                  {
                     for (i_=0; i_<m_; ++i_, p_BM3_+=I_BM3_, p_y+=I_y)
                     {
                        *p_BM3_ = ( (*p_y < 0) && !mccREL_NAN(*p_y) );
                     }
                  }
               }
            }
            if (mccIfCondition(&BM3_))
            {
               {
                  int i_, j_;
                  int m_=1, n_=1, cx_ = 0;
                  double *p_w;
                  int I_w=1;
                  double *p_y;
                  int I_y=1;
                  m_ = mcmCalcResultSize(m_, &n_, mccM(y_P_), mccN(y_P_));
                  mccAllocateMatrix(&w, m_, n_);
                  I_w = (mccM(&w) != 1 || mccN(&w) != 1);
                  p_w = mccPR(&w);
                  I_y = (mccM(y_P_) != 1 || mccN(y_P_) != 1);
                  p_y = mccPR(y_P_);
                  if (m_ != 0)
                  {
                     for (j_=0; j_<n_; ++j_)
                     {
                        for (i_=0; i_<m_; ++i_, p_w+=I_w, p_y+=I_y)
                        {
                           *p_w = (*p_y + 1);
                        }
                     }
                  }
               }
            }
            else
            {
               /* else w=1-x-y ; end ; */
               {
                  int i_, j_;
                  int m_=1, n_=1, cx_ = 0;
                  double *p_w;
                  int I_w=1;
                  double *p_x;
                  int I_x=1;
                  double *p_y;
                  int I_y=1;
                  m_ = mcmCalcResultSize(m_, &n_, mccM(x_P_), mccN(x_P_));
                  m_ = mcmCalcResultSize(m_, &n_, mccM(y_P_), mccN(y_P_));
                  mccAllocateMatrix(&w, m_, n_);
                  I_w = (mccM(&w) != 1 || mccN(&w) != 1);
                  p_w = mccPR(&w);
                  I_x = (mccM(x_P_) != 1 || mccN(x_P_) != 1);
                  p_x = mccPR(x_P_);
                  I_y = (mccM(y_P_) != 1 || mccN(y_P_) != 1);
                  p_y = mccPR(y_P_);
                  if (m_ != 0)
                  {
                     for (j_=0; j_<n_; ++j_)
                     {
                        for (i_=0; i_<m_; ++i_, p_w+=I_w, p_x+=I_x, p_y+=I_y)
                        {
                           *p_w = ((1 - *p_x) - *p_y);
                        }
                     }
                  }
               }
            }
         }
         
      }
      else
      {
         /* elseif t==3,         */
         {
            int i_, j_;
            int m_=1, n_=1, cx_ = 0;
            unsigned short *p_BM3_;
            int I_BM3_=1;
            double *p_t;
            int I_t=1;
            m_ = mcmCalcResultSize(m_, &n_, mccM(t_P_), mccN(t_P_));
            mccAllocateMatrix(&BM3_, m_, n_);
            I_BM3_ = (mccM(&BM3_) != 1 || mccN(&BM3_) != 1);
            p_BM3_ = mccSPR(&BM3_);
            I_t = (mccM(t_P_) != 1 || mccN(t_P_) != 1);
            p_t = mccPR(t_P_);
            if (m_ != 0)
            {
               for (j_=0; j_<n_; ++j_)
               {
                  for (i_=0; i_<m_; ++i_, p_BM3_+=I_BM3_, p_t+=I_t)
                  {
                     *p_BM3_ = ( (*p_t == 3) && !mccREL_NAN(*p_t) );
                  }
               }
            }
         }
         if (mccIfCondition(&BM3_))
         {
            /* w=max([ 0 1-max([ abs(x) abs(y) abs(x+y)]) ]) ; */
            mccAbs(&RM0_, x_P_);
            mccAbs(&RM1_, y_P_);
            mccCatenateColumns(&RM2_, &RM0_, &RM1_);
            {
               int i_, j_;
               int m_=1, n_=1, cx_ = 0;
               double *p_RM3_;
               int I_RM3_=1;
               double *p_x;
               int I_x=1;
               double *p_y;
               int I_y=1;
               m_ = mcmCalcResultSize(m_, &n_, mccM(x_P_), mccN(x_P_));
               m_ = mcmCalcResultSize(m_, &n_, mccM(y_P_), mccN(y_P_));
               mccAllocateMatrix(&RM3_, m_, n_);
               I_RM3_ = (mccM(&RM3_) != 1 || mccN(&RM3_) != 1);
               p_RM3_ = mccPR(&RM3_);
               I_x = (mccM(x_P_) != 1 || mccN(x_P_) != 1);
               p_x = mccPR(x_P_);
               I_y = (mccM(y_P_) != 1 || mccN(y_P_) != 1);
               p_y = mccPR(y_P_);
               if (m_ != 0)
               {
                  for (j_=0; j_<n_; ++j_)
                  {
                     for (i_=0; i_<m_; ++i_, p_RM3_+=I_RM3_, p_x+=I_x, p_y+=I_y)
                     {
                        *p_RM3_ = (*p_x + *p_y);
                     }
                  }
               }
            }
            mccAbs(&RM4_, &RM3_);
            mccCatenateColumns(&RM5_, &RM2_, &RM4_);
            mccMax(&RM6_, &RM5_);
            {
               int i_, j_;
               int m_=1, n_=1, cx_ = 0;
               double *p_RM7_;
               int I_RM7_=1;
               double *p_RM6_;
               int I_RM6_=1;
               m_ = mcmCalcResultSize(m_, &n_, mccM(&RM6_), mccN(&RM6_));
               mccAllocateMatrix(&RM7_, m_, n_);
               I_RM7_ = (mccM(&RM7_) != 1 || mccN(&RM7_) != 1);
               p_RM7_ = mccPR(&RM7_);
               I_RM6_ = (mccM(&RM6_) != 1 || mccN(&RM6_) != 1);
               p_RM6_ = mccPR(&RM6_);
               if (m_ != 0)
               {
                  for (j_=0; j_<n_; ++j_)
                  {
                     for (i_=0; i_<m_; ++i_, p_RM7_+=I_RM7_, p_RM6_+=I_RM6_)
                     {
                        *p_RM7_ = (1 - *p_RM6_);
                     }
                  }
               }
            }
            mccCatenateColumns(&RM8_, mccTempMatrix(0, 0., mccINT, 0 ), &RM7_);
            mccMax(&w, &RM8_);
            
         }
         else
         {
            /* elseif t==4,   */
            {
               int i_, j_;
               int m_=1, n_=1, cx_ = 0;
               unsigned short *p_BM3_;
               int I_BM3_=1;
               double *p_t;
               int I_t=1;
               m_ = mcmCalcResultSize(m_, &n_, mccM(t_P_), mccN(t_P_));
               mccAllocateMatrix(&BM3_, m_, n_);
               I_BM3_ = (mccM(&BM3_) != 1 || mccN(&BM3_) != 1);
               p_BM3_ = mccSPR(&BM3_);
               I_t = (mccM(t_P_) != 1 || mccN(t_P_) != 1);
               p_t = mccPR(t_P_);
               if (m_ != 0)
               {
                  for (j_=0; j_<n_; ++j_)
                  {
                     for (i_=0; i_<m_; ++i_, p_BM3_+=I_BM3_, p_t+=I_t)
                     {
                        *p_BM3_ = ( (*p_t == 4) && !mccREL_NAN(*p_t) );
                     }
                  }
               }
            }
            if (mccIfCondition(&BM3_))
            {
               /* w=(1-abs(x))*(1-abs(y)) ; */
               mccAbs(&RM8_, x_P_);
               {
                  int i_, j_;
                  int m_=1, n_=1, cx_ = 0;
                  double *p_RM7_;
                  int I_RM7_=1;
                  double *p_RM8_;
                  int I_RM8_=1;
                  m_ = mcmCalcResultSize(m_, &n_, mccM(&RM8_), mccN(&RM8_));
                  mccAllocateMatrix(&RM7_, m_, n_);
                  I_RM7_ = (mccM(&RM7_) != 1 || mccN(&RM7_) != 1);
                  p_RM7_ = mccPR(&RM7_);
                  I_RM8_ = (mccM(&RM8_) != 1 || mccN(&RM8_) != 1);
                  p_RM8_ = mccPR(&RM8_);
                  if (m_ != 0)
                  {
                     for (j_=0; j_<n_; ++j_)
                     {
                        for (i_=0; i_<m_; ++i_, p_RM7_+=I_RM7_, p_RM8_+=I_RM8_)
                        {
                           *p_RM7_ = (1 - *p_RM8_);
                        }
                     }
                  }
               }
               mccAbs(&RM6_, y_P_);
               {
                  int i_, j_;
                  int m_=1, n_=1, cx_ = 0;
                  double *p_RM5_;
                  int I_RM5_=1;
                  double *p_RM6_;
                  int I_RM6_=1;
                  m_ = mcmCalcResultSize(m_, &n_, mccM(&RM6_), mccN(&RM6_));
                  mccAllocateMatrix(&RM5_, m_, n_);
                  I_RM5_ = (mccM(&RM5_) != 1 || mccN(&RM5_) != 1);
                  p_RM5_ = mccPR(&RM5_);
                  I_RM6_ = (mccM(&RM6_) != 1 || mccN(&RM6_) != 1);
                  p_RM6_ = mccPR(&RM6_);
                  if (m_ != 0)
                  {
                     for (j_=0; j_<n_; ++j_)
                     {
                        for (i_=0; i_<m_; ++i_, p_RM5_+=I_RM5_, p_RM6_+=I_RM6_)
                        {
                           *p_RM5_ = (1 - *p_RM6_);
                        }
                     }
                  }
               }
               mccRealMatrixMultiply(&w, &RM7_, &RM5_);
            }
            else
            {
               /* elseif t==5, */
               {
                  int i_, j_;
                  int m_=1, n_=1, cx_ = 0;
                  unsigned short *p_BM3_;
                  int I_BM3_=1;
                  double *p_t;
                  int I_t=1;
                  m_ = mcmCalcResultSize(m_, &n_, mccM(t_P_), mccN(t_P_));
                  mccAllocateMatrix(&BM3_, m_, n_);
                  I_BM3_ = (mccM(&BM3_) != 1 || mccN(&BM3_) != 1);
                  p_BM3_ = mccSPR(&BM3_);
                  I_t = (mccM(t_P_) != 1 || mccN(t_P_) != 1);
                  p_t = mccPR(t_P_);
                  if (m_ != 0)
                  {
                     for (j_=0; j_<n_; ++j_)
                     {
                        for (i_=0; i_<m_; ++i_, p_BM3_+=I_BM3_, p_t+=I_t)
                        {
                           *p_BM3_ = ( (*p_t == 5) && !mccREL_NAN(*p_t) );
                        }
                     }
                  }
               }
               if (mccIfCondition(&BM3_))
               {
                  /* w=qbspln(x-0.5)*qbspln(y-0.5) ; */
                  {
                     int i_, j_;
                     int m_=1, n_=1, cx_ = 0;
                     double *p_RM5_;
                     int I_RM5_=1;
                     double *p_x;
                     int I_x=1;
                     m_ = mcmCalcResultSize(m_, &n_, mccM(x_P_), mccN(x_P_));
                     mccAllocateMatrix(&RM5_, m_, n_);
                     I_RM5_ = (mccM(&RM5_) != 1 || mccN(&RM5_) != 1);
                     p_RM5_ = mccPR(&RM5_);
                     I_x = (mccM(x_P_) != 1 || mccN(x_P_) != 1);
                     p_x = mccPR(x_P_);
                     if (m_ != 0)
                     {
                        for (j_=0; j_<n_; ++j_)
                        {
                           for (i_=0; i_<m_; ++i_, p_RM5_+=I_RM5_, p_x+=I_x)
                           {
                              *p_RM5_ = (*p_x - 0.5);
                           }
                        }
                     }
                  }
                  qbspln_(&RM6_, &RM5_);
                  {
                     int i_, j_;
                     int m_=1, n_=1, cx_ = 0;
                     double *p_RM7_;
                     int I_RM7_=1;
                     double *p_y;
                     int I_y=1;
                     m_ = mcmCalcResultSize(m_, &n_, mccM(y_P_), mccN(y_P_));
                     mccAllocateMatrix(&RM7_, m_, n_);
                     I_RM7_ = (mccM(&RM7_) != 1 || mccN(&RM7_) != 1);
                     p_RM7_ = mccPR(&RM7_);
                     I_y = (mccM(y_P_) != 1 || mccN(y_P_) != 1);
                     p_y = mccPR(y_P_);
                     if (m_ != 0)
                     {
                        for (j_=0; j_<n_; ++j_)
                        {
                           for (i_=0; i_<m_; ++i_, p_RM7_+=I_RM7_, p_y+=I_y)
                           {
                              *p_RM7_ = (*p_y - 0.5);
                           }
                        }
                     }
                  }
                  qbspln_(&RM8_, &RM7_);
                  mccRealMatrixMultiply(&w, &RM6_, &RM8_);
                  /* end ; */
               }
            }
         }
      }
   }
   
   
   MretH:
   mccCopy(w_PP_, &w );
   mccFreeMatrix(&w);
   mccFreeMatrix(&l);
   mccFreeMatrix(&h);
   mccFreeMatrix(&la);
   mccFreeMatrix(&ha);
   mccFreeMatrix(&IM0_);
   mccFreeMatrix(&BM0_);
   mccFreeMatrix(&BM1_);
   mccFreeMatrix(&BM2_);
   mccFreeMatrix(&BM3_);
   mccFreeMatrix(&RM0_);
   mccFreeMatrix(&RM1_);
   mccFreeMatrix(&RM2_);
   mccFreeMatrix(&RM3_);
   mccFreeMatrix(&RM4_);
   mccFreeMatrix(&RM5_);
   mccFreeMatrix(&RM6_);
   mccFreeMatrix(&RM7_);
   mccFreeMatrix(&RM8_);
   return;
}
/*
[RII] = szbas(iiR)
*/
/***************** Compiler Assumptions ****************
 *
 *       B0_         	boolean scalar temporary
 *       B1_         	boolean scalar temporary
 *       B2_         	boolean scalar temporary
 *       BM0_        	boolean vector/matrix temporary
 *       BM1_        	boolean vector/matrix temporary
 *       BM2_        	boolean vector/matrix temporary
 *       BM3_        	boolean vector/matrix temporary
 *       I0_         	integer scalar temporary
 *       I1_         	integer scalar temporary
 *       I2_         	integer scalar temporary
 *       IM0_        	integer vector/matrix temporary
 *       IM1_        	integer vector/matrix temporary
 *       IM2_        	integer vector/matrix temporary
 *       IM3_        	integer vector/matrix temporary
 *       IM4_        	integer vector/matrix temporary
 *       R0_         	real scalar temporary
 *       R1_         	real scalar temporary
 *       S2_         	<constant>
 *       S3_         	<constant>
 *       abs         	<function>
 *       h           	integer vector/matrix
 *       ha          	integer vector/matrix
 *       l           	integer vector/matrix
 *       la          	integer vector/matrix
 *       max         	<function>
 *       qbspln      	<function>
 *       szbas       	<function being defined>
 *       t           	real vector/matrix
 *       w           	real vector/matrix
 *       x           	integer scalar
 *       y           	integer scalar
 *******************************************************/
static void szbas_(mxArray *w_PP_, mxArray *l_PP_, mxArray *h_PP_, int x, int y, mxArray *t_P_ )
{
   mxArray w;
   mxArray l;
   mxArray h;
   mxArray la;
   mxArray ha;
   mxArray IM0_;
   mxArray BM0_;
   mxArray BM1_;
   unsigned short B0_ = 0;
   mxArray BM2_;
   unsigned short B1_ = 0;
   mxArray BM3_;
   unsigned short B2_ = 0;
   int I0_ = 0;
   int I1_ = 0;
   int I2_ = 0;
   mxArray IM1_;
   mxArray IM2_;
   mxArray IM3_;
   mxArray IM4_;
   double R0_ = 0.0;
   double R1_ = 0.0;
   
   mccRealInit(w);
   mccIntInit(l);
   mccIntInit(h);
   mccIntInit(la);
   mccIntInit(ha);
   mccIntInit(IM0_);
   mccBoolInit(BM0_);
   mccBoolInit(BM1_);
   mccBoolInit(BM2_);
   mccBoolInit(BM3_);
   mccIntInit(IM1_);
   mccIntInit(IM2_);
   mccIntInit(IM3_);
   mccIntInit(IM4_);
   
   /* % Basis functions from Szelinski & Coughlan paper */
   /* % Calculates the value of the basis function number t at point (x,y) */
   /* % Returns its value w and the support boundaries - basis function number t */
   /* % has support [l,h]x[l,h] */
   
   /* % Usage: [w,l,h]=szbas(x,y,t) ; */
   
   /* la=[0,-1,-1,-1,-1] ; */
   mccCopy(&la, &S2_);
   /* ha=[1,1,1,1,2] ; */
   mccCopy(&ha, &S3_);
   
   /* l=la(t) ; h=ha(t) ; */
   mccFindIndex(&IM0_, t_P_);
   {
      int i_, j_;
      int m_=1, n_=1, cx_ = 0;
      int *p_l;
      int I_l=1;
      int *p_la;
      int *p_IM0_;
      int I_IM0_=1;
      m_ = mccCalcSubscriptDimensions(m_, &n_, mccM(&IM0_), mccN(&IM0_), &la);
      mccAllocateMatrix(&l, m_, n_);
      I_l = (mccM(&l) != 1 || mccN(&l) != 1);
      p_l = mccIPR(&l);
      I_IM0_ = (mccM(&IM0_) != 1 || mccN(&IM0_) != 1);
      p_IM0_ = mccIPR(&IM0_);
      if (m_ != 0)
      {
         for (j_=0; j_<n_; ++j_)
         {
            for (i_=0; i_<m_; ++i_, p_l+=I_l, p_IM0_+=I_IM0_)
            {
               *p_l = ((int)mccIPR(&la)[((int)(*p_IM0_ - .5))]);
            }
         }
      }
   }
   mccFindIndex(&IM0_, t_P_);
   {
      int i_, j_;
      int m_=1, n_=1, cx_ = 0;
      int *p_h;
      int I_h=1;
      int *p_ha;
      int *p_IM0_;
      int I_IM0_=1;
      m_ = mccCalcSubscriptDimensions(m_, &n_, mccM(&IM0_), mccN(&IM0_), &ha);
      mccAllocateMatrix(&h, m_, n_);
      I_h = (mccM(&h) != 1 || mccN(&h) != 1);
      p_h = mccIPR(&h);
      I_IM0_ = (mccM(&IM0_) != 1 || mccN(&IM0_) != 1);
      p_IM0_ = mccIPR(&IM0_);
      if (m_ != 0)
      {
         for (j_=0; j_<n_; ++j_)
         {
            for (i_=0; i_<m_; ++i_, p_h+=I_h, p_IM0_+=I_IM0_)
            {
               *p_h = ((int)mccIPR(&ha)[((int)(*p_IM0_ - .5))]);
            }
         }
      }
   }
   /* w=0; */
   {
      double tr_ = 0;
      mccAllocateMatrix(&w, 1, 1);
      *mccPR(&w) = tr_;
   }
   /* if x>=h | x<=l | y>=h |  y<=l, return ; end ; */
   {
      int i_, j_;
      int m_=1, n_=1, cx_ = 0;
      unsigned short *p_BM0_;
      int I_BM0_=1;
      int *p_h;
      int I_h=1;
      m_ = mcmCalcResultSize(m_, &n_, mccM(&h), mccN(&h));
      mccAllocateMatrix(&BM0_, m_, n_);
      I_BM0_ = (mccM(&BM0_) != 1 || mccN(&BM0_) != 1);
      p_BM0_ = mccSPR(&BM0_);
      I_h = (mccM(&h) != 1 || mccN(&h) != 1);
      p_h = mccIPR(&h);
      if (m_ != 0)
      {
         for (j_=0; j_<n_; ++j_)
         {
            for (i_=0; i_<m_; ++i_, p_BM0_+=I_BM0_, p_h+=I_h)
            {
               *p_BM0_ = (x >= ((int)*p_h));
            }
         }
      }
   }
   B0_ = mccIfCondition(&BM0_);
   if (!(double)B0_)
   {
      {
         int i_, j_;
         int m_=1, n_=1, cx_ = 0;
         unsigned short *p_BM1_;
         int I_BM1_=1;
         int *p_l;
         int I_l=1;
         m_ = mcmCalcResultSize(m_, &n_, mccM(&l), mccN(&l));
         mccAllocateMatrix(&BM1_, m_, n_);
         I_BM1_ = (mccM(&BM1_) != 1 || mccN(&BM1_) != 1);
         p_BM1_ = mccSPR(&BM1_);
         I_l = (mccM(&l) != 1 || mccN(&l) != 1);
         p_l = mccIPR(&l);
         if (m_ != 0)
         {
            for (j_=0; j_<n_; ++j_)
            {
               for (i_=0; i_<m_; ++i_, p_BM1_+=I_BM1_, p_l+=I_l)
               {
                  *p_BM1_ = (x <= ((int)*p_l));
               }
            }
         }
      }
      B0_ = mccIfCondition(&BM1_);
   }
   B1_ = (double)B0_;
   if (!(double)B1_)
   {
      {
         int i_, j_;
         int m_=1, n_=1, cx_ = 0;
         unsigned short *p_BM2_;
         int I_BM2_=1;
         int *p_h;
         int I_h=1;
         m_ = mcmCalcResultSize(m_, &n_, mccM(&h), mccN(&h));
         mccAllocateMatrix(&BM2_, m_, n_);
         I_BM2_ = (mccM(&BM2_) != 1 || mccN(&BM2_) != 1);
         p_BM2_ = mccSPR(&BM2_);
         I_h = (mccM(&h) != 1 || mccN(&h) != 1);
         p_h = mccIPR(&h);
         if (m_ != 0)
         {
            for (j_=0; j_<n_; ++j_)
            {
               for (i_=0; i_<m_; ++i_, p_BM2_+=I_BM2_, p_h+=I_h)
               {
                  *p_BM2_ = (y >= ((int)*p_h));
               }
            }
         }
      }
      B1_ = mccIfCondition(&BM2_);
   }
   B2_ = (double)B1_;
   if (!(double)B2_)
   {
      {
         int i_, j_;
         int m_=1, n_=1, cx_ = 0;
         unsigned short *p_BM3_;
         int I_BM3_=1;
         int *p_l;
         int I_l=1;
         m_ = mcmCalcResultSize(m_, &n_, mccM(&l), mccN(&l));
         mccAllocateMatrix(&BM3_, m_, n_);
         I_BM3_ = (mccM(&BM3_) != 1 || mccN(&BM3_) != 1);
         p_BM3_ = mccSPR(&BM3_);
         I_l = (mccM(&l) != 1 || mccN(&l) != 1);
         p_l = mccIPR(&l);
         if (m_ != 0)
         {
            for (j_=0; j_<n_; ++j_)
            {
               for (i_=0; i_<m_; ++i_, p_BM3_+=I_BM3_, p_l+=I_l)
               {
                  *p_BM3_ = (y <= ((int)*p_l));
               }
            }
         }
      }
      B2_ = mccIfCondition(&BM3_);
   }
   if ((double)B2_)
   {
      goto MretH;
   }
   
   /* if t==1, w=1 ;  */
   {
      int i_, j_;
      int m_=1, n_=1, cx_ = 0;
      unsigned short *p_BM3_;
      int I_BM3_=1;
      double *p_t;
      int I_t=1;
      m_ = mcmCalcResultSize(m_, &n_, mccM(t_P_), mccN(t_P_));
      mccAllocateMatrix(&BM3_, m_, n_);
      I_BM3_ = (mccM(&BM3_) != 1 || mccN(&BM3_) != 1);
      p_BM3_ = mccSPR(&BM3_);
      I_t = (mccM(t_P_) != 1 || mccN(t_P_) != 1);
      p_t = mccPR(t_P_);
      if (m_ != 0)
      {
         for (j_=0; j_<n_; ++j_)
         {
            for (i_=0; i_<m_; ++i_, p_BM3_+=I_BM3_, p_t+=I_t)
            {
               *p_BM3_ = ( (*p_t == 1) && !mccREL_NAN(*p_t) );
            }
         }
      }
   }
   if (mccIfCondition(&BM3_))
   {
      {
         double tr_ = 1;
         mccAllocateMatrix(&w, 1, 1);
         *mccPR(&w) = tr_;
      }
      
   }
   else
   {
      /* elseif t==2,  */
      {
         int i_, j_;
         int m_=1, n_=1, cx_ = 0;
         unsigned short *p_BM3_;
         int I_BM3_=1;
         double *p_t;
         int I_t=1;
         m_ = mcmCalcResultSize(m_, &n_, mccM(t_P_), mccN(t_P_));
         mccAllocateMatrix(&BM3_, m_, n_);
         I_BM3_ = (mccM(&BM3_) != 1 || mccN(&BM3_) != 1);
         p_BM3_ = mccSPR(&BM3_);
         I_t = (mccM(t_P_) != 1 || mccN(t_P_) != 1);
         p_t = mccPR(t_P_);
         if (m_ != 0)
         {
            for (j_=0; j_<n_; ++j_)
            {
               for (i_=0; i_<m_; ++i_, p_BM3_+=I_BM3_, p_t+=I_t)
               {
                  *p_BM3_ = ( (*p_t == 2) && !mccREL_NAN(*p_t) );
               }
            }
         }
      }
      if (mccIfCondition(&BM3_))
      {
         /* if x<0, */
         if ((x < 0))
         {
            /* if y>0, w=x+1 ; end ; */
            if ((y > 0))
            {
               {
                  double tr_ = (x + 1);
                  mccAllocateMatrix(&w, 1, 1);
                  *mccPR(&w) = tr_;
               }
            }
         }
         else
         {
            /* elseif y<0, w=y+1 ;  */
            if ((y < 0))
            {
               {
                  double tr_ = (y + 1);
                  mccAllocateMatrix(&w, 1, 1);
                  *mccPR(&w) = tr_;
               }
            }
            else
            {
               /* else w=1-x-y ; end ; */
               {
                  double tr_ = ((1 - x) - y);
                  mccAllocateMatrix(&w, 1, 1);
                  *mccPR(&w) = tr_;
               }
            }
         }
         
      }
      else
      {
         /* elseif t==3,         */
         {
            int i_, j_;
            int m_=1, n_=1, cx_ = 0;
            unsigned short *p_BM3_;
            int I_BM3_=1;
            double *p_t;
            int I_t=1;
            m_ = mcmCalcResultSize(m_, &n_, mccM(t_P_), mccN(t_P_));
            mccAllocateMatrix(&BM3_, m_, n_);
            I_BM3_ = (mccM(&BM3_) != 1 || mccN(&BM3_) != 1);
            p_BM3_ = mccSPR(&BM3_);
            I_t = (mccM(t_P_) != 1 || mccN(t_P_) != 1);
            p_t = mccPR(t_P_);
            if (m_ != 0)
            {
               for (j_=0; j_<n_; ++j_)
               {
                  for (i_=0; i_<m_; ++i_, p_BM3_+=I_BM3_, p_t+=I_t)
                  {
                     *p_BM3_ = ( (*p_t == 3) && !mccREL_NAN(*p_t) );
                  }
               }
            }
         }
         if (mccIfCondition(&BM3_))
         {
            /* w=max([ 0 1-max([ abs(x) abs(y) abs(x+y)]) ]) ; */
            I0_ = abs(x);
            I1_ = abs(y);
            mccCatenateColumns(&IM0_, mccTempMatrix(I0_, 0., mccINT, 0 ), mccTempMatrix(I1_, 0., mccINT, 0 ));
            I2_ = abs(((int)(x + y)));
            mccCatenateColumns(&IM1_, &IM0_, mccTempMatrix(I2_, 0., mccINT, 0 ));
            mccMax(&IM2_, &IM1_);
            {
               int i_, j_;
               int m_=1, n_=1, cx_ = 0;
               int *p_IM3_;
               int I_IM3_=1;
               int *p_IM2_;
               int I_IM2_=1;
               m_ = mcmCalcResultSize(m_, &n_, mccM(&IM2_), mccN(&IM2_));
               mccAllocateMatrix(&IM3_, m_, n_);
               I_IM3_ = (mccM(&IM3_) != 1 || mccN(&IM3_) != 1);
               p_IM3_ = mccIPR(&IM3_);
               I_IM2_ = (mccM(&IM2_) != 1 || mccN(&IM2_) != 1);
               p_IM2_ = mccIPR(&IM2_);
               if (m_ != 0)
               {
                  for (j_=0; j_<n_; ++j_)
                  {
                     for (i_=0; i_<m_; ++i_, p_IM3_+=I_IM3_, p_IM2_+=I_IM2_)
                     {
                        *p_IM3_ = (1 - ((int)*p_IM2_));
                     }
                  }
               }
            }
            mccCatenateColumns(&IM4_, mccTempMatrix(0, 0., mccINT, 0 ), &IM3_);
            mccMax(&w, &IM4_);
            
         }
         else
         {
            /* elseif t==4,   */
            {
               int i_, j_;
               int m_=1, n_=1, cx_ = 0;
               unsigned short *p_BM3_;
               int I_BM3_=1;
               double *p_t;
               int I_t=1;
               m_ = mcmCalcResultSize(m_, &n_, mccM(t_P_), mccN(t_P_));
               mccAllocateMatrix(&BM3_, m_, n_);
               I_BM3_ = (mccM(&BM3_) != 1 || mccN(&BM3_) != 1);
               p_BM3_ = mccSPR(&BM3_);
               I_t = (mccM(t_P_) != 1 || mccN(t_P_) != 1);
               p_t = mccPR(t_P_);
               if (m_ != 0)
               {
                  for (j_=0; j_<n_; ++j_)
                  {
                     for (i_=0; i_<m_; ++i_, p_BM3_+=I_BM3_, p_t+=I_t)
                     {
                        *p_BM3_ = ( (*p_t == 4) && !mccREL_NAN(*p_t) );
                     }
                  }
               }
            }
            if (mccIfCondition(&BM3_))
            {
               /* w=(1-abs(x))*(1-abs(y)) ; */
               {
                  double tr_ = ((1 - abs(x)) * (double) (1 - abs(y)));
                  mccAllocateMatrix(&w, 1, 1);
                  *mccPR(&w) = tr_;
               }
            }
            else
            {
               /* elseif t==5, */
               {
                  int i_, j_;
                  int m_=1, n_=1, cx_ = 0;
                  unsigned short *p_BM3_;
                  int I_BM3_=1;
                  double *p_t;
                  int I_t=1;
                  m_ = mcmCalcResultSize(m_, &n_, mccM(t_P_), mccN(t_P_));
                  mccAllocateMatrix(&BM3_, m_, n_);
                  I_BM3_ = (mccM(&BM3_) != 1 || mccN(&BM3_) != 1);
                  p_BM3_ = mccSPR(&BM3_);
                  I_t = (mccM(t_P_) != 1 || mccN(t_P_) != 1);
                  p_t = mccPR(t_P_);
                  if (m_ != 0)
                  {
                     for (j_=0; j_<n_; ++j_)
                     {
                        for (i_=0; i_<m_; ++i_, p_BM3_+=I_BM3_, p_t+=I_t)
                        {
                           *p_BM3_ = ( (*p_t == 5) && !mccREL_NAN(*p_t) );
                        }
                     }
                  }
               }
               if (mccIfCondition(&BM3_))
               {
                  /* w=qbspln(x-0.5)*qbspln(y-0.5) ; */
                  qbspln__1(&R0_, (x - 0.5));
                  qbspln__1(&R1_, (y - 0.5));
                  {
                     double tr_ = (R0_ * (double) R1_);
                     mccAllocateMatrix(&w, 1, 1);
                     *mccPR(&w) = tr_;
                  }
                  /* end ; */
               }
            }
         }
      }
   }
   
   
   MretH:
   mccCopy(w_PP_, &w );
   mccCopy(l_PP_, &l );
   mccCopy(h_PP_, &h );
   mccFreeMatrix(&w);
   mccFreeMatrix(&l);
   mccFreeMatrix(&h);
   mccFreeMatrix(&la);
   mccFreeMatrix(&ha);
   mccFreeMatrix(&IM0_);
   mccFreeMatrix(&BM0_);
   mccFreeMatrix(&BM1_);
   mccFreeMatrix(&BM2_);
   mccFreeMatrix(&BM3_);
   mccFreeMatrix(&IM1_);
   mccFreeMatrix(&IM2_);
   mccFreeMatrix(&IM3_);
   mccFreeMatrix(&IM4_);
   return;
}
/*
R = qbspln(R)
*/
/***************** Compiler Assumptions ****************
 *
 *       BM0_        	boolean vector/matrix temporary
 *       R0_         	real scalar temporary
 *       RM0_        	real vector/matrix temporary
 *       RM1_        	real vector/matrix temporary
 *       abs         	<function>
 *       qbspln      	<function being defined>
 *       x           	real vector/matrix
 *       y           	real vector/matrix
 *******************************************************/
static void qbspln_(mxArray *y_PP_, mxArray *x_P_ )
{
   mxArray x;
   mxArray y;
   mxArray BM0_;
   double R0_ = 0.0;
   mxArray RM0_;
   mxArray RM1_;
   
   mccRealInit(x);
   mccCopy(&x, x_P_);
   mccRealInit(y);
   mccBoolInit(BM0_);
   mccRealInit(RM0_);
   mccRealInit(RM1_);
   
   /* % Calculate function values of a quadratic B-spline at point x */
   
   /* % See also: cbspln.m lbspln.m */
   
   /* % Usage: y=qbspln(x) */
   
   /* x=abs(x) ; */
   mccAbs(&x, &x);
   /* if x>1.5, */
   {
      int i_, j_;
      int m_=1, n_=1, cx_ = 0;
      unsigned short *p_BM0_;
      int I_BM0_=1;
      double *p_x;
      int I_x=1;
      m_ = mcmCalcResultSize(m_, &n_, mccM(&x), mccN(&x));
      mccAllocateMatrix(&BM0_, m_, n_);
      I_BM0_ = (mccM(&BM0_) != 1 || mccN(&BM0_) != 1);
      p_BM0_ = mccSPR(&BM0_);
      I_x = (mccM(&x) != 1 || mccN(&x) != 1);
      p_x = mccPR(&x);
      if (m_ != 0)
      {
         for (j_=0; j_<n_; ++j_)
         {
            for (i_=0; i_<m_; ++i_, p_BM0_+=I_BM0_, p_x+=I_x)
            {
               *p_BM0_ = ( (*p_x > 1.5) && !mccREL_NAN(*p_x) );
            }
         }
      }
   }
   if (mccIfCondition(&BM0_))
   {
      /* y=0 ; */
      {
         double tr_ = 0;
         mccAllocateMatrix(&y, 1, 1);
         *mccPR(&y) = tr_;
      }
   }
   else
   {
      /* else */
      /* if x>0.5, */
      {
         int i_, j_;
         int m_=1, n_=1, cx_ = 0;
         unsigned short *p_BM0_;
         int I_BM0_=1;
         double *p_x;
         int I_x=1;
         m_ = mcmCalcResultSize(m_, &n_, mccM(&x), mccN(&x));
         mccAllocateMatrix(&BM0_, m_, n_);
         I_BM0_ = (mccM(&BM0_) != 1 || mccN(&BM0_) != 1);
         p_BM0_ = mccSPR(&BM0_);
         I_x = (mccM(&x) != 1 || mccN(&x) != 1);
         p_x = mccPR(&x);
         if (m_ != 0)
         {
            for (j_=0; j_<n_; ++j_)
            {
               for (i_=0; i_<m_; ++i_, p_BM0_+=I_BM0_, p_x+=I_x)
               {
                  *p_BM0_ = ( (*p_x > 0.5) && !mccREL_NAN(*p_x) );
               }
            }
         }
      }
      if (mccIfCondition(&BM0_))
      {
         /* y=(3/2-x)^2/2 ; */
         R0_ = (3 / (double) 2);
         {
            int i_, j_;
            int m_=1, n_=1, cx_ = 0;
            double *p_RM0_;
            int I_RM0_=1;
            double *p_x;
            int I_x=1;
            m_ = mcmCalcResultSize(m_, &n_, mccM(&x), mccN(&x));
            mccAllocateMatrix(&RM0_, m_, n_);
            I_RM0_ = (mccM(&RM0_) != 1 || mccN(&RM0_) != 1);
            p_RM0_ = mccPR(&RM0_);
            I_x = (mccM(&x) != 1 || mccN(&x) != 1);
            p_x = mccPR(&x);
            if (m_ != 0)
            {
               for (j_=0; j_<n_; ++j_)
               {
                  for (i_=0; i_<m_; ++i_, p_RM0_+=I_RM0_, p_x+=I_x)
                  {
                     *p_RM0_ = (R0_ - *p_x);
                  }
               }
            }
         }
         mccPower(&RM1_, &RM0_, mccTempMatrix(2, 0., mccINT, 0 ));
         {
            int i_, j_;
            int m_=1, n_=1, cx_ = 0;
            double *p_y;
            int I_y=1;
            double *p_RM1_;
            int I_RM1_=1;
            m_ = mcmCalcResultSize(m_, &n_, mccM(&RM1_), mccN(&RM1_));
            mccAllocateMatrix(&y, m_, n_);
            I_y = (mccM(&y) != 1 || mccN(&y) != 1);
            p_y = mccPR(&y);
            I_RM1_ = (mccM(&RM1_) != 1 || mccN(&RM1_) != 1);
            p_RM1_ = mccPR(&RM1_);
            if (m_ != 0)
            {
               for (j_=0; j_<n_; ++j_)
               {
                  for (i_=0; i_<m_; ++i_, p_y+=I_y, p_RM1_+=I_RM1_)
                  {
                     *p_y = (*p_RM1_ / (double) 2);
                  }
               }
            }
         }
      }
      else
      {
         /* else */
         /* y=0.75-x^2 ; */
         mccPower(&RM1_, &x, mccTempMatrix(2, 0., mccINT, 0 ));
         {
            int i_, j_;
            int m_=1, n_=1, cx_ = 0;
            double *p_y;
            int I_y=1;
            double *p_RM1_;
            int I_RM1_=1;
            m_ = mcmCalcResultSize(m_, &n_, mccM(&RM1_), mccN(&RM1_));
            mccAllocateMatrix(&y, m_, n_);
            I_y = (mccM(&y) != 1 || mccN(&y) != 1);
            p_y = mccPR(&y);
            I_RM1_ = (mccM(&RM1_) != 1 || mccN(&RM1_) != 1);
            p_RM1_ = mccPR(&RM1_);
            if (m_ != 0)
            {
               for (j_=0; j_<n_; ++j_)
               {
                  for (i_=0; i_<m_; ++i_, p_y+=I_y, p_RM1_+=I_RM1_)
                  {
                     *p_y = (0.75 - *p_RM1_);
                  }
               }
            }
         }
         /* end ; */
      }
      /* end ; */
   }
   
   
   mccCopy(y_PP_, &y );
   mccFreeMatrix(&y);
   mccFreeMatrix(&x);
   mccFreeMatrix(&BM0_);
   mccFreeMatrix(&RM0_);
   mccFreeMatrix(&RM1_);
   return;
}
/*
r = qbspln(r)
*/
/***************** Compiler Assumptions ****************
 *
 *       abs         	<function>
 *       qbspln      	<function being defined>
 *       x           	real scalar
 *       y           	real scalar
 *******************************************************/
static void qbspln__1(double *y_PP_, double x )
{
   double y = 0.0;
   
   
   /* % Calculate function values of a quadratic B-spline at point x */
   
   /* % See also: cbspln.m lbspln.m */
   
   /* % Usage: y=qbspln(x) */
   
   /* x=abs(x) ; */
   x = fabs(x);
   /* if x>1.5, */
   if (( (x > 1.5) && !mccREL_NAN(x) ))
   {
      /* y=0 ; */
      y = 0;
   }
   else
   {
      /* else */
      /* if x>0.5, */
      if (( (x > 0.5) && !mccREL_NAN(x) ))
      {
         /* y=(3/2-x)^2/2 ; */
         y = (mcmRealPowerInt(((3 / (double) 2) - x), 2) / (double) 2);
      }
      else
      {
         /* else */
         /* y=0.75-x^2 ; */
         y = (0.75 - mcmRealPowerInt(x, 2));
         /* end ; */
      }
      /* end ; */
   }
   
   
   *y_PP_ = y;
   return;
}
