function [sx,sy]=szunpack(s,nx,ny) 
% Part of the implementation of the Szelinski-Coughlan registration algorithm
% Given the packed array s and the size nx, ny, unpack
% s into sx,sy. The inverse of szpack.
%
% Jan Kybic, February 1999
%
% Usage: [sx,sy]=szunpack(s,nx,ny) 

s=reshape(s,2,nx*ny) ;

sx=s(1,:) ; sy=s(2,:) ;

sx=reshape(sx,ny,nx) ;
sy=reshape(sy,ny,nx) ;



