function c=genrandc(nc,nd,nx,f)
% Generates random transformation c with deviation f
%
% Usage: c=genrandc(nc,nd,nx,f)

c=zeros(nd,nc) ;

for y=1:nd ;
  c(y,:)=linspace(1,nx,nc)+[ 0 f*randn(1,nc-2) 0] ;
  c(y,:)=qbanal(c(y,:)) ;
end ;

for x=1:nc,
  c(:,x)=qbanal(c(:,x)')' ;
end ;

c=reshape(c,1,nc*nd) ;
