function imh=testregister(refim,testim) ;
% Register images and compute average differences before and after
% Linear warping functions
nl=min(log(length(refim)),log(length(testim)))/log(2)-4 ;
nl=floor(max(nl,0)) ;

% scale
refim=refim/max(max(refim)) ;
testim=testim/max(max(refim)) ;

subplot(221) ; imagesc(64*refim) ; title('Reference') ; colorbar ;  colormap('jet') ;
subplot(222) ; imagesc(64*testim) ; title('Test') ; colorbar ;  colormap('jet') ;
nr=size(refim,2) ;
N=size(refim,1)*nr ;
% diffbefore=sum(sum((refim-testim).^2))/N 


ctime=cputime ;
refp=pyramid2(refim,nl) ;
testp=pyramid2(testim,nl) ;
disp([ 'Pyramids took ' num2str(cputime-ctime) ' s' ]) ;

ctime=cputime ;
c=pimwarpoptbddh(refp,testp,2,2) ;
disp([ 'Registration took ' num2str(cputime-ctime) ' s' ]) ;

imeb=imcbanal(testim) ;
imh=meximwarpldd(imeb,c,nr,2) ;
dif=refim-imh ;
subplot(223) ; imagesc(64*imh) ; title('Warped') ; colorbar ;   colormap('jet') ;
subplot(224) ; imagesc(64*dif) ; title('Difference') ; colorbar ;  colormap('jet') ;
% diffafter=sum(sum((dif.^2))/N 

