% Register anatomical images

load aimgs

N=10 ; nc=13 ; lambda=0 ;
wis=zeros(1,N) ;
fmri=normalize(fmri) ;

for i=1:N,
  subplot(221) ;
  wanat=normalize(wanats(:,:,i)) ;
  imagesc(wanat) ; colormap(bone) ; title('anat') ;
  mask=wanat>0.2 ;
  mask=double(bwmorph(mask,'erode',1)) ;
  subplot(223) ; imagesc(mask) ;
  ww=wws(:,:,i) ;
  subplot(224) ; imagesc(fmri) ; title('fmri') ;
  s=spwstruct ; s(1)=3 ; s(2)=nc ; s(3)=nc ; s(11)=1 ; s(12)=1 ; 
  s(4)=1 ; s(8)=lambda ;
  c=spwfind(wanat,fmri,s) ;
  xs=splnwarp21(reshape(c,1,nc*nc),nc,128,128) ;
  mdif=(xs-ww).*double(mask) ;
  wi=sum(sum(abs(mdif)))/sum(sum(mask)) 
  wis(i)=wi ;
end ;

mean(wis)