% Register anatomical images

clear all 
load aimgs

N=13 ; nc=13 ; lambda=0 ;
fmri=normalize(fmri) ;

i=1 ;
for nc=4:30,
  subplot(221) ;
  wanat=normalize(wanats(:,:,i)) ;
  imagesc(wanat) ; colormap(bone) ; title('anat') ;
  mask=wanat>0.2 ;
  mask=double(bwmorph(mask,'erode',1)) ;
  subplot(223) ; imagesc(mask) ;
  ww=wws(:,:,i) ;
  subplot(224) ; imagesc(fmri) ; title('fmri') ;
  s=spwstruct ; s(1)=3 ; s(2)=nc ; s(3)=nc ; s(11)=0 ; s(12)=0 ; 
  s(4)=1 ; s(8)=lambda ;
  c=spwfind(wanat,fmri,s) ;
  xs=splnwarp21(reshape(c,1,nc*nc),nc,128,128) ;
  mdif=(xs-ww).*double(mask) ;
  wi=sum(sum(abs(mdif)))/sum(sum(mask)) 
  wis(nc,1)=wi ; wis(nc,2)=nc ;
  save -ascii regndep.dat wis
end ;

