function disptablewf(wx,wy)
% Displays warping function given by tables wx,wy
%
% Usage: disptablewf(wx,wy)




[ny,nx]=size(wx) ;
stepx=10 ; stepy=10 ;
tx=round(1:stepx:nx) ;
ty=round(1:stepy:ny) ;

cla ; hold on ;

for iy=ty,
  q=1:nx ;
  qx=wx(iy,q) ; qy=wy(iy,q) ;
  plot(qx,qy) ;
end ;

for ix=tx,
  q=1:ny ;
  qx=wx(q,ix) ; qy=wy(q,ix) ;
  plot(qx,qy) ;
end ;
