function y=imshift(x,sy,sx)
% Shift image x by (sx,sy) 
%
% Usage: y=imshift(x,sy,sx)

z=zeros(size(x)) ;
if sy<0, 
  z(1:size(x,1)+sy,:)=x(1-sy:size(x,1),:) ;
else
  z(1+sy:size(x,1),:)=x(1:size(x,1)-sy,:) ;
end ;  

if sx<0, 
  y(:,1:size(x,2)+sx)=z(:,1-sx:size(x,2)) ;
else
  y(:,1+sx:size(x,2),:)=z(:,1:size(x,2)-sx) ;
end ;  
