function y=qbsynt(c)
% Given quadratic B-spline interpolation coefficients, find function values
% For a 2D array
% Usage: y=qbsynt(c)

y=c ;
[nx ny]=size(c) ;

for i=1:nx,
  y(i,:)=qbsynt(c(i,:)) ;
end ;

for i=1:ny,
  y(:,i)=qbsynt(y(:,i)) ;
end ;
