function c=imsanal(z,deg) ;
% Take each row of a 2D picture z and find proper interpolating 
% B-spline coefficients of degree deg

if deg==3,
  c=imcbanal(z) ;
elseif deg==2,
  c=imqbanal(z) ;
elseif deg==1,  
  c=z ;
else 
  error('Unsupported degree in imsanal.') ;
end ;


  
