function c=lndbicoef(x,z) ;
% Calculate coefficients for bidirectional landmark warping function
% The R^2->R function w is constrained to be z() at points x()
% x contains (x,y) coordinate pair in each row
% Elsewhere, it is a linear combination of r^2 log r 
% basis functions
%
% Returns the coefficients c of w in this basis.
%
% Usage: function c=lndbicoef(x,z) ;

c=[ lndunicoef(x,z(:,1)) lndunicoef(x,z(:,2)) ] ;
