function registerme()
% Registers all my brain slices

call=[] ;

for i=1:30,
  s=spwstruct ; s(11)=1 ; 

  anatpref='/home/jkybic/nirkko/ev-KYBIC-Jan_N2-S_446-052/7651-4-' ;
  anatofs=66 ;
  epipref='/home/jkybic/nirkko/ev-KYBIC-J_MotLI/Ev7652-mean0-' ;
  epiofs=1 ;
  affix='.ima' ;
  i=i-1 ;
  disp([ 'Warping set ' num2str(i+1) ]) ;
  anatname=[ anatpref num2str(i+anatofs) affix ] ;
  epiname=[ epipref num2str(i+epiofs,'%03d') affix ] ;
  anat=loadima(anatname) ; 
  anatp=pyramid2(anat,1) ; anat=anatp{2} ; 
  epi=loadima(epiname) ; 
  subplot(221) ; imagesc(anat) ; colormap(gray) ; title('Anatomical') ;
  subplot(222) ; imagesc(epi) ; colormap(gray) ; title('EPI') ;
  d=0.5+(anat-imhisteq(anat,epi))/2 ;
  subplot(224) ; imagesc(d) ; colormap(gray) ; title('Difference') ;
  pause(0.001) ;
  [c,E]=spwfind(anat,epi,s) ;
  epib=imcbanal(epi) ;
  nr=size(epi,2) ;
  nc=s(2) ; nd=s(3) ;
  epiw=meximwarp(epib,reshape(c,1,nc*nd),nr,nc,s(1)) ;
  subplot(223) ; imagesc(epiw) ; colormap(gray) ; title('Warped') ;
  d=0.5+(anat-imhisteq(anat,epiw))/2 ;
  subplot(224) ; imagesc(d) ; colormap(gray) ; title('Difference') ;
  pause(0.001) ;
  call=[ call ; reshape(c,1,nc*nd) ] ;
  save -ascii registerme.dat call
end ;