function [y,t]=cubicdual(ste,size) ;
% Finds size points spaced step of a cubic spline dual
%
%
% Calculate spline of degree 7 in Fourier domain and show it
[x,t]=fourtotime('(o>0)*sin(o/2)^8/(o/2+(o==0))^8+(o==0)*1',4) ;
% plot(t,x) ; grid on ;
% to calculate values at integer points
h=interp1(t,x,[-4 -3 -2 -1 0 1 2 3 4]) ;

% show the dual of B3
pr=50 ; % precision
denom=[ num2str(h(1),pr) '*exp(j*o*(-4))+'...
        num2str(h(2),pr) '*exp(j*o*(-3))+'...
        num2str(h(3),pr) '*exp(j*o*(-2))+'...
        num2str(h(4),pr) '*exp(-j*o)+'...
        num2str(h(5),pr) '+'...
        num2str(h(6),pr) '*exp(j*o)+'...
        num2str(h(7),pr) '*exp(j*o*2)+'...
        num2str(h(8),pr) '*exp(j*o*3)+'...
        num2str(h(9),pr) '*exp(j*o*4)' ] ;
fb3d=['(sin(o/2)+(o==0))^4/(o/2+(o==0))^4/(' denom ')'] ;

% The function is not exact. To increase precision, increase the support
% parameter and T in fourtotime.m
[y,t]=fourtotime(fb3d,(size+1)*ste/4,2*size+2) ;
y=y(2:length(y)) ; t=t(2:length(t)) ;

% [x,t]=fourtotime(fb3d,8) ;
%figure(1) ; clf ;
%plot(t,x) ; grid on ; zoom on; 
%figure(2) ; clf ;
%showfour(fb3d,10) ;

