function ww=genrandsptrans(nc,nd,nx,ny,amp,lin) ;
%
% Usage: ww=genrandsptrans(nc,nd,nx,ny,amp) ;

if nargin<6, lin=1 ; end ;

c=zeros(nd,nc) ;
step=(nx-1)/(nc-3) ;

for y=1:nd ;
  c(y,:)=lin*linspace(1-step,nx+step,nc)+[ 0 amp*randn(1,nc-2) 0] ;
  c(y,:)=cbanal(c(y,:)) ;
end ;

for x=1:nc,
  c(:,x)=cbanal(c(:,x)')' ;
end ;

c=reshape(c,1,nc*nd) ;
ww=splnwarp21(c,nc,nx,ny) ;



