% Out of search space deformation testing


%wws=genrandsptrans(5,5,128,128,2,1) ;
%wwl=genrandlandtrans(5,5,128,128,5,0) ;
wws=genrandwavtransp(128,128,0.2,5,7,7) ;
wwl=genrandwavtrans(128,128,0.5,5,0) ;
wref=zeros(128) ;
for i=1:128, wref(i,:)=(1:128) ; end ;
resmat=[] ;
nc=7 ; lambda=0 ; order=3 ; 


for i=[ 10:29 0:9], % slices to register
  for alpha=1:-0.1:0,
    alpha
    ww=wws+alpha*wwl ;
    subplot(231) ; contour(ww,20) ; pause(0.01) ;
    anat=getanatim(i) ;
    wanat=imwarptable(anat,ww) ;
    mask=wanat>0.10 ;
    mask=double(bwmorph(mask,'open',10)) ;
    subplot(232) ; imagesc(mask) ;
    subplot(233) ; title('Dif. before') ; imagesc(wanat-anat) ; pause(0.01) ;
    Eb=sum(sum((wanat-anat).^2.*mask)) 
    mdif=(wref-ww).*double(mask) ;
    wib=sum(sum(abs(mdif)))/sum(sum(mask)) 
    cid=cubicprojdd(ww,nc,nc) ;
    xsid=splnwarp21o(reshape(cid,1,nc*nc),nc,128,128,order) ;
    mdifid=(xsid-ww).*double(mask) ;
    wid=sum(sum(abs(mdifid)))/sum(sum(mask)) 
    ranatid=imwarptable(anat,xsid) ;
    Eaid=sum(sum((ranatid-wanat).^2.*mask)) 
    subplot(234) ; title('Dif. projection') ; imagesc(ranatid-wanat) ; 
    pause(0.01) ;
    s=spwstruct ; s(1)=order ; s(2)=nc ; s(3)=nc ; s(11)=2 ; 
    s(14)=1e-5 ; s(15)=1e-20 ;
    s(4)=0 ; s(8)=lambda ;
    c=spwfind(wanat,anat,s) ;
    xs=splnwarp21o(reshape(c,1,nc*nc),nc,128,128,order) ;
    mdif=(xs-ww).*double(mask) ;
    wi=sum(sum(abs(mdif)))/sum(sum(mask)) 
    ranat=imwarptable(anat,xs) ;
    subplot(235) ; title('Warped') ; imagesc(ranat) ; pause(0.01) ;
    subplot(236) ; title('Dif. after') ; imagesc(ranat-wanat) ; pause(0.01) ;
    Ea=sum(sum((ranat-wanat).^2.*mask)) 
    resmat=[ resmat ; i alpha wib wid wi Eb Eaid Ea ] ;
     save -ascii outspdef.dat resmat 
  end ; % alpha
end ;
