% showmultipict

x=[1 1 2 2 3 3 3] ;
y=[1 2 2 3 3 4 5] ;

plot(x,y,'o-') ;
axis([0.5 3.5 0.5 5.5]) ;
set(gca,'XTick',[1 2 3])
set(gca,'YTick',[1 2 3 4 5])
set(gca,'XTickLabel',{ '32' ; '64';'128'})
set(gca,'YTickLabel',{ '128' ;'64';'32';'16';'8'})
title('Multiresolution strategy') ;
xlabel('Image size (N)') ;
ylabel('Knot spacing (h)') ;

print -deps multipict.eps