anatpref='/home/jkybic/nirkko/ev-KYBIC-Jan_N2-S_446-052/7651-4-' ;
anatofs=66 ;
epipref='/home/jkybic/nirkko/ev-KYBIC-J_MotLI/Ev7652-mean0-' ;
epiofs=1 ;
affix='.ima' ;

i=10 ; ncos=2 ; amp=1 ;
figure(1) ; colormap(gray) ; clf ;
  disp([ 'Comparing set ' num2str(i+1) ]) ;
  anatname=[ anatpref num2str(i+anatofs) affix ] ;
  anat=loadima(anatname) ; 
  anatp=pyramid2(anat,1) ; anat=anatp{2} ; 
  nr=size(anat,2) ;
  subplot(231) ; title('Reference') ; imagesc(anat) ; pause(0.01) ;
  ww=genrandctrans(128,128,ncos,amp) ;
  wanat=imwarptable(anat,ww) ;
  subplot(232) ; title('Test') ; imagesc(wanat) ; pause(0.01) ;
  mask=wanat>0.10 ;
  mask=double(bwmorph(mask,'open',10)) ;
  subplot(233) ; title('Mask') ; imagesc(mask) ; pause(0.01) ;
  subplot(234) ; title('Dif. before') ; imagesc(wanat-anat) ; pause(0.01) ;
  
  nc=19 ; order=3 ; lambda=0 ;
  s=spwstruct ; s(1)=order ; s(2)=nc ; s(3)=nc ; s(11)=2 ; 
      s(4)=0 ; s(8)=lambda ; s(14)=0.1 ;
      c=spwfind(wanat,anat,s) ;
   