% Compare meshes

num=9 ;
refnames=cell(num) ; testnames=cell(num) ; 
meshrefnames=cell(num) ; meshtestnames=cell(num) ;
meshjanrefnames=cell(num) ; meshjantestnames=cell(num) ;

refnames{1}='An-tirmPD-017.tiff' ;
testnames{1}='Fu-mean0-017.tiff' ;
meshrefnames{1}='/home/jkybic/nirkko/manual-warp2/meshAn017.s' ;
meshtestnames{1}='/home/jkybic/nirkko/manual-warp2/meshFu017.d' ;
meshjanrefnames{1}='/home/jkybic/nirkko/manual-warp2/meshAn017jan.s' ;
meshjantestnames{1}='/home/jkybic/nirkko/manual-warp2/meshFu017jan.d' ;


refnames{2}='An-tirmPD-018.tiff' ;
testnames{2}='Fu-mean0-018.tiff' ;
meshrefnames{2}='/home/jkybic/nirkko/manual-warp2/meshAn018.s';
meshtestnames{2}='/home/jkybic/nirkko/manual-warp2/meshFu018.d';
meshjanrefnames{2}='/home/jkybic/nirkko/manual-warp2/meshAn018jan.s';
meshjantestnames{2}='/home/jkybic/nirkko/manual-warp2/meshFu018jan.d';

refnames{3}='An-tirmPD-019.tiff' ;
testnames{3}='Fu-mean0-019.tiff' ;
meshrefnames{3}='/home/jkybic/nirkko/manual-warp2/meshAn019.s';
meshtestnames{3}='/home/jkybic/nirkko/manual-warp2/meshFu019.d';
meshjanrefnames{3}='/home/jkybic/nirkko/manual-warp2/meshAn019jan.s';
meshjantestnames{3}='/home/jkybic/nirkko/manual-warp2/meshFu019jan.d';

refnames{4}='An-tirmPD-017.tiff' ;
testnames{4}='Hd-mean0-017.tiff' ;
meshrefnames{4}='/home/jkybic/nirkko/manual-warp2/meshAn017.s';
meshtestnames{4}='/home/jkybic/nirkko/manual-warp2/meshHd017.d';
meshjanrefnames{4}='/home/jkybic/nirkko/manual-warp2/meshAn017jan.s';
meshjantestnames{4}='/home/jkybic/nirkko/manual-warp2/meshHd017jan.d';

refnames{5}='An-tirmPD-018.tiff' ;
testnames{5}='Hd-mean0-018.tiff' ;
meshrefnames{5}='/home/jkybic/nirkko/manual-warp2/meshAn018.s';
meshtestnames{5}='/home/jkybic/nirkko/manual-warp2/meshHd018.d';
meshjanrefnames{5}='/home/jkybic/nirkko/manual-warp2/meshAn018jan.s';
meshjantestnames{5}='/home/jkybic/nirkko/manual-warp2/meshHd018jan.d';

refnames{6}='An-tirmPD-019.tiff' ;
testnames{6}='Hd-mean0-019.tiff' ;
meshrefnames{6}='/home/jkybic/nirkko/manual-warp2/meshAn019.s';
meshtestnames{6}='/home/jkybic/nirkko/manual-warp2/meshHd019.d';
meshjanrefnames{6}='/home/jkybic/nirkko/manual-warp2/meshAn019jan.s';
meshjantestnames{6}='/home/jkybic/nirkko/manual-warp2/meshHd019jan.d';

refnames{7}='An-tirmPD-017.tiff' ;
testnames{7}='Zu-mean0-017.tiff' ;
meshrefnames{7}='/home/jkybic/nirkko/manual-warp2/meshAn017.s';
meshtestnames{7}='/home/jkybic/nirkko/manual-warp2/meshZu017.d';
meshjanrefnames{7}='/home/jkybic/nirkko/manual-warp2/meshAn017jan.s';
meshjantestnames{7}='/home/jkybic/nirkko/manual-warp2/meshZu017jan.d';


refnames{8}='An-tirmPD-018.tiff' ;
testnames{8}='Zu-mean0-018.tiff' ;
meshrefnames{8}='/home/jkybic/nirkko/manual-warp2/meshAn018.s';
meshtestnames{8}='/home/jkybic/nirkko/manual-warp2/meshZu018.d';
meshjanrefnames{8}='/home/jkybic/nirkko/manual-warp2/meshAn018jan.s';
meshjantestnames{8}='/home/jkybic/nirkko/manual-warp2/meshZu018jan.d';

refnames{9}='An-tirmPD-019.tiff' ;
testnames{9}='Zu-mean0-019.tiff' ;
meshrefnames{9}='/home/jkybic/nirkko/manual-warp2/meshAn019.s';
meshtestnames{9}='/home/jkybic/nirkko/manual-warp2/meshZu019.d';
meshjanrefnames{9}='/home/jkybic/nirkko/manual-warp2/meshAn019jan.s';
meshjantestnames{9}='/home/jkybic/nirkko/manual-warp2/meshZu019jan.d';


allc=load([' /home/jkybic/matlab/cmpwithmanual/' 'allc_anfuhdcu']) ;
wi=zeros(9,6) ; % warping indexes
% Create reference unity transform
xr=zeros(512) ; yr=zeros(512) ;
for i=1:512,
  xr(i,:)=1:512 ;
  yr(i,:)=i ;
end ;

i=4 ;
  c=allc(i,:) ;
  img=imread([' /home/jkybic/matlab/cmpwithmanual/' refnames{i} ]) ;
  img=double(img(:,:,1)') ;
  imt=imread([' /home/jkybic/matlab/cmpwithmanual/' testnames{i} ]) ;
  imt=imshift(double(imt(:,:,1)'),-8,0) ;
  % subplot(331) ;imagesc(img) ; title('Image') ;
  [xs,ys]=readxmorphmesh(meshrefnames{i}) ;
  [xd,yd]=readxmorphmesh(meshtestnames{i}) ;
  [xw,yw]=mexxmorphwarp(xs,ys,xd,yd,512,512) ;
  xw=xw+1 ; yw=yw+1 ; % to get to the Matlab coordinate system

  [xjs,yjs]=readxmorphmesh(meshjanrefnames{i}) ;
  [xjd,yjd]=readxmorphmesh(meshjantestnames{i}) ;
  [xj,yj]=mexxmorphwarp(xjs,yjs,xjd,yjd,512,512) ;
  xj=xj+1 ; yj=yj+1 ; % to get to the Matlab coordinate system


  xs=splnwarp21(c*4,7,512,512) ;
  f=0.5 ;
  figure(1) ;
  dispimgwithedges(img,img,f) ; 
      print -depsc /home/jkybic/tex/spregslds/edgesanat.eps

  figure(2) ;
  dispimgwithedges(img,imt,f) ; 
        print -depsc /home/jkybic/tex/spregslds/edgesepi.eps
  ima=imwarptable(imt,xs) ;
  figure(3) ;
  dispimgwithedges(img,ima,f) ;
        print -depsc /home/jkybic/tex/spregslds/edgesauto.eps
  imm=imwarptable(imt,xw) ;
  figure(4) ;
  dispimgwithedges(img,imm,f) ; 
          print -depsc /home/jkybic/tex/spregslds/edgesmanual.eps
  imj=imwarptable(imt,xj) ;

