function sp=odspim(img)
% Calculates 1D spectrum of an image (by summing over all directions)
%
%

[ny,nx]=size(img) ;
nyc=ny/2 ; nxc=nx/2 ;
f=abs(fftshift(fft2(img))) ;

sp=zeros(1,ceil(sqrt((ny/2)^2+(nx/2)^2))+1) ;
for i=1:ny,
  for j=1:nx,
    r=round(sqrt((i-nyc)^2+(j-nxc)^2)) ;
    r=max(1,r) ;
    sp(r)=sp(r)+f(i,j) ;
  end ;
end ;
