clear all ;
h=0.1 ;
t=-2:h:2 ;
N=length(t) ;
yf=zeros(N) ;
yo=zeros(N) ;

for i=1:N,
  x=t(i) ;
  yf(i)=(abs(x/2)-1)^2*(abs(x)+1) ;
  of(i)=(x/2)*(abs(x/2)-1)^2 ;
end ;

figure(1) ;
subplot(211) ; plot(t,yf) ; grid on ;
subplot(212) ; plot(t,of) ; grid on ;

figure(2) ;
yfd=zeros(N) ;
yod=zeros(N) ;

for i=1:N-1,
  x=t(i) ;
  yfd(i)=(yf(i+1)-yf(i))/h ;
  yod(i)=(of(i+1)-of(i))/h ;
end ;

figure(2) ;
subplot(211) ; plot(t,yfd) ; grid on ; title('Deriv') ;
subplot(212) ; plot(t,yod) ; grid on ;
