function dd=derctoderd(dc,d)
% Given derivatives of e with respect to c (dc), calculate derivates
% with respect to d (dd).
%
% function dd=derctoderd(dc,d)

n=length(d) ;

dd=dc ;
dd(1)=sum(dc) ;
dd(2)=2*d(2)*dc(2) ;
for i=3:n-2, dd(i)=2*d(i)*sum(dc(i:n)) ; end ;
dd(n-1)=2*d(n-1)*dc(n-1) ;
dd(n)=2*d(n)*dc(n) ;