function showintsinc(n)
% Show graphically the integral of sinc^n
% 
% Usage: showintsinc(n)

max=40 ; step=0.5 ;

t=1:step:max ;
m=length(t) ;
f=zeros(1,m) ;
for i=1:m,
  f(i)=intsinc(n,t(i))/t(i) ;
end ;

plot(t,f) ;