function y=filfirs(x,w)
%
% M. Unser / BEIP		Jan-93
%
% For symmetric filter only!
% First coeff = center;
%
% JK: The signal may not be too short.
%
% Usage: y=filfirs(x,w)

nx=length(x);            %length of signal
np=2*nx-1;
nx2=2*nx;
if nx==0
  error('Signal length is zero in routine filfirs')
  return
end
nw=length(w);             %length of filter
if nw==0
  error('Filter length is zero in routine filfirs')
  return
end

y=w(1)*x;
for k=1:nx
% y(k)=w(1)*x(k);																			
for i=1:nw-1
   k1=k-i;
   k2=k+i;         
   if (k1<1)
     k1=rem((1-k1),np)+1;
     if (k1>nx) k1=nx2-k1; end
   end  
   if (k2>nx)
     k2=rem((k2-1),np)+1;
     if (k2>nx) k2=nx2-k2; end
   end
   y(k)=y(k)+(x(k1)+x(k2))*w(i+1);
 end
end
