/************************************************************************/
/* Public implementation follows										*/
/************************************************************************/

/*--- Defines ----------------------------------------------------------*/
/* None */

/*--- Types ------------------------------------------------------------*/
/* None */

/*--- Functions --------------------------------------------------------*/

extern	void		firConvolveFinite
									(double				*inPtr,
									 double				*outPtr,
									 long				n,
									 long				shift,
									 double				*kernel,
									 long				nk);
extern	void		firConvolveMirror
									(double				*inPtr,
									 double				*outPtr,
									 long				n,
									 long				shift,
									 double				*kernel,
									 long				nk);
extern	void		firConvolvePeriodic
									(double				*inPtr,
									 double				*outPtr,
									 long				n,
									 long				shift,
									 double				*kernel,
									 long				nk);
extern	void		iirConvolveFinite
									(double				*inPtr,
									 double				*outPtr,
									 long				n,
									 double				gain,
									 double				*realPoles,
									 long				np);
extern	void		iirConvolveMirror
									(double				*inPtr,
									 double				*outPtr,
									 long				n,
									 double				gain,
									 double				*realPoles,
									 long				np);
extern	void		iirConvolvePeriodic
									(double				*inPtr,
									 double				*outPtr,
									 long				n,
									 double				gain,
									 double				*realPoles,
									 long				np);
extern	void		manyConvolveFourier
									(double				*data,
									 double				*kernelDht,
									 double				*CaS,
									 double				*tmp,
									 long				n,
									 double				shift);
extern	void		manyConvolveFourierSymmetricKernel
									(double				*data,
									 double				*symmetricKernelDht,
									 double				*CaS,
									 double				*tmp,
									 long				n,
									 double				shift);
extern	int			oneConvolveFourier
									(double				*data,
									 double				*kernel,
									 long				n,
									 double				shift);
extern	int			oneConvolveFourierSymmetricKernel
									(double				*data,
									 double				*symmetricKernel,
									 long				n,
									 double				shift);

/************************************************************************/
/* Externals															*/
/*----------------------------------------------------------------------*/
/* dft.c																*/
/* dht.c																*/
/************************************************************************/

/* dht.c */
extern	void		dht				(double				*data,
									 double				*tmp,
									 double				*CaS,
									 long				n,
									 int				forward);

/* dft.c */
extern	void		getCaS			(double				*CaS,
									 long				n);
