function E=secder(w)
% Given a (2D->1D) displacement field w, estimate mean square of the 
% second derivative along x


% Not using B-spline space due to boundary  problems
% c=imcbanal(w) ;
c=w ;
E=0 ;
[ny,nx]=size(w) ;
for i=1:ny,
  q=conv([1 -2 1]/4,c(i,:)).^2 ; E=E+sum(q(2:nx-2))  ;
end ;

% E=E/(nx-4)/ny ; % normalization across size
% E=E/nx^2 ;  % normalization because of scaling of w

