function s=szpack(sx,sy) 
% Part of the implementation of the Szelinski-Coughlan registration algorithm
% Given the displacement arrays sx,sy, pack
% sx,sy into s
%
% Jan Kybic, February 1999
%
% Usage: s=szpack(sx,sy) 

[ny,nx]=size(sx) ;
sx=reshape(sx,1,nx*ny) ;
sy=reshape(sy,1,nx*ny) ;
s=reshape([sx ; sy],2*nx*ny,1) ;


