if 0,
  fr=zeros(20,20) ; ft=fr ;
  fr(5,3:7)=[ 1 2 3 2 1 ] ; 
  ft(6,4:6)=[ 2 3 2 ] ;
  m=3 ; t=3 ;

  % [E,s]=szopt(fr,ft,m,t) ;
  [E,s]=szpyr(fr,ft,m,t,3) ;
  [ny,nx]=size(fr) ;
  nsx=floor((nx-2)/m)+1 ; % size of the control grid
  nsy=floor((ny-2)/m)+1 ; 
  [sx,sy]=szunpack(s,nsx,nsy) ;
  [ux,uy]=szdispd(sx,sy,nx,ny,m,t) ;
  fw=imwarp2table(ft,ux,uy,'linear') ;
  sum(sum((fw-fr).^2)) 
else  
  
  clear all ; clf ;
  fr=zeros(10,10) ; ft=fr ;
  for i=3:8,
    for j=3:8,
      fr(i,j)=1/(1+((i-5)^2+(j-5)^2)^2) ;
      ft(i,j)=1/(1+((i-5.01)^2+(j-5)^2)^2) ;
    end ;
  end ;
  
%  fr=eye(3) ; ft=fr(3:-1:1,:)  ; ft(2,1)=0.1 ;
  
  subplot(221) ;imagesc(fr) ; colormap(hot) ; colorbar ; axis image ;
  subplot(222) ;imagesc(ft) ; colormap(hot) ; colorbar ; axis image ;
  subplot(223) ;imagesc(abs(fr-ft)) ; colormap(hot) ; colorbar ; axis image ;
  sum(sum((ft-fr).^2)) 
  
  if 1,  
    % Szelinski and Coughlan
    m=4 ; t=4 ;
    %  [E,s]=szpyr(fr,ft,m,t,1) ;
    % [E,s]=szoptgr(fr,ft,m,t) ; % my version of the gradient descent
    [E,s]=szopt(fr,ft,m,t) ; 
    [ny,nx]=size(fr) ;
    nsx=floor((nx-2)/m)+1 ; % size of the control grid
    nsy=floor((ny-2)/m)+1 ; 
    [sx,sy]=szunpack(s,nsx,nsy) ;
    [ux,uy]=szdispd(sx,sy,nx,ny,m,t) ;
    fw=imwarp2table(ft,ux,uy,'linear') ;
  else
    % my algorithm
    nr=10 ; nca=4 ; nda=4 ; ny=10 ;
    cr=clincf(1,nr) ;
    c=zeros(4,4) ;
    c(:,1)=clincf(cr(1),cr(1)) ;
    c(:,2)=clincf(cr(2),cr(2)) ;
    c(:,3)=clincf(cr(3),cr(3)) ;
    c(:,4)=clincf(cr(4),cr(4)) ;
    dr=clincf(1,ny) ;
    d=zeros(4,4) ;
    d(1,:)=clincf(dr(1),dr(1))' ;
    d(2,:)=clincf(dr(2),dr(2))' ;
    d(3,:)=clincf(dr(3),dr(3))' ;
    d(4,:)=clincf(dr(4),dr(4))' ;
    c=reshape(c,1,nca*nda) ;
    d=reshape(d,1,nca*nda) ;
    c=[c d] ;
    [c,E]=imwarpoptdi(fr,ft,nca,nda,c,3) ;
    ftb=imcbanal(imcbanal(ft)')' ;
    fw=meximwarpdc(ftb,c,nca,nr,ny) ;

  end ;
  
    sum(sum((fw-fr).^2)) 
    subplot(224) ;imagesc(abs(fw-fr)) ; colormap(hot) ; colorbar ; axis image ;
  end ;
  