% Compares my results and Philippe's

num=4 ;
refnames=cell(num) ; testnames=cell(num) ;
reglsnames=cell(num) ; regminames=cell(num) ;


refnames{1}='refPreprocKPStdPD.img' ;
refnames{2}='refPreprocKStdPD.img' ;
refnames{3}='refPreprocPStdPD.img' ;
refnames{4}='refStdPD.img' ;

testnames{1}='tstPreprocKPStdEv.img' ;
testnames{2}='tstPreprocKStdEv.img' ;
testnames{3}='tstPreprocPStdEv.img' ;
testnames{4}='tstStdEv.img' ;

reglsnames{1}='regLSpreprocKPStdEv.img' ;
reglsnames{2}='regLSpreprocKStdEv.img' ;
reglsnames{3}='regLSpreprocPStdEv.img' ;
reglsnames{4}='regLSstdEv.img' ;

regminames{1}='regMIpreprocKPStdEv.img' ; 
regminames{2}='regMIpreprocKStdEv.img' ;
regminames{3}='regMIpreprocPStdEv.img' ;
regminames{4}='regMIstdEv.img' ;

prefix='../../people/philippe/reg/' ;

for i=1:num,
  disp([ 'Comparing for ' refnames{i} ]) ;
  figure(1) ; 
  ref=loadimg([ prefix refnames{i} ]) ; 
  subplot(221) ; imagesc(64*ref) ; title('Reference') ;
  colormap('jet') ;
  test=loadimg([ prefix testnames{i} ]) ; 
  subplot(222) ; imagesc(64*test) ; title('Test') ;  colormap('jet') ;
  regmi=loadimg([ prefix regminames{i} ]) ; 
  subplot(223) ; imagesc(64*regmi) ; title('Warped MI') ;  colormap('jet') ;
  regls=loadimg([ prefix reglsnames{i} ]) ; 
  subplot(224) ; imagesc(64*regls) ; title('Warped LS') ;  colormap('jet') ;
  disp([ 'Initial mean square difference ' num2str(msd(ref,test)) ]) ;
  disp([ 'for LS ... ' num2str(msd(ref,regls)) ]) ;
  disp([ 'for MI ... ' num2str(msd(ref,regmi)) ]) ;
  figure(2) ;
  regnl=testregister(ref,test) ;
  disp([ 'for nonlinear ... ' num2str(msd(ref,regnl)) ]) ;
  disp('Press any key') ;
  pause ;
  end ;