% Calculate warp index and show statistics

nc=4 ; nd=4 ; % nodes
f=2 ;           % dispersion
cmsf=64 ; 
nmr='015' ;

N=100 ; % Number of repetitions
wi=zeros(1,N) ;

% testim=loadima([ '../images/EvStd-mean0-' nmr '.ima']) ;
% load circleimage ;
% testim=ti ;
load brainimage ;

testc=imcbanal(testim) ;
[ny nx]=size(testim) ;

for i=1:N,
  disp([ 'Iteration number ' num2str(i)]) ;
  % generate random transformation
  c=genrandc(nc,nd,nx,f) ;
  % generate reference image
  refim=meximwarpbddh(testc,c,nx,nc) ;
  
  % register
  nl=min(log(length(refim)),log(length(testim)))/log(2)-4 ;
  nl=floor(max(nl,0)) ;
  refp=pyramid2(refim,nl) ;
  testp=pyramid2(testim,nl) ;
  % figure(1) ;
  % dispwf(c,nc) ; title('real') ; pause(0.01) ;
  % figure(2) ;
  ce=pimwarpoptbddh(refp,testp,nc,nd) ;
  % figure(3) ;
  % dispwf(ce,nc) ; title('obtained') ;
  
  imh=meximwarpbddh(testc,ce,nx,nc) ;
  
  % figure(2) ;
  % image(cmsf*refim) ; title('reference') ; colorbar ; grid on ;
  % colormap(jet) ;
  % subplot(222) ;
  % image(cmsf*testim) ; title('test') ; colorbar ; grid on ;
  % subplot(223) ;
  % image(cmsf*imh) ; title('warped') ; colorbar ; grid on ;
  % subplot(224) ;
  % image(cmsf*0.5+cmsf*(imh-refim)/2) ; title('difference') ; colorbar ; grid on ;

  w=warpindex(c,ce,nc,nx,ny,testim) 
  wi(i)=w ;
end ;

  