% Just a few remarks on how to show coloured edges

href=edge(refim,'canny',0.3) ; imagesc(href)
hwarp=edge(warped,'canny',0.3) ; imagesc(hwarp)      
colormap([1 1 1;1 0 0;0 0 1;1 0 1])
image(double(hwarp)+2*double(href)+1)
grid on

% try enlarge and superspose edges
[X,Y]=meshgrid(1:128) ;                                           
[X1,Y1]=meshgrid(1:0.125:128) ;
bigref=interp2(X,Y,refim,X1,Y1,'*spline') ;                        
hbigref=edge(bigref,'canny',0.3) ; imagesc(hbigref) ;
bigwarp=interp2(X,Y,imh,X1,Y1,'*spline') ; imagesc(bigwarp)  
bigfluid=interp2(X,Y,fluid,X1,Y1,'*spline') ; imagesc(bigfluid)
colormap([ (0:63)'*[1 1 1]/63 ; [1 0 0] ]) 
  
bigfluid=bigfluid-min(min(bigfluid)) ;
bigfluid=bigfluid/max(max(bigfluid)) ;
image(1+62-62*bigfluid+64*double(hbigref)) ;

subplot(211) ;                            
bigwarp=bigwarp-min(min(bigwarp)) ;       
bigwarp=bigwarp/max(max(bigwarp)) ;
image(1+62-62*bigwarp+64*double(hbigref)) 
title('Splines') ;

% Superposing gradient
rf=refim ; rf=rf-min(min(rf)) ; rf=rf/max(max(rf)) ;
image(rf*63+1)              
lp=filter2(fspecial('laplacian'),rf) ;                         
lp=abs(lp) ; imagesc(lp)