function e=imwarpdif(g,fr,ft)
% Given a reference image fr, test image ft and warp coefficients g,
% calculate differences between the reference image and warped test image

fr=fr(:)' ;
fwt=imwarp(ft,g,length(fr)) ;
e=fr-fwt ;

% Penalty
d=[g 0]-[0 g] ;
dl=length(d) ;
d=d(2:dl-1) ;
d=min(d,zeros(1,dl-2)) ;
de=sum(d.^2) 
e=e+1000*de ;
